/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { AverageTrueRangeIndicatorStrategy } from "./AverageTrueRangeIndicatorStrategy";
import { typeGetValue, markType } from "./type";
export class AverageTrueRangeIndicator extends StrategyBasedIndicator {
    get_pp() {
        return new AverageTrueRangeIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return AverageTrueRangeIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get qa() {
        return typeGetValue(this.c(AverageTrueRangeIndicator.qb));
    }
    set qa(a) {
        this.h(AverageTrueRangeIndicator.qb, a);
    }
    pv() {
        return this.qa;
    }
    p4(a) {
        this.qa = a;
    }
}
AverageTrueRangeIndicator.qb = StrategyBasedIndicator.p7(14, AverageTrueRangeIndicator.$);
AverageTrueRangeIndicator.$t = markType(AverageTrueRangeIndicator, 'AverageTrueRangeIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.AverageTrueRangeIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AverageTrueRangeIndicator" />*/
//# sourceMappingURL=AverageTrueRangeIndicator.js.map