/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ChaikinVolatilityIndicatorStrategy } from "./ChaikinVolatilityIndicatorStrategy";
import { typeGetValue, markType } from "./type";
export class ChaikinVolatilityIndicator extends StrategyBasedIndicator {
    get_pp() {
        return new ChaikinVolatilityIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return ChaikinVolatilityIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get qa() {
        return typeGetValue(this.c(ChaikinVolatilityIndicator.qb));
    }
    set qa(a) {
        this.h(ChaikinVolatilityIndicator.qb, a);
    }
    pv() {
        return this.qa;
    }
    p4(a) {
        this.qa = a;
    }
}
ChaikinVolatilityIndicator.qb = StrategyBasedIndicator.p7(10, ChaikinVolatilityIndicator.$);
ChaikinVolatilityIndicator.$t = markType(ChaikinVolatilityIndicator, 'ChaikinVolatilityIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.ChaikinVolatilityIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.ChaikinVolatilityIndicator" />*/
//# sourceMappingURL=ChaikinVolatilityIndicator.js.map