/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DependencyObject } from "./DependencyObject";
import { INotifyPropertyChanged_$type, PropertyChangedEventArgs, Type, markType } from "./type";
import { Style } from "./Style";
import { DependencyProperty } from "./DependencyProperty";
import { PropertyUpdatedEventArgs } from "./PropertyUpdatedEventArgs";
import { PropertyMetadata } from "./PropertyMetadata";
export class ErrorBarSettingsBase extends DependencyObject {
    constructor() {
        super();
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.n = new Style();
    }
    l(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
}
ErrorBarSettingsBase.$t = markType(ErrorBarSettingsBase, 'ErrorBarSettingsBase', DependencyObject.$, [INotifyPropertyChanged_$type]);
Type.dep(DependencyProperty, PropertyMetadata, ErrorBarSettingsBase, 'l', ['DefaultErrorBarStyle:n:m', [Style.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.ErrorBarSettingsBase" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.ErrorBarSettingsBase" />*/
//# sourceMappingURL=ErrorBarSettingsBase.js.map