/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IFinancialPriceSeriesProxy_$type } from "./IFinancialPriceSeriesProxy";
import { Base, markType, getInstanceType } from "./type";
import { stringEndsWith } from "./string";
export class FinancialPriceSeriesProxy extends Base {
    getCloseMemberPath(a) {
        return a.no;
    }
    getHighMemberPath(a) {
        return a.nr;
    }
    getLowMemberPath(a) {
        return a.nw;
    }
    getOpenMemberPath(a) {
        return a.n0;
    }
    getVolumeMemberPath(a) {
        return a.n4;
    }
    matchesType(a) {
        if (!a.cp) {
            return false;
        }
        if (stringEndsWith(getInstanceType(a).typeName, "Indicator") || stringEndsWith(getInstanceType(a).typeName, "Overlay")) {
            return false;
        }
        return true;
    }
    setCategoryMode(a, b) {
        a.lu = b;
    }
    setCloseMemberPath(a, b) {
        a.no = b;
    }
    setDisplayType(a, b) {
        a.ox = b;
    }
    setHighMemberPath(a, b) {
        a.nr = b;
    }
    setLowMemberPath(a, b) {
        a.nw = b;
    }
    setOpenMemberPath(a, b) {
        a.n0 = b;
    }
    setVolumeMemberPath(a, b) {
        a.n4 = b;
    }
    setXAxis(a, b) {
        a.ln = b;
    }
    setYAxis(a, b) {
        a.l7 = b;
    }
}
FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);
//# sourceMappingURL=FinancialPriceSeriesProxy.js.map