/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "./DependencyProperty";
import { List$1 } from "./List$1";
import { Type, Number_$type, typeCast, runOn, markType, Point_$type, fromEnum } from "./type";
import { CategoryFrame } from "./CategoryFrame";
import { MathUtil } from "./MathUtil";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "./Polyline";
import { Polygon } from "./Polygon";
import { RangeValueList } from "./RangeValueList";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_, isInfinity } from "./number";
import { Flattener } from "./Flattener";
export class PriceChannelOverlay extends FinancialOverlay {
    constructor() {
        super();
        this.o2 = new List$1(Number_$type, 0);
        this.o1 = new List$1(Number_$type, 0);
        this.ab = PriceChannelOverlay.$;
        this.lq = new CategoryFrame(3);
        this.ls = new CategoryFrame(3);
        this.lp = new CategoryFrame(3);
    }
    ie(a, b, c, d) {
        switch (b) {
            case "HighColumn":
            case "LowColumn":
                this.ov = false;
                break;
        }
        super.ie(a, b, c, d);
        switch (b) {
            case PriceChannelOverlay.$$p[0]:
                this.ov = false;
                this.it(false);
                break;
        }
    }
    ds(a, b, c) {
        let d = super.ds(a, b, c);
        if (this.mb == null || this.md == null) {
            d = false;
        }
        return d;
    }
    ow() {
        this.o2.clear();
        this.o1.clear();
        let a = truncate(MathUtil.b(this.o3, 0, this.by.count));
        let b = Math.min(this.mb.count, this.md.count);
        let c = this.m5(this.mb);
        let d = this.m5(this.md);
        for (let e = 0; e < b; e++) {
            let f = Math.min(a, e);
            let g = -1.7976931348623157E+308;
            let h = 1.7976931348623157E+308;
            for (let i = 0; i < f; i++) {
                if (!isNaN_(c.item(e - i))) {
                    g = Math.max(g, c.item(e - i));
                }
                if (!isNaN_(d.item(e - i))) {
                    h = Math.min(h, d.item(e - i));
                }
            }
            if (e == 0) {
                h = d.item(0);
                g = c.item(0);
            }
            this.o2.add(g);
            this.o1.add(h);
        }
        return true;
    }
    ob(a, b) {
        super.ob(a, b);
        let c = b.bq;
        let d = b.bp;
        let e = this.getEffectiveViewport1(b);
        let f = new ScalerParams(0, c, d, this.ln.bz, e);
        let g = new ScalerParams(0, c, d, this.l7.bz, e);
        let h = this.ln;
        let i = this.l7;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = 0;
        let k = typeCast(ISortingAxis_$type, this.ln);
        if (k != null && k.i$b.count != this.by.count) {
            return;
        }
        j = this.nc(c, d, e);
        if (!this.ov) {
            this.ov = this.ow();
        }
        g.b = this.d8();
        let l = this.ln.dm(2, f) - this.ln.dm(1, f);
        for (let m = b.bs.c; m <= b.bs.d; ++m) {
            let n;
            if (k == null) {
                n = b.bs.getBucket(m);
            }
            else {
                let o = k.i$b._inner[m];
                let p = k.i$d(o);
                let q = this.o2._inner[m];
                let r = this.o1._inner[m];
                let s = q;
                let t = r;
                let u = p;
                while (m < b.bs.d) {
                    o = k.i$b._inner[m + 1];
                    u = k.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s = Math.max(q, this.o2._inner[m]);
                    t = Math.min(r, this.o1._inner[m]);
                }
                if (!isInfinity(t) && !isInfinity(s)) {
                    let v = NaN;
                    if (!isNaN_(p)) {
                        v = this.ln.dj(p, f);
                    }
                    n = [v, t, s];
                }
                else {
                    n = [NaN, NaN, NaN];
                }
            }
            let w = Math.max(1, l);
            if (!isNaN_(n[0]) && m * w >= this.ox) {
                if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
                    n[0] = n[0] + j;
                }
                else {
                    n[0] = h.dj(n[0], f) + j;
                }
                n[1] = i.dj(n[1], g);
                n[2] = i.dj(n[2], g);
                a.f.add(n);
            }
        }
    }
    he(a, b) {
        super.he(a, b);
        let c = b;
        if (c != null) {
            c.bz();
        }
    }
    od(a, b) {
        super.od(a, b);
        let c = typeCast(PriceChannelOverlayView.$, b);
        if (c == null) {
            return;
        }
        let d = this.getEffectiveViewport1(b);
        if (b.bv(a)) {
            c.bz();
            let e = a.f.count;
            let f = (g) => a.f._inner[g][0];
            let g = (h) => a.f._inner[e - 1 - h][0];
            let h = (i) => a.f._inner[i][1];
            let i = (j) => a.f._inner[e - 1 - j][2];
            c.b0(e, f, g, h, i);
            b.bx(a);
        }
        this.lv.x(this, this.mt(), this.ln, runOn(this, this.lf), this.ni(b), this.nj(b));
        let j = false;
        let k = this.lv.c;
        let l = a.f;
        let m = this.by.count;
        if (k != null) {
            j = true;
        }
        if (j) {
            let n = new ScalerParams(0, b.bq, b.bp, this.ln.bz, d);
            this.oa(l, -1, m, this.ln, n, b.n);
        }
        let o = c.b6;
        let p = c.b7;
        let q = c.b2;
        this.lv.ae(o, true, false, true, true);
        this.lv.ae(p, true, false, true, true);
        this.lv.ae(q, false, true, false, false);
        q._opacity = this.lv.i * this.dy;
    }
    be() {
        return new PriceChannelOverlayView(this);
    }
    h9(a) {
        super.h9(a);
        this.o0 = typeCast(PriceChannelOverlayView.$, a);
    }
    ed(a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bh);
        let e = new ScalerParams(0, this.br.mk, this.bh.bp, this.ln.bz, d);
        let f = this.nc(this.br.mk, this.bh.bp, d);
        return this.ef(new RangeValueList(this.o2, this.o1), a, this.ln, e, f, runOn(this, this.nb), b, c);
    }
    e1(a, b) {
        if (this.o2 == null || this.o1 == null) {
            return super.e1(a, b);
        }
        return this.e2(a, b, this.ln, runOn(this, this.nb), new RangeValueList(this.o2, this.o1));
    }
    e3(a, b) {
        if (this.o2 == null || this.o1 == null) {
            return super.e3(a, b);
        }
        return this.e4(a, b, this.ln, runOn(this, this.nb), new RangeValueList(this.o2, this.o1));
    }
    d8() {
        return this.o1 == null || this.o1.count == 0 ? NaN : this.o1._inner[0];
    }
}
PriceChannelOverlay.$t = markType(PriceChannelOverlay, 'PriceChannelOverlay', FinancialOverlay.$);
Type.dep(DependencyProperty, PropertyMetadata, PriceChannelOverlay, 'raisePropertyChanged', ['Period:o3:o5', [1, 14]]);
export class PriceChannelBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.a.bu.by.count - 1);
        if (b <= c) {
            let d = -1.7976931348623157E+308;
            let e = 1.7976931348623157E+308;
            let f = 0;
            for (let g = b; g <= c; ++g) {
                if (!isNaN_(this.f.by.o2._inner[g]) && !isNaN_(this.f.by.o1._inner[g])) {
                    d = Math.max(d, this.f.by.o2._inner[g]);
                    e = Math.min(e, this.f.by.o1._inner[g]);
                    ++f;
                }
            }
            if (f > 0 && e != 1.7976931348623157E+308 && d != -1.7976931348623157E+308) {
                return [0.5 * (b + c), e, d];
            }
        }
        return [NaN, NaN, NaN];
    }
}
PriceChannelBucketCalculator.$t = markType(PriceChannelBucketCalculator, 'PriceChannelBucketCalculator', FinancialBucketCalculator.$);
export class PriceChannelOverlayView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b3 = new Polygon();
        this.b8 = new Polyline();
        this.b9 = new Polyline();
        this.by = null;
        this.b1 = new Polygon();
        this.b4 = new Polyline();
        this.b5 = new Polyline();
        this.by = a;
    }
    get b2() {
        return this.b3;
    }
    get b6() {
        return this.b8;
    }
    get b7() {
        return this.b9;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bi = 1;
        }
    }
    bt() {
        return new PriceChannelBucketCalculator(this);
    }
    bz() {
        this.b3.aj.clear();
        this.b8.aj.clear();
        this.b9.aj.clear();
        this.an();
    }
    b0(a, b, c, d, e) {
        for (let f of fromEnum(Flattener.d(a, b, d, this.e.ej))) {
            this.b3.aj.add({ $type: Point_$type, x: b(f), y: d(f) });
            this.b8.aj.add({ $type: Point_$type, x: b(f), y: d(f) });
        }
        for (let g of fromEnum(Flattener.d(a, c, e, this.e.ej))) {
            this.b3.aj.add({ $type: Point_$type, x: c(g), y: e(g) });
            this.b9.aj.add({ $type: Point_$type, x: c(g), y: e(g) });
        }
        this.an();
    }
    a9() {
        super.a9();
        this.b1.aj = this.b3.aj;
        this.b4.aj = this.b8.aj;
        this.b5.aj = this.b9.aj;
        let a = this.bk();
        this.b1._fill = a;
        this.b1._opacity = 1;
        this.b4._stroke = a;
        this.b4.ac = this.e.en + 3;
        this.b5._stroke = a;
        this.b5.ac = this.e.en + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.t(this.b1);
                a.u(this.b4);
                a.u(this.b5);
            }
            else {
                a.t(this.b3);
                a.u(this.b8);
                a.u(this.b9);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a1.exportPolygonData(a, this.b3, "fill", ["Fill"]);
        this.e.a1.exportPolylineData(a, this.b8, "bottom", ["Lower", "Main"]);
        this.e.a1.exportPolylineData(a, this.b9, "top", ["Upper"]);
    }
}
PriceChannelOverlayView.$t = markType(PriceChannelOverlayView, 'PriceChannelOverlayView', FinancialSeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.PriceChannelOverlay" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.PriceChannelOverlay" />*/
//# sourceMappingURL=PriceChannelOverlay_combined.js.map