import { HorizontalRangeCategorySeries } from "./HorizontalRangeCategorySeries";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "./type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "./List$1";
import { Polyline } from "./Polyline";
import { Polygon } from "./Polygon";
import { RangeCategorySeriesView } from "./RangeCategorySeriesView";
import { RenderingContext } from "./RenderingContext";
export declare class RangeAreaSeries extends HorizontalRangeCategorySeries {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    oz: RangeAreaSeriesView;
    protected get_ci(): boolean;
    readonly ci: boolean;
    protected o0(a: Point, b: Point, c: Point, d: boolean): boolean;
    dd(a: Point, b: boolean): boolean;
    constructor();
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    he(a: boolean, b: SeriesView): void;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    readonly useHighMarkerFidelity: boolean;
    static $t: Type;
}
export declare class RangeAreaSeriesView extends RangeCategorySeriesView {
    protected cw: RangeAreaSeries;
    constructor(a: RangeAreaSeries);
    ap(): void;
    private c4;
    private c0;
    private c6;
    readonly c5: Polyline;
    readonly c1: Polygon;
    readonly c7: Polyline;
    cx(): void;
    cy(a: number, b: List$1<number[]>, c: boolean): void;
    private c3;
    private c2;
    private cz;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
