import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { SplineType } from "./SplineType";
import { SeriesView } from "./SeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { Rect } from "./Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategorySeriesView } from "./CategorySeriesView";
import { CollisionAvoider } from "./CollisionAvoider";
import { List$1 } from "./List$1";
import { Point, IList$1, Type } from "./type";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { FastItemsSourceEventAction } from "./FastItemsSourceEventAction";
export declare abstract class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    px: SplineSeriesBaseView;
    protected get_ci(): boolean;
    readonly ci: boolean;
    protected pw: number[];
    p3(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericAxisBase, f: CategorySeriesView): void;
    pz(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    ai(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    nz(a: CategoryFrame, b: CategorySeriesView): void;
    private p0(a, b, c, d, e, f, g);
    d6(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    p1(a: CategoryAxisBase, b: Rect, c: Rect, d: Rect): number;
    py: SplineType;
    protected p4(): void;
    protected ie(a: any, b: string, c: any, d: any): void;
    protected hh(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class SplineSeriesBaseView extends AnchoredCategorySeriesView {
    protected c4: SplineSeriesBase;
    constructor(a: SplineSeriesBase);
    protected ac(): void;
    static $t: Type;
}
