/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { typeCast, Array_$type, runOn, markType } from "./type";
import { ISortingAxis_$type } from "./ISortingAxis";
import { List$1 } from "./List$1";
import { Path } from "./Path";
import { ScalerParams } from "./ScalerParams";
import { intDivide, isNaN_ } from "./number";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
export class StepAreaSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.pw = null;
        this.pw = new CategoryLineRasterizer();
        this.ab = StepAreaSeries.$;
    }
    be() {
        return new StepAreaSeriesView(this);
    }
    h9(a) {
        super.h9(a);
        this.px = a;
    }
    get_ci() {
        return true;
    }
    get ci() {
        return this.get_ci();
    }
    preferredCategoryMode(a) {
        return typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
    }
    he(a, b) {
        super.he(a, b);
        let c = b;
        c.c5();
    }
    py(a, b, c, d, e) {
        if (b) {
            if (e) {
                if ((a & 1) == 0 || ((intDivide(a, 2)) + 1) >= c.f.count) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                return c.f._inner[(intDivide(a, 2)) + 1][0];
            }
            return c.f._inner[(intDivide(a, 2))][0] + ((a & 1) == 1 ? -d : d);
        }
        if (e) {
            if ((a & 1) == 0 || ((intDivide(a, 2)) + 1) >= c.f.count) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            return c.f._inner[(intDivide(a, 2)) + 1][0];
        }
        return c.f._inner[(intDivide(a, 2))][0] + ((a & 1) == 0 ? -d : d);
    }
    mv() {
        return 1;
    }
    d6(a, b, c, d, e, f, g, h) {
        let i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        let j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        if (a > 0.5) {
            return j;
        }
        return i;
    }
    bc() {
        if (this.bd == 0) {
            return 2;
        }
        else {
            return super.bc();
        }
    }
    n2(a, b) {
        super.n2(a, b);
        let c = b.bq;
        let d = b.bp;
        let e = this.getEffectiveViewport1(b);
        let f = typeCast(ISortingAxis_$type, this.pd) != null;
        let g = this.pd != null ? 0.5 * this.pd.getCategorySize(c, d, e) : 0;
        if (this.pd != null && this.pd.bz) {
            g = -g;
        }
        let h = a.f.count * 2;
        let i = new List$1(Array_$type, 2, h);
        this.mt.x(this, this.ne(), this.pd, runOn(this, this.mf), this.nm(b), this.nn(b));
        let j = false;
        let k = this.mt.c;
        if (k != null) {
            j = true;
        }
        for (let l = 0; l < h; l++) {
            let m = new Array(4);
            m[0] = this.py(l, false, a, g, f);
            m[1] = a.f._inner[(intDivide(l, 2))][1];
            m[2] = this.py(l, true, a, g, f);
            m[3] = a.f._inner[(intDivide(l, 2))][2];
            i.add(m);
        }
        let n = this.mu.cl.d;
        if (j) {
            let o = new ScalerParams(0, b.bq, b.bp, this.pd.bz, e);
            this.ny(i, -1, this.valueColumn.count, this.pd, o, b.n);
        }
        let p = typeCast(StepAreaSeriesView.$, b);
        let q = p.dh;
        let r = p.dj;
        let s = p.dd;
        let t = p.df;
        this.mt.ae(q, true, false, true, true);
        this.mt.ae(r, true, false, true, true);
        this.mt.ae(s, false, true, false, false);
        this.mt.ae(t, false, true, false, false);
        if (b.cp(a)) {
            p.c7(h, i, false, n, this.ej, (u, v, w, x, y) => this.oy(u, 2 * a.f.count, b), 1, this.od(i, i.count - 1, b.bp, b.bq, true));
            b.cs(a);
        }
        let u = this.fetchYAxis();
        p.dd._opacity = this.dy;
        p.df._opacity = 0.5 * this.dy;
    }
    get currentCategoryMode() {
        return this.preferredCategoryMode(this.pd);
    }
    get useHighMarkerFidelity() {
        return this.nh;
    }
}
StepAreaSeries.$t = markType(StepAreaSeries, 'StepAreaSeries', HorizontalAnchoredCategorySeries.$, [IIsCategoryBased_$type]);
export class StepAreaSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c4 = null;
        this.dc = new Path();
        this.dg = new Path();
        this.de = new Path();
        this.di = new Path();
        this.c8 = new Path();
        this.da = new Path();
        this.c9 = new Path();
        this.db = new Path();
        this.c4 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bi = 1;
        }
    }
    get dd() {
        return this.dc;
    }
    get dh() {
        return this.dg;
    }
    get df() {
        return this.de;
    }
    get dj() {
        return this.di;
    }
    c5() {
        this.dc.aj = null;
        this.de.aj = null;
        this.dg.aj = null;
        this.di.aj = null;
        this.an();
    }
    c6(a, b, c, d, e, f, g) {
        this.c6(a, b, c, d, e, f, g);
    }
    c7(a, b, c, d, e, f, g, h) {
        this.c4.pw.a = typeCast(ISortingAxis_$type, this.cn.fetchXAxis()) !== null ? true : false;
        this.c4.pw.j(this.dc, this.dg, this.de, this.di, a, b, c, d, e, f, g, h);
        this.an();
    }
    a9() {
        super.a9();
        this.c8.aj = this.dc.aj;
        this.da.aj = this.dg.aj;
        this.c9.aj = this.de.aj;
        this.db.aj = this.di.aj;
        let a = this.bk();
        this.c8._fill = a;
        this.c8._opacity = 1;
        this.c9._fill = a;
        this.c9._opacity = 1;
        this.da._stroke = a;
        this.da.ac = this.e.en + 3;
        this.db._stroke = a;
        this.db.ac = this.e.en + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            a.s(this.c8);
            a.s(this.c9);
            a.s(this.da);
            a.s(this.db);
        }
        else {
            a.s(this.dc);
            a.s(this.de);
            a.s(this.dg);
            a.s(this.di);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a1.exportPathData(a, this.dg, "lowerShape", ["Lower"]);
        this.e.a1.exportPathData(a, this.di, "upperShape", ["Upper", "Main"]);
        this.e.a1.exportPathData(a, this.de, "translucentShape", ["Translucent"]);
        this.e.a1.exportPathData(a, this.dc, "fillShape", ["Fill"]);
    }
}
StepAreaSeriesView.$t = markType(StepAreaSeriesView, 'StepAreaSeriesView', AnchoredCategorySeriesView.$);
//# sourceMappingURL=StepAreaSeries_combined.js.map