import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { CategoryMode } from "./CategoryMode";
import { SeriesView } from "./SeriesView";
import { Type, IList$1 } from "./type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { CategoryFrame } from "./CategoryFrame";
import { List$1 } from "./List$1";
import { CategorySeriesView } from "./CategorySeriesView";
import { Path } from "./Path";
import { UnknownValuePlotting } from "./UnknownValuePlotting";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Clipper } from "./Clipper";
import { RenderingContext } from "./RenderingContext";
export declare class StepLineSeries extends HorizontalAnchoredCategorySeries implements IIsCategoryBased {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    px: StepLineSeriesView;
    constructor();
    pw: CategoryLineRasterizer;
    ac(): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected get_ci(): boolean;
    readonly ci: boolean;
    he(a: boolean, b: SeriesView): void;
    protected bc(): SeriesHitTestMode;
    d6(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    private py(a, b, c, d, e, f);
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly useHighMarkerFidelity: boolean;
    static $t: Type;
}
export declare class StepLineSeriesView extends AnchoredCategorySeriesView {
    protected c4: StepLineSeries;
    constructor(a: StepLineSeries);
    private de;
    private dd;
    private df;
    readonly db: Path;
    readonly dc: Path;
    readonly da: Path;
    c5(): void;
    c6(a: number, b: List$1<number[]>, c: boolean, d: UnknownValuePlotting, e: Clipper, f: number, g: number): void;
    private c9;
    private c8;
    private c7;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    protected ac(): void;
    static $t: Type;
}
