/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { StochRSIIndicatorStrategy } from "./StochRSIIndicatorStrategy";
import { typeGetValue, markType } from "./type";
export class StochRSIIndicator extends StrategyBasedIndicator {
    get_pp() {
        return new StochRSIIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return StochRSIIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get qa() {
        return typeGetValue(this.c(StochRSIIndicator.qb));
    }
    set qa(a) {
        this.h(StochRSIIndicator.qb, a);
    }
    pv() {
        return this.qa;
    }
    p4(a) {
        this.qa = a;
    }
}
StochRSIIndicator.qb = StrategyBasedIndicator.p7(14, StochRSIIndicator.$);
StochRSIIndicator.$t = markType(StochRSIIndicator, 'StochRSIIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.StochRSIIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.StochRSIIndicator" />*/
//# sourceMappingURL=StochRSIIndicator.js.map