/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { NumericAxisBase } from "./NumericAxisBase";
import { NumericScaleMode_$type } from "./NumericScaleMode";
import { DependencyProperty } from "./DependencyProperty";
import { NumericScaler } from "./NumericScaler";
import { ArgumentNullException } from "./ArgumentNullException";
import { LogarithmicScaler } from "./LogarithmicScaler";
import { Type, enumGetBox, typeCast, markType } from "./type";
import { PropertyMetadata } from "./PropertyMetadata";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
export class StraightNumericAxisBase extends NumericAxisBase {
    constructor() {
        super();
        this.kq = null;
        this.ku = false;
        this.k4();
    }
    ax() {
        return new StraightNumericAxisBaseView(this);
    }
    f5(a) {
        super.f5(a);
        this.kt = a;
    }
    get ks() {
        return this.c(StraightNumericAxisBase.k6);
    }
    set ks(a) {
        this.h(StraightNumericAxisBase.k6, a);
    }
    static k2(a, b) {
        let c = typeCast(StraightNumericAxisBase.$, a);
        c.k4();
        c.gd("Scaler", b.oldValue, b.newValue);
    }
    kr() {
        return null;
    }
    get_kp() {
        if (this.kq == null) {
            this.k4();
        }
        return this.kq;
    }
    set_kp(a) {
        let b = this.kq != a;
        if (b) {
            let c = this.kq;
            this.kq = a;
            this.gd("ActualScaler", c, a);
        }
    }
    get kp() {
        return this.get_kp();
    }
    set kp(a) {
        this.set_kp(a);
    }
    kb(a, b, c, d, e, f, g) {
        let h = this.kp.t(a, b, c, f, g);
        f = h.p3;
        g = h.p4;
        return {
            p5: f,
            p6: g
        };
    }
    k3(a) {
        let b = this.ku;
        this.ku = true;
        a();
        this.ku = b;
    }
    k4() {
        let a = this.ks;
        if (a == null) {
            a = this.iu();
        }
        this.kp = a;
        if (this.kp == null) {
            throw new ArgumentNullException(0, "ActualScaler");
        }
        this.kz();
    }
    kz() {
        this.kt.bb();
    }
    f7(a, b, c, d) {
        if (this.ku) {
            return;
        }
        super.f7(a, b, c, d);
        switch (b) {
            case NumericAxisBase.$$p[2]:
                this.k4();
                break;
            case NumericAxisBase.$$p[1]:
                this.k4();
                break;
            case StraightNumericAxisBase.$$p[0]:
                this.k4();
                break;
            case "Scaler":
                this.k4();
                break;
            case "ActualScaler":
                this.i1 = typeCast(LogarithmicScaler.$, this.kp) !== null;
                this.kz();
                this.cb();
                this.gj(false);
                break;
            case "ActualMaximumValue":
                this.k0();
                break;
            case "ActualMinimumValue":
                this.k1();
                this.k4();
                break;
        }
    }
    k1() {
        this.kp.y(this.jg);
    }
    k0() {
        this.kp.x(this.jf);
    }
    kv(a, b) {
        if (a < this.jg) {
            a = this.jg;
        }
        else if (a > this.jf) {
            a = this.jf;
        }
        if (!b.b5) {
            return (a - this.jg) / (this.jf - this.jg);
        }
        else {
            return (a - this.jf) / (this.jg - this.jf);
        }
    }
}
StraightNumericAxisBase.k6 = DependencyProperty.i("Scaler", NumericScaler.$, StraightNumericAxisBase.$, new PropertyMetadata(2, null, StraightNumericAxisBase.k2));
StraightNumericAxisBase.$t = markType(StraightNumericAxisBase, 'StraightNumericAxisBase', NumericAxisBase.$);
Type.dep(DependencyProperty, PropertyMetadata, StraightNumericAxisBase, 'gd', ['ScaleMode:ko:k5', [NumericScaleMode_$type, enumGetBox(NumericScaleMode_$type, 0)]]);
export class StraightNumericAxisBaseView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.ba = null;
        this.ba = a;
    }
    bb() {
        this.ba.kp.x(this.ba.jf);
        this.ba.kp.y(this.ba.jg);
    }
}
StraightNumericAxisBaseView.$t = markType(StraightNumericAxisBaseView, 'StraightNumericAxisBaseView', NumericAxisBaseView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.StraightNumericAxisBase" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.StraightNumericAxisBase" />*/
//# sourceMappingURL=StraightNumericAxisBase_combined.js.map