import { TimeAxisBase } from "./TimeAxisBase";
import { ITimeRangeSelectorAxis } from "./ITimeRangeSelectorAxis";
import { TimeAxisBreakCollection } from "./TimeAxisBreakCollection";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { TimeAxisIntervalCollection } from "./TimeAxisIntervalCollection";
import { Type, IList$1 } from "./type";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "./Rect";
import { TimeAxisLabelFormat } from "./TimeAxisLabelFormat";
export declare class TimeXAxis extends TimeAxisBase implements ITimeRangeSelectorAxis {
    constructor();
    dj(a: number, b: ScalerParams): number;
    f0(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    protected startCursor(): void;
    protected resetCursor(): void;
    private lt;
    dm(a: number, b: ScalerParams): number;
    private ld;
    readonly le: TimeAxisBreakCollection;
    private lj;
    readonly lk: TimeAxisLabelFormatCollection;
    protected f7(a: any, b: string, c: any, d: any): void;
    protected gv(a: Rect, b: Rect): void;
    protected gu(a: Rect, b: Rect): void;
    cd(): boolean;
    private _omission;
    private omission;
    private l5();
    private lc;
    private lm(a);
    private lq(a, b);
    private l4();
    eq(a: any): any;
    static lu(a: Date, b: number, c: IList$1<TimeAxisLabelFormat>): any;
    protected get_ke(): boolean;
    protected set_ke(a: boolean): void;
    ke: boolean;
    private lh;
    readonly li: TimeAxisIntervalCollection;
    private lw();
    static lx(a: number): string;
    private lf();
    private lg();
    protected gk(a: boolean): void;
    private ll();
    private ln(a);
    private l3;
    private lp;
    visibleMinimum: Date;
    private lo;
    visibleMaximum: Date;
    protected k7(): void;
    getOffset1(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    i$f(a: number): number;
    private l6(a, b);
    private l8(a, b);
    private l7(a, b);
    protected get_bu(): boolean;
    readonly bu: boolean;
    getWindowRectForSelection(a: Date, b: Date): Rect;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    private l1;
    private l0();
    protected k3(): void;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    readonly i$a: boolean;
    static $t: Type;
}
