/**
 * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
*/
export class ChartSeriesEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
         * Gets the series.
        */
    get series() {
        if (this.i.series == null) {
            return null;
        }
        return this.i.series.externalObject;
    }
}
//# sourceMappingURL=igx-chart-series-event-args.js.map