import { Type } from '@angular/core';
import { IgxSplineSeriesBaseComponent } from './igx-spline-series-base-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { SplineAreaSeries } from "./SplineAreaSeries";
/**
 * Represents a IgxDataChartComponent spline area series.
*/
export declare const IgxSplineAreaSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxSplineAreaSeriesComponent extends IgxSplineSeriesBaseComponent {
    protected createImplementation(): SplineAreaSeries;
    readonly i: SplineAreaSeries;
    constructor();
}
