import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxSplineSeriesBaseComponent } from './igx-spline-series-base-component';
import { IgxHorizontalAnchoredCategorySeriesComponent } from './igx-horizontal-anchored-category-series-component';
import { IgxAnchoredCategorySeriesComponent } from './igx-anchored-category-series-component';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { SplineSeries } from "./SplineSeries";
/**
 * Represents a IgxDataChartComponent spline series.
*/
export const IgxSplineSeriesComponent_PROVIDERS = [{ provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }];
export class IgxSplineSeriesComponent extends IgxSplineSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SplineSeries();
    }
    get i() {
        return this._implementation;
    }
}
IgxSplineSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-spline-series',
                template: ``,
                providers: [{ provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxSplineSeriesComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-spline-series-component.js.map