import { FinancialOverlay } from "./FinancialOverlay";
import { List$1 } from "./List$1";
import { Type, Point } from "./type";
import { CategoryFrame } from "./CategoryFrame";
import { AxisRange } from "./AxisRange";
import { Axis } from "./Axis";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { Rect } from "./Rect";
import { SeriesView } from "./SeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "./Polyline";
import { Polygon } from "./Polygon";
import { RenderingContext } from "./RenderingContext";
export declare class BollingerBandsOverlay extends FinancialOverlay {
    constructor();
    o6: number;
    o5: number;
    protected ie(a: any, b: string, c: any, d: any): void;
    private o3;
    private o4;
    protected ow(): boolean;
    am(a: Axis): AxisRange;
    o1: List$1<number>;
    o2: List$1<number>;
    ob(a: CategoryFrame, b: FinancialSeriesView): void;
    he(a: boolean, b: SeriesView): void;
    ed(a: Point, b: boolean, c: boolean): number;
    e3(a: Point, b: boolean): number;
    e1(a: Point, b: boolean): number;
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    private o0;
    protected nk(): number;
    d8(): number;
    static $$p: string[];
    static $t: Type;
}
export declare class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
    constructor(a: FinancialSeriesView);
    protected f: BollingerBandsOverlayView;
    getBucket(a: number): number[];
    static $t: Type;
}
export declare class BollingerBandsOverlayView extends FinancialSeriesView {
    by: BollingerBandsOverlay;
    constructor(a: BollingerBandsOverlay);
    ap(): void;
    protected bt(): FinancialBucketCalculator;
    b0(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: (arg1: number) => number, e: (arg1: number) => number, f: (arg1: number) => number): void;
    bz(): void;
    readonly b2: Polygon;
    readonly b7: Polyline;
    readonly b8: Polyline;
    readonly b9: Polyline;
    private b3;
    private ca;
    private cb;
    private cc;
    private b1;
    private b4;
    private b5;
    private b6;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
