import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "./DependencyProperty";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Type, IList$1 } from "./type";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewer } from "./SeriesViewer";
import { CategoryMode } from "./CategoryMode";
import { IGetItemAtIndex } from "./IGetItemAtIndex";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
export declare class CategoryXAxis extends CategoryAxisBase {
    ax(): AxisView;
    f5(a: AxisView): void;
    j9: CategoryXAxisView;
    constructor();
    private kl;
    kn: number;
    private kk;
    km: number;
    ao(): AxisLabelPanelBase;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    i3(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    c7(): number;
    ks(a: any): void;
    dj(a: number, b: ScalerParams): number;
    protected j8(a: IList$1<number[]>): number[][];
    fz(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    dk(a: number, b: ScalerParams, c: CategoryMode): number;
    private kh(a, b, c, d);
    dm(a: number, b: ScalerParams): number;
    dn(a: number, b: ScalerParams, c: CategoryMode): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    kt(a: number, b: number): void;
    protected gk(a: boolean): void;
    cd(): boolean;
    static readonly ku: DependencyProperty;
    ki: number;
    private kb;
    kd: number;
    static readonly kv: DependencyProperty;
    kj: number;
    private kc;
    ke: number;
    iu(a: SeriesViewer): boolean;
    protected get_av(): AxisOrientation;
    readonly av: AxisOrientation;
    protected ka(): IGetItemAtIndex;
    protected kg(a: number, b: ScalerParams): number;
    protected kf(a: number, b: number, c: boolean, d: ScalerParams): number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $t: Type;
}
export declare class CategoryXAxisView extends CategoryAxisBaseView {
    protected ba: CategoryXAxis;
    constructor(a: CategoryXAxis);
    static $t: Type;
}
