/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "./type";
import { Brush } from "./Brush";
var FullStochasticOscillatorIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(FullStochasticOscillatorIndicator, _super);
    function FullStochasticOscillatorIndicator() {
        var _this = _super.call(this) || this;
        _this.trendLineBrush = ((function () {
            var $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        _this.trendLineType = 10;
        _this.trendLinePeriod = 3;
        return _this;
    }
    FullStochasticOscillatorIndicator.prototype.get_pp = function () {
        return new FullStochasticOscillatorIndicatorStrategy();
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "pp", {
        get: function () {
            return this.get_pp();
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.get_p2 = function () {
        return FullStochasticOscillatorIndicator.$;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "p2", {
        get: function () {
            return this.get_p2();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qa", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.qf));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.qf, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.pv = function () {
        return this.qa;
    };
    FullStochasticOscillatorIndicator.prototype.p4 = function (a) {
        this.qa = a;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "smoothingPeriod", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.qg));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.qg, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.px = function () {
        return this.smoothingPeriod;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qc", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.qh));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.qh, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.pu = function () {
        return this.qc;
    };
    FullStochasticOscillatorIndicator.prototype.o5 = function () {
        return this.qc;
    };
    FullStochasticOscillatorIndicator.qf = StrategyBasedIndicator.p7(14, FullStochasticOscillatorIndicator.$);
    FullStochasticOscillatorIndicator.qg = StrategyBasedIndicator.p8(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
    FullStochasticOscillatorIndicator.qh = StrategyBasedIndicator.p8(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
    FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
    return FullStochasticOscillatorIndicator;
}(StrategyBasedIndicator));
export { FullStochasticOscillatorIndicator };
/*<BeginStatics Name="Infragistics.Controls.Charts.FullStochasticOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FullStochasticOscillatorIndicator" />*/
//# sourceMappingURL=FullStochasticOscillatorIndicator.js.map