/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager_$type } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "./DVContainer";
import { Type, runOn, Point_$type, typeCast, EnumUtil, enumGetBox, markType } from "./type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "./DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryMode_$type } from "./CategoryMode";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { TrendLineType_$type } from "./TrendLineType";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "./PropertyMetadata";
var HorizontalAnchoredCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(HorizontalAnchoredCategorySeries, _super);
    function HorizontalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ph = null;
        _this.pd = null;
        _this.pj = null;
        _this.pf = 0;
        return _this;
    }
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "pi", {
        get: function () {
            var _this = this;
            if (this.ph == null) {
                this.ph = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b1.n; });
            }
            return this.ph;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.prototype.hc = function () {
        _super.prototype.hc.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalAnchoredCategorySeries.prototype.bc = function () {
        if (this.bd == 0) {
            return 1;
        }
        else {
            return _super.prototype.bc.call(this);
        }
    };
    HorizontalAnchoredCategorySeries.prototype.ml = function () {
        return this.pd;
    };
    HorizontalAnchoredCategorySeries.prototype.m5 = function () {
        return this.pj;
    };
    HorizontalAnchoredCategorySeries.prototype.lb = function (a) {
        if (this.mm == null || this.mm.m.count == 0 || !this.hasMarkers || !this.li()) {
            return Rect.empty;
        }
        return this.pi.d$d(this, this.mm.m, a, runOn(this, this.pv));
    };
    HorizontalAnchoredCategorySeries.prototype.pv = function (a) {
        return this.oe.c3(a);
    };
    HorizontalAnchoredCategorySeries.prototype.pn = function (a, b, c) {
        return this.pi.d$c(this, this.m5(), a, b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.ag = function (a) {
        return this.pi.d$a(this, this.mm.f, this.nm(this.bh), this.nn(this.bh), a);
    };
    HorizontalAnchoredCategorySeries.prototype.ah = function (a) {
        return this.pi.d$b(this, this.mm.f, this.nm(this.bh), this.nn(this.bh), a);
    };
    HorizontalAnchoredCategorySeries.prototype.dd = function (a, b) {
        if (this.dc(a, b)) {
            return true;
        }
        if (this.lj(a, b)) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.mq.r(this.ml(), this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    };
    HorizontalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        var a = this.getEffectiveViewport1(this.bh);
        return this.ml().getCategorySize(this.bh.bq, this.bh.bp, a);
    };
    HorizontalAnchoredCategorySeries.prototype.ed = function (a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bh);
        var e = this.ml();
        var f = new ScalerParams(0, this.br.mk, this.bh.bp, e.bz, d);
        var g = this.mq.r(e, this.br.mk, this.bh.bp, d);
        return this.ef(this.valueColumn, a, e, f, g, runOn(this, this.nk), b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.e3 = function (a, b) {
        return this.e4(a, b, this.ml(), runOn(this, this.nk), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.e1 = function (a, b) {
        return this.e2(a, b, this.ml(), runOn(this, this.nk), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.d0 = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.d1(a, b, this.ml(), d, e, this.valueColumn.count, runOn(this, this.nk));
    };
    HorizontalAnchoredCategorySeries.prototype.k0 = function (a, b, c) {
        if (this.ml() == null || this.m5() == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        return this.k2(a, b, c, this.mq.r(this.ml(), this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.m5(), this.ml(), null, null, null);
    };
    HorizontalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.pd;
    };
    HorizontalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.pj;
    };
    HorizontalAnchoredCategorySeries.prototype.ow = function (a) {
        this.xAxis = typeCast(CategoryAxisBase.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.ox = function (a) {
        this.yAxis = typeCast(NumericYAxis.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.ng = function () {
        return this.pj != null && this.pj.cb();
    };
    HorizontalAnchoredCategorySeries.prototype.pr = function (a) {
        this.pd = a;
    };
    HorizontalAnchoredCategorySeries.prototype.ps = function (a) {
        this.pj = a;
    };
    HorizontalAnchoredCategorySeries.prototype.mf = function (a, b) {
        return this.ob(a, b, this.pd);
    };
    HorizontalAnchoredCategorySeries.prototype.ie = function (a, b, c, d) {
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                this.pr(this.xAxis);
                if (this.oe.cx) {
                    this.oe.cw = CategoryTrendLineManagerFactory.a(this.oe.cw, this.pd, this.jc, this, this.b1);
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.oe.cw = CategoryTrendLineManagerFactory.a(this.oe.cw, this.pd, this.jc, this, this.b1);
                }
                break;
        }
        _super.prototype.ie.call(this, a, b, c, d);
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.hi(typeCast(Axis.$, c));
                    this.ik(typeCast(Axis.$, d));
                    this.pr(this.xAxis);
                    this.mu.cl.g(this.ej);
                    this.it(false);
                    this.h1();
                }
                break;
            case HorizontalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.hi(typeCast(Axis.$, c));
                    this.ik(typeCast(Axis.$, d));
                    this.ps(this.yAxis);
                    this.mu.cl.g(this.ej);
                    this.ng();
                    this.it(false);
                    this.h1();
                }
                break;
            case "CategoryMode":
                if (this.xAxis != null) {
                    this.xAxis.jz(true);
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.hh = function (a, b, c, d) {
        _super.prototype.hh.call(this, a, b, c, d);
        if (this.pd != null && typeCast(ISortingAxis_$type, this.pd) !== null) {
            this.pd.i$i();
        }
        switch (a) {
            case 4:
                if (this.pd != null) {
                    this.pd.cb();
                }
                if (this.pj != null && !this.pj.cb()) {
                    this.it(true);
                }
                break;
            case 1:
                if (this.pd != null) {
                    this.pd.cb();
                }
                if (this.pj != null && !this.pj.cb()) {
                    this.it(true);
                }
                break;
            case 0:
                if (this.pd != null) {
                    this.pd.cb();
                }
                if (this.pj != null && !this.pj.cb()) {
                    this.it(true);
                }
                break;
            case 2:
                if (this.op != null && this.oe.cl.d > 0 && this.pj != null && !this.pj.cb()) {
                    this.it(true);
                }
                break;
            case 3:
                if (d == this.op) {
                    if (this.pd != null) {
                        this.pd.cb();
                    }
                    if (this.pj != null && !this.pj.cb()) {
                        this.it(true);
                    }
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.pl = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.bw) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.pm = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "pg", {
        get: function () {
            return this.pf;
        },
        set: function (a) {
            var b = this.pg;
            if (a != b) {
                this.pf = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.pg));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
    return HorizontalAnchoredCategorySeries;
}(AnchoredCategorySeries));
export { HorizontalAnchoredCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::pt', [CategoryAxisBase.$, null], 'YAxis::pu', [NumericYAxis.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.HorizontalAnchoredCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.HorizontalAnchoredCategorySeries" />*/
//# sourceMappingURL=HorizontalAnchoredCategorySeries.js.map