import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting } from "./IUnknownValuePlotting";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting } from "./UnknownValuePlotting";
import { SeriesView } from "./SeriesView";
import { Type } from "./type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "./List$1";
import { Path } from "./Path";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Clipper } from "./Clipper";
import { RenderingContext } from "./RenderingContext";
export declare class LineSeries extends HorizontalAnchoredCategorySeries implements IUnknownValuePlotting {
    protected be(): SeriesView;
    px: LineSeriesView;
    h9(a: SeriesView): void;
    protected get_ci(): boolean;
    readonly ci: boolean;
    constructor();
    pw: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    he(a: boolean, b: SeriesView): void;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    unknownValuePlotting: UnknownValuePlotting;
    protected ie(a: any, b: string, c: any, d: any): void;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class LineSeriesView extends AnchoredCategorySeriesView {
    protected c4: LineSeries;
    constructor(a: LineSeries);
    private de;
    private dd;
    private df;
    readonly db: Path;
    readonly dc: Path;
    readonly da: Path;
    c5(): void;
    c6(a: number, b: List$1<number[]>, c: boolean, d: UnknownValuePlotting, e: Clipper, f: number, g: number): void;
    protected a8(): void;
    private c9;
    private c8;
    private c7;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    protected ac(): void;
    static $t: Type;
}
