/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType, TypeRegistrar } from "./type";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "./Rect";
import { RangeInfo } from "./RangeInfo";
import { HorizontalLogarithmicScaler } from "./HorizontalLogarithmicScaler";
import { FastHorizontalLinearScaler } from "./FastHorizontalLinearScaler";
import { isNaN_ } from "./number";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
var NumericXAxis = /** @class */ (function (_super) {
    tslib_1.__extends(NumericXAxis, _super);
    function NumericXAxis() {
        var _this = _super.call(this) || this;
        _this.ab = NumericXAxis.$;
        _this.ir = _this.ip();
        return _this;
    }
    NumericXAxis.prototype.ax = function () {
        return new NumericXAxisView(this);
    };
    NumericXAxis.prototype.f5 = function (a) {
        _super.prototype.f5.call(this, a);
        this.k7 = a;
    };
    NumericXAxis.prototype.ao = function () {
        if (this.cf) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    NumericXAxis.prototype.ip = function () {
        var _this = this;
        var a = _super.prototype.ip.call(this);
        a.b.c = function (b) {
            if ((_this.as == null || _this.as.visibility == 0) && _this.ag != null) {
                _this.ap.a6 = b;
                if (_this.as != null && (_this.as.location == 4 || _this.as.location == 5)) {
                    _this.a9.hp();
                }
            }
        };
        a.k = function (b, c, d) { return _this.gs(c, d, b.z, b.b, false); };
        a.l = function (b, c, d, e) { return _this.gt(c, d, e, b.z); };
        a.m = function (b, c) {
            var d = b.y;
            var e = new ScalerParams(0, b.aa, b.z, _this.b0, d);
            return _this.dj(c, e);
        };
        a.q = function (b, c) { return true; };
        a.j = function (b) { return _this.f3(b.t, b.n, b.z, b.a, true); };
        a.e = function (b) {
            b.n = b.z.bottom;
            if (_this.ag != null && _this.ag.a9 != null) {
                var c = b.n;
                var d = b.r;
                var e = _this.gn(c, d, b.aa, b.z, b.y, b.z.top, b.z.bottom);
                c = e.p0;
                d = e.p1;
                b.n = c;
                b.r = d;
            }
        };
        a.p = function (b, c, d) {
            var e = Math.round(c);
            return e >= Math.floor(b.z.left) && e <= Math.ceil(b.z.right);
        };
        return a;
    };
    NumericXAxis.prototype.dj = function (a, b) {
        if (this.kq != null) {
            return this.kq.p(a, b);
        }
        return this.kp.p(a, b);
    };
    NumericXAxis.prototype.dm = function (a, b) {
        if (this.kq != null) {
            return this.kq.q(a, b);
        }
        return this.kp.q(a, b);
    };
    NumericXAxis.prototype.f0 = function (a, b, c, d) {
        if (this.kq != null) {
            this.kq.v(a, b, c, d);
            return;
        }
        this.kp.v(a, b, c, d);
    };
    NumericXAxis.prototype.fz = function (a, b, c, d, e) {
        if (this.kq != null) {
            this.kq.u(a, b, c, d, e);
            return;
        }
        this.kp.u(a, b, c, d, e);
    };
    NumericXAxis.prototype.f1 = function (a, b, c, d) {
        if (this.kq != null) {
            this.kq.j(a, b, c, d);
            return;
        }
        this.kp.j(a, b, c, d);
    };
    NumericXAxis.prototype.k8 = function (a, b) {
        if (this.a9 == null || a == NaN || b == NaN) {
            return;
        }
        var c = this.kv(a, this);
        var d = this.kv(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.a9.my = new Rect(0, c, this.a9.my.y, d - c, this.a9.my.height);
    };
    NumericXAxis.prototype.is = function (a, b, c, d) {
        var e = d;
        var f = _super.prototype.is.call(this, a, b, c, d);
        var g = new ScalerParams(0, b, a, this.bz, c);
        var h = NaN;
        var i = NaN;
        if (!this.bz && b.right == 1) {
            i = this.jf;
        }
        else if (this.bz && b.left == 0) {
            h = this.jf;
        }
        if (isNaN_(h)) {
            h = this.dm(e.left, g);
        }
        if (isNaN_(i)) {
            i = this.dm(e.right, g);
        }
        var j = Math.min(h, i);
        var k = Math.max(h, i);
        this.jj = j;
        this.ji = k;
        f.k.add(((function () {
            var $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.width;
            return $ret;
        })()));
        return f;
    };
    NumericXAxis.prototype.gk = function (a) {
        _super.prototype.gk.call(this, a);
        var b = this.a9 != null ? this.a9.mk : Rect.empty;
        var c = !b.isEmpty ? this.ib : Rect.empty;
        var d = this.h6();
        var e = this.h5();
        var f = this.ir.c(a, c, b, d, e);
        if (f != null) {
            this.je = f.f.m;
            this.jh = f.f.l;
        }
    };
    NumericXAxis.prototype.gu = function (a, b) {
        _super.prototype.gu.call(this, a, b);
        if (b.height != a.height) {
            this.cb();
        }
    };
    NumericXAxis.prototype.get_av = function () {
        return 0;
    };
    Object.defineProperty(NumericXAxis.prototype, "av", {
        get: function () {
            return this.get_av();
        },
        enumerable: true,
        configurable: true
    });
    NumericXAxis.prototype.iu = function () {
        if (this.i5) {
            return new HorizontalLogarithmicScaler();
        }
        switch (this.ko) {
            case 0: return new FastHorizontalLinearScaler();
            case 1: return new HorizontalLogarithmicScaler();
        }
        return null;
    };
    NumericXAxis.prototype.j$c = function (a, b) {
        return this.dm.apply(this, arguments);
    };
    NumericXAxis.prototype.j$b = function (a, b) {
        return this.dj.apply(this, arguments);
    };
    NumericXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.fz.apply(this, arguments);
    };
    NumericXAxis.prototype.j$e = function (a, b, c, d) {
        this.f0.apply(this, arguments);
    };
    NumericXAxis.prototype.j$f = function (a, b, c, d) {
        this.f1.apply(this, arguments);
    };
    Object.defineProperty(NumericXAxis.prototype, "j$a", {
        get: function () {
            return this.bz;
        },
        enumerable: true,
        configurable: true
    });
    NumericXAxis.$t = markType(NumericXAxis, 'NumericXAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericXAxis;
}(StraightNumericAxisBase));
export { NumericXAxis };
var NumericXAxisView = /** @class */ (function (_super) {
    tslib_1.__extends(NumericXAxisView, _super);
    function NumericXAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bc = null;
        _this.bc = a;
        return _this;
    }
    NumericXAxisView.$t = markType(NumericXAxisView, 'NumericXAxisView', StraightNumericAxisBaseView.$);
    return NumericXAxisView;
}(StraightNumericAxisBaseView));
export { NumericXAxisView };
//# sourceMappingURL=NumericXAxis_combined.js.map