/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { PercentageVolumeOscillatorIndicatorStrategy } from "./PercentageVolumeOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "./type";
var PercentageVolumeOscillatorIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(PercentageVolumeOscillatorIndicator, _super);
    function PercentageVolumeOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentageVolumeOscillatorIndicator.prototype.get_pp = function () {
        return new PercentageVolumeOscillatorIndicatorStrategy();
    };
    Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "pp", {
        get: function () {
            return this.get_pp();
        },
        enumerable: true,
        configurable: true
    });
    PercentageVolumeOscillatorIndicator.prototype.get_p2 = function () {
        return PercentageVolumeOscillatorIndicator.$;
    };
    Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "p2", {
        get: function () {
            return this.get_p2();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "shortPeriod", {
        get: function () {
            return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.qb));
        },
        set: function (a) {
            this.h(PercentageVolumeOscillatorIndicator.qb, a);
        },
        enumerable: true,
        configurable: true
    });
    PercentageVolumeOscillatorIndicator.prototype.px = function () {
        return this.shortPeriod;
    };
    Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "longPeriod", {
        get: function () {
            return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.qa));
        },
        set: function (a) {
            this.h(PercentageVolumeOscillatorIndicator.qa, a);
        },
        enumerable: true,
        configurable: true
    });
    PercentageVolumeOscillatorIndicator.prototype.pu = function () {
        return this.longPeriod;
    };
    PercentageVolumeOscillatorIndicator.qb = StrategyBasedIndicator.p9(10, PercentageVolumeOscillatorIndicator.$);
    PercentageVolumeOscillatorIndicator.qa = StrategyBasedIndicator.p5(30, PercentageVolumeOscillatorIndicator.$);
    PercentageVolumeOscillatorIndicator.$t = markType(PercentageVolumeOscillatorIndicator, 'PercentageVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
    return PercentageVolumeOscillatorIndicator;
}(StrategyBasedIndicator));
export { PercentageVolumeOscillatorIndicator };
/*<BeginStatics Name="Infragistics.Controls.Charts.PercentageVolumeOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.PercentageVolumeOscillatorIndicator" />*/
//# sourceMappingURL=PercentageVolumeOscillatorIndicator.js.map