/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { NumericAxisBase } from "./NumericAxisBase";
import { NumericScaleMode_$type } from "./NumericScaleMode";
import { DependencyProperty } from "./DependencyProperty";
import { NumericScaler } from "./NumericScaler";
import { ArgumentNullException } from "./ArgumentNullException";
import { LogarithmicScaler } from "./LogarithmicScaler";
import { Type, enumGetBox, typeCast, markType } from "./type";
import { PropertyMetadata } from "./PropertyMetadata";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
var StraightNumericAxisBase = /** @class */ (function (_super) {
    tslib_1.__extends(StraightNumericAxisBase, _super);
    function StraightNumericAxisBase() {
        var _this = _super.call(this) || this;
        _this.kq = null;
        _this.ku = false;
        _this.k4();
        return _this;
    }
    StraightNumericAxisBase.prototype.ax = function () {
        return new StraightNumericAxisBaseView(this);
    };
    StraightNumericAxisBase.prototype.f5 = function (a) {
        _super.prototype.f5.call(this, a);
        this.kt = a;
    };
    Object.defineProperty(StraightNumericAxisBase.prototype, "ks", {
        get: function () {
            return this.c(StraightNumericAxisBase.k6);
        },
        set: function (a) {
            this.h(StraightNumericAxisBase.k6, a);
        },
        enumerable: true,
        configurable: true
    });
    StraightNumericAxisBase.k2 = function (a, b) {
        var c = typeCast(StraightNumericAxisBase.$, a);
        c.k4();
        c.gd("Scaler", b.oldValue, b.newValue);
    };
    StraightNumericAxisBase.prototype.kr = function () {
        return null;
    };
    StraightNumericAxisBase.prototype.get_kp = function () {
        if (this.kq == null) {
            this.k4();
        }
        return this.kq;
    };
    StraightNumericAxisBase.prototype.set_kp = function (a) {
        var b = this.kq != a;
        if (b) {
            var c = this.kq;
            this.kq = a;
            this.gd("ActualScaler", c, a);
        }
    };
    Object.defineProperty(StraightNumericAxisBase.prototype, "kp", {
        get: function () {
            return this.get_kp();
        },
        set: function (a) {
            this.set_kp(a);
        },
        enumerable: true,
        configurable: true
    });
    StraightNumericAxisBase.prototype.kb = function (a, b, c, d, e, f, g) {
        var h = this.kp.t(a, b, c, f, g);
        f = h.p3;
        g = h.p4;
        return {
            p5: f,
            p6: g
        };
    };
    StraightNumericAxisBase.prototype.k3 = function (a) {
        var b = this.ku;
        this.ku = true;
        a();
        this.ku = b;
    };
    StraightNumericAxisBase.prototype.k4 = function () {
        var a = this.ks;
        if (a == null) {
            a = this.iu();
        }
        this.kp = a;
        if (this.kp == null) {
            throw new ArgumentNullException(0, "ActualScaler");
        }
        this.kz();
    };
    StraightNumericAxisBase.prototype.kz = function () {
        this.kt.bb();
    };
    StraightNumericAxisBase.prototype.f7 = function (a, b, c, d) {
        if (this.ku) {
            return;
        }
        _super.prototype.f7.call(this, a, b, c, d);
        switch (b) {
            case NumericAxisBase.$$p[2]:
                this.k4();
                break;
            case NumericAxisBase.$$p[1]:
                this.k4();
                break;
            case StraightNumericAxisBase.$$p[0]:
                this.k4();
                break;
            case "Scaler":
                this.k4();
                break;
            case "ActualScaler":
                this.i1 = typeCast(LogarithmicScaler.$, this.kp) !== null;
                this.kz();
                this.cb();
                this.gj(false);
                break;
            case "ActualMaximumValue":
                this.k0();
                break;
            case "ActualMinimumValue":
                this.k1();
                this.k4();
                break;
        }
    };
    StraightNumericAxisBase.prototype.k1 = function () {
        this.kp.y(this.jg);
    };
    StraightNumericAxisBase.prototype.k0 = function () {
        this.kp.x(this.jf);
    };
    StraightNumericAxisBase.prototype.kv = function (a, b) {
        if (a < this.jg) {
            a = this.jg;
        }
        else if (a > this.jf) {
            a = this.jf;
        }
        if (!b.b5) {
            return (a - this.jg) / (this.jf - this.jg);
        }
        else {
            return (a - this.jf) / (this.jg - this.jf);
        }
    };
    StraightNumericAxisBase.k6 = DependencyProperty.i("Scaler", NumericScaler.$, StraightNumericAxisBase.$, new PropertyMetadata(2, null, StraightNumericAxisBase.k2));
    StraightNumericAxisBase.$t = markType(StraightNumericAxisBase, 'StraightNumericAxisBase', NumericAxisBase.$);
    return StraightNumericAxisBase;
}(NumericAxisBase));
export { StraightNumericAxisBase };
Type.dep(DependencyProperty, PropertyMetadata, StraightNumericAxisBase, 'gd', ['ScaleMode:ko:k5', [NumericScaleMode_$type, enumGetBox(NumericScaleMode_$type, 0)]]);
var StraightNumericAxisBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(StraightNumericAxisBaseView, _super);
    function StraightNumericAxisBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.ba = null;
        _this.ba = a;
        return _this;
    }
    StraightNumericAxisBaseView.prototype.bb = function () {
        this.ba.kp.x(this.ba.jf);
        this.ba.kp.y(this.ba.jg);
    };
    StraightNumericAxisBaseView.$t = markType(StraightNumericAxisBaseView, 'StraightNumericAxisBaseView', NumericAxisBaseView.$);
    return StraightNumericAxisBaseView;
}(NumericAxisBaseView));
export { StraightNumericAxisBaseView };
/*<BeginStatics Name="Infragistics.Controls.Charts.StraightNumericAxisBase" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.StraightNumericAxisBase" />*/
//# sourceMappingURL=StraightNumericAxisBase_combined.js.map