/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "./type";
import { DependencyProperty } from "./DependencyProperty";
import { PropertyMetadata } from "./PropertyMetadata";
import { List$1 } from "./List$1";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "./number";
var StrategyBasedIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(StrategyBasedIndicator, _super);
    function StrategyBasedIndicator() {
        var _this = _super.call(this) || this;
        _this.p3();
        return _this;
    }
    StrategyBasedIndicator.prototype.p3 = function () {
        this.po = this.pp;
        this.ab = this.p2;
    };
    StrategyBasedIndicator.prototype.pv = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.p4 = function (a) {
    };
    StrategyBasedIndicator.prototype.px = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.pu = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.p8 = function (a, b, c) {
        var d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, function (e, f) { return (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
        StrategyBasedIndicator.ps.add(c);
        return d;
    };
    StrategyBasedIndicator.p7 = function (a, b) {
        return StrategyBasedIndicator.p8(a, b, "Period");
    };
    StrategyBasedIndicator.p5 = function (a, b) {
        return StrategyBasedIndicator.p8(a, b, "LongPeriod");
    };
    StrategyBasedIndicator.p9 = function (a, b) {
        return StrategyBasedIndicator.p8(a, b, "ShortPeriod");
    };
    StrategyBasedIndicator.prototype.o1 = function (a, b) {
        var c = this.lz(a, b);
        var d = this.l0(c);
        return this.po.b(c, d);
    };
    StrategyBasedIndicator.prototype.oy = function (a, b) {
        var c = this.lz(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.mu(this.o1(a, b))) {
            return false;
        }
        var d = this.l0(c);
        if (this.ov != null) {
            c.minimumValue = this.ov.c;
            c.maximumValue = this.ov.b;
        }
        var e = this.po.a(c, d);
        for (var f = 0; f < this.o3 && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.l7 != null && this.pr(c)) {
            this.l7.cb();
        }
        return e;
    };
    StrategyBasedIndicator.prototype.pr = function (a) {
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            var b = this.ov;
            this.ov = new AxisRange(a.minimumValue, a.maximumValue);
            return this.pq(b, this.ov);
        }
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        try {
            for (var _a = tslib_1.__values(fromEnum(a.indicatorColumn)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var e = _b.value;
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var f = this.ov;
        this.ov = new AxisRange(c, d);
        return this.pq(f, this.ov);
        var e_1, _c;
    };
    StrategyBasedIndicator.prototype.pq = function (a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    };
    StrategyBasedIndicator.prototype.pw = function (a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    };
    StrategyBasedIndicator.prototype.lz = function (a, b) {
        var c = _super.prototype.lz.call(this, a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.pw(this.pv());
        c.shortPeriod = this.pw(this.px());
        c.longPeriod = this.pw(this.pu());
        c.multiplier = this.pt();
        return c;
    };
    StrategyBasedIndicator.prototype.pt = function () {
        return 1;
    };
    StrategyBasedIndicator.p6 = function (a, b) {
        var c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, function (d, e) { return (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
        StrategyBasedIndicator.ps.add("Multiplier");
        return c;
    };
    StrategyBasedIndicator.prototype.ie = function (a, b, c, d) {
        _super.prototype.ie.call(this, a, b, c, d);
        if (StrategyBasedIndicator.ps.contains(b)) {
            if (this.l7 != null && !this.l7.cb()) {
                this.l3.bs.e(this.ej);
                this.oy(0, this.indicatorColumn.count);
                if (this.ow.b2) {
                    this.ow.b0.g$i();
                }
                this.it(false);
            }
        }
    };
    StrategyBasedIndicator.ps = new List$1(String_$type, 0);
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    return StrategyBasedIndicator;
}(FinancialIndicator));
export { StrategyBasedIndicator };
/*<BeginStatics Name="Infragistics.Controls.Charts.StrategyBasedIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.StrategyBasedIndicator" />*/
//# sourceMappingURL=StrategyBasedIndicator.js.map