/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { Brush } from "./Brush";
import { DependencyProperty } from "./DependencyProperty";
import { Type, runOn, markType, fromEnum } from "./type";
import { Rect } from "./Rect";
import { Pool$1 } from "./Pool$1";
import { ArrayExtension } from "./ArrayExtension";
import { Rectangle } from "./Rectangle";
import { List$1 } from "./List$1";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "./PropertyMetadata";
import { isNaN_ } from "./number";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
var WaterfallSeries = /** @class */ (function (_super) {
    tslib_1.__extends(WaterfallSeries, _super);
    function WaterfallSeries() {
        var _this = _super.call(this) || this;
        _this.ab = WaterfallSeries.$;
        return _this;
    }
    WaterfallSeries.prototype.be = function () {
        return new WaterfallSeriesView(this);
    };
    WaterfallSeries.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        this.pw = a;
    };
    WaterfallSeries.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    WaterfallSeries.prototype.get_cx = function () {
        return true;
    };
    Object.defineProperty(WaterfallSeries.prototype, "cx", {
        get: function () {
            return this.get_cx();
        },
        enumerable: true,
        configurable: true
    });
    WaterfallSeries.prototype.iy = function (a, b) {
        _super.prototype.iy.call(this, a, b);
        this.p7 = a;
        this.p8 = b;
    };
    WaterfallSeries.prototype.ko = function () {
        return this.p7;
    };
    WaterfallSeries.prototype.get_na = function () {
        return true;
    };
    Object.defineProperty(WaterfallSeries.prototype, "na", {
        get: function () {
            return this.get_na();
        },
        enumerable: true,
        configurable: true
    });
    WaterfallSeries.prototype.ie = function (a, b, c, d) {
        _super.prototype.ie.call(this, a, b, c, d);
        switch (b) {
            case WaterfallSeries.$$p[3]:
            case WaterfallSeries.$$p[2]:
            case WaterfallSeries.$$p[0]:
            case WaterfallSeries.$$p[1]:
                this.it(false);
                break;
        }
    };
    WaterfallSeries.prototype.dd = function (a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.lj(a, b)) {
            return true;
        }
        return false;
    };
    WaterfallSeries.prototype.k9 = function (a) {
        var _this = this;
        if (this.pw == null || this.pw.c5 == null || this.pw.c5.count == 0 || this.xAxis == null) {
            return Rect.empty;
        }
        var b = this.pw.c5;
        var c = this.kv(a);
        var d = -1;
        var e = this.xAxis.bz;
        var f = this.ld.right * 2;
        if (e) {
            d = ArrayExtension.binarySearch$1(Rectangle.$, b, function (g) {
                var h = _this.pw.dc(g);
                return (f - c.x) < (f - (h.left + h.width / 2)) ? -1 : ((f - c.x) > (f - (h.left + h.width / 2)) ? 1 : 0);
            });
        }
        else {
            d = ArrayExtension.binarySearch$1(Rectangle.$, b, function (g) {
                var h = _this.pw.dc(g);
                return c.x < (h.left + h.width / 2) ? -1 : (c.x > (h.left + h.width / 2) ? 1 : 0);
            });
        }
        if (d < 0) {
            d = ~d;
            d--;
        }
        if (d < 0) {
            d = 0;
        }
        if (d > b.count - 1) {
            d = b.count - 1;
        }
        var g = d;
        var h = d;
        if (g < 0) {
            g--;
        }
        if (h < b.count - 1) {
            h++;
        }
        var i = this.p9(g);
        var j = this.p9(d);
        var k = this.p9(h);
        var l = i.left + i.width / 2;
        var m = j.left + j.width / 2;
        var n = k.left + k.width / 2;
        var o = Math.abs(l - c.x);
        var p = Math.abs(m - c.x);
        var q = Math.abs(n - c.x);
        var r = i.containsPoint(c);
        var s = j.containsPoint(c);
        var t = k.containsPoint(c);
        if (p <= o && p <= q) {
            if (!e && t) {
                return k;
            }
            if (e && r) {
                return i;
            }
            return j;
        }
        if (o <= p && o <= q) {
            if (!e && s) {
                return j;
            }
            return i;
        }
        if (q <= p && q <= o) {
            if (e && s) {
                return j;
            }
            return k;
        }
        return Rect.empty;
    };
    WaterfallSeries.prototype.p9 = function (a) {
        return this.pw.db(a);
    };
    WaterfallSeries.prototype.mv = function () {
        return 1;
    };
    WaterfallSeries.prototype.he = function (a, b) {
        _super.prototype.he.call(this, a, b);
        this.pw.c5.count = 0;
    };
    WaterfallSeries.prototype.d7 = function () {
        return this.pd.i3(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    };
    WaterfallSeries.prototype.n2 = function (a, b) {
        var c = b;
        _super.prototype.n2.call(this, a, b);
        var d = b.bq;
        var e = b.bp;
        var f = this.getEffectiveViewport1(b);
        var g = this.pd.i3(d, e, f);
        var h = this.px;
        var i = this.py;
        var j;
        var k = this.on(b);
        var l = NaN;
        var m = c.c5;
        var n;
        var o = 0;
        this.mt.x(this, this.ne(), this.pd, runOn(this, this.mf), this.nm(b), this.nn(b));
        this.mt.p = this.px;
        this.mt.q = this.py;
        this.mt.j = this.px;
        this.mt.k = this.py;
        var p = false;
        var q = this.mt.c;
        if (q != null) {
            p = true;
        }
        var r = this.pd.b3;
        var s = this.valueColumn.count;
        var t = a.f;
        var u = this.pd;
        var v = new ScalerParams(0, d, e, this.pd.bz, f);
        var w = this.ki;
        var x = this.p7;
        var y = this.kj;
        var z = this.p8 || y;
        if (a.f.count > 0) {
            j = a.f._inner[0][0] - 0.5 * g;
            var aa = a.f._inner[0][1];
            if (!isNaN_(aa)) {
                if (aa > k) {
                    n = m.item(o);
                    o++;
                    c.da(n, j, k);
                    n.width = g;
                    n.height = Math.abs(k - aa);
                    this.mt.al = x;
                    this.mt.ah = x;
                    this.mt.am = z;
                    this.mt.ai = z;
                    this.mt.f = true;
                    if (p) {
                        this.ny(t, 0, s, u, v, b.n);
                    }
                    this.mt.ae(n, false, false, false, false);
                    n.al = this.mt.j;
                    n.am = this.mt.k;
                }
                else {
                    n = m.item(o);
                    o++;
                    c.da(n, j, aa);
                    n.width = g;
                    n.height = Math.abs(aa - k);
                    this.mt.al = w;
                    this.mt.ah = w;
                    this.mt.am = y;
                    this.mt.ai = y;
                    this.mt.f = false;
                    if (p) {
                        this.ny(t, 0, s, u, v, b.n);
                    }
                    this.mt.ae(n, false, false, false, false);
                    n.al = this.mt.j;
                    n.am = this.mt.k;
                }
                l = aa;
            }
            else {
                l = k;
            }
        }
        for (var ab = 1; ab < a.f.count; ++ab) {
            var ac = a.f._inner[ab];
            j = a.f._inner[ab][0] - 0.5 * g;
            var ad = ac[1];
            if (!isNaN_(ad)) {
                n = m.item(o);
                o++;
                c.da(n, j, Math.min(l, ad));
                n.width = g;
                n.height = Math.abs(l - ad);
                this.mt.al = w;
                this.mt.ah = w;
                this.mt.am = y;
                this.mt.ai = y;
                this.mt.f = false;
                if (l > ad) {
                    if (p) {
                        this.ny(t, ab, s, u, v, b.n);
                    }
                }
                else {
                    this.mt.al = x;
                    this.mt.ah = x;
                    this.mt.am = z;
                    this.mt.ai = z;
                    this.mt.f = true;
                    if (p) {
                        this.ny(t, ab, s, u, v, b.n);
                    }
                }
                this.mt.ae(n, false, false, false, false);
                n.al = this.mt.j;
                n.am = this.mt.k;
                l = ad;
            }
        }
        m.count = o;
        b.cs(a);
    };
    Object.defineProperty(WaterfallSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    WaterfallSeries.$t = markType(WaterfallSeries, 'WaterfallSeries', HorizontalAnchoredCategorySeries.$);
    return WaterfallSeries;
}(HorizontalAnchoredCategorySeries));
export { WaterfallSeries };
Type.dep(DependencyProperty, PropertyMetadata, WaterfallSeries, 'raisePropertyChanged', ['NegativeBrush:p7:p3', [Brush.$, null], 'NegativeOutline:p8:p4', [Brush.$, null], 'RadiusX:px:p5', [1, 2], 'RadiusY:py:p6', [1, 2]]);
var WaterfallSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(WaterfallSeriesView, _super);
    function WaterfallSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c4 = null;
        _this.c6 = null;
        _this.dd = new Rectangle();
        _this.c5 = null;
        _this.c4 = a;
        _this.c5 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.de);
            $ret.activate = runOn(_this, _this.c7);
            $ret.disactivate = runOn(_this, _this.c9);
            $ret.destroy = runOn(_this, _this.c8);
            return $ret;
        })());
        return _this;
    }
    WaterfallSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.c6 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.ej = 4;
            this.c4.p7 = ((function () {
                var $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.c4.p8 = ((function () {
                var $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.e.bi = 5;
        }
    };
    WaterfallSeriesView.prototype.de = function () {
        var a = new Rectangle();
        this.c6.add(a);
        a._visibility = 1;
        return a;
    };
    WaterfallSeriesView.prototype.c7 = function (a) {
        a._visibility = 0;
    };
    WaterfallSeriesView.prototype.c9 = function (a) {
        a._visibility = 1;
    };
    WaterfallSeriesView.prototype.c8 = function (a) {
        this.c6.remove(a);
    };
    WaterfallSeriesView.prototype.da = function (a, b, c) {
        var d = false;
        if (a.o != c) {
            d = true;
            a.o = c;
        }
        if (a.n != b) {
            d = true;
            a.n = b;
        }
        if (d) {
            this.an();
        }
    };
    WaterfallSeriesView.prototype.z = function (a) {
        return this.c6._inner[a];
    };
    WaterfallSeriesView.prototype.y = function (a) {
        var b = this.c6._inner[a];
        this.dd._visibility = b._visibility;
        this.dd.n = b.n;
        this.dd.o = b.o;
        this.dd.width = b.width;
        this.dd.height = b.height;
        var c = this.bl(a);
        this.dd._fill = c;
        this.dd._stroke = c;
        this.dd.ac = this.e.en + 3;
        return this.dd;
    };
    WaterfallSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.c6.count; c++) {
                var d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    };
    WaterfallSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        var b = 0;
        var c = new List$1(Rectangle.$, 0);
        try {
            for (var _a = tslib_1.__values(fromEnum(this.c5.a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var d = _b.value;
                c.add(d);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        c.aa(function (e, f) {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        try {
            for (var _d = tslib_1.__values(fromEnum(c)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var e = _e.value;
                var f = "Negative";
                if (e._fill == this.e.ki) {
                    f = "Positive";
                }
                this.e.a1.exportRectangleData(a, e, "column" + b, ["Main", f]);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_2) throw e_2.error; }
        }
        b++;
        var e_1, _c, e_2, _f;
    };
    WaterfallSeriesView.prototype.db = function (a) {
        var b = this.c5.item(a);
        return new Rect(0, b.n, b.o, b.width, b.height);
    };
    WaterfallSeriesView.prototype.dc = function (a) {
        return new Rect(0, a.n, a.o, a.width, a.height);
    };
    WaterfallSeriesView.$t = markType(WaterfallSeriesView, 'WaterfallSeriesView', AnchoredCategorySeriesView.$);
    return WaterfallSeriesView;
}(AnchoredCategorySeriesView));
export { WaterfallSeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.WaterfallSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.WaterfallSeries" />*/
//# sourceMappingURL=WaterfallSeries_combined.js.map