/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { EventArgs, Base, markType } from "./type";
import { Rect } from "./Rect";
var ZoomSliderWidget = /** @class */ (function (_super) {
    tslib_1.__extends(ZoomSliderWidget, _super);
    function ZoomSliderWidget() {
        var _this = _super.call(this) || this;
        _this.j = null;
        _this.h = null;
        _this.q = null;
        _this.windowRectChanged = null;
        return _this;
    }
    ZoomSliderWidget.prototype.windowRectChangedHandler = function (a, b) {
        this.r = new Rect(0, (b.newRect.left), (b.newRect.top), (b.newRect.width), (b.newRect.height));
    };
    ZoomSliderWidget.a = function (externalChart_, host_) {
        var component_ = externalChart_._createZoomSlider(host_.getNativeElement());
        var result_ = new ZoomSliderWidget();
        result_.h = host_;
        result_.j = component_;
        component_.i.windowRectChanged = function (sender, args) { result_.windowRectChangedHandler(sender, args); };
        return result_;
    };
    Object.defineProperty(ZoomSliderWidget.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.r;
            if (Rect.l_op_Inequality(a, b)) {
                this.q = a;
                this.n("windowRect", {
                    left: a.left,
                    top: a.top,
                    width: a.width,
                    height: a.height
                });
                if (this.windowRectChanged != null) {
                    this.windowRectChanged(this, EventArgs.empty);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSliderWidget.prototype, "d", {
        get: function () {
            return this.i("startInset");
        },
        set: function (a) {
            this.n("startInset", a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSliderWidget.prototype, "c", {
        get: function () {
            return this.i("endInset");
        },
        set: function (a) {
            this.n("endInset", a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSliderWidget.prototype, "f", {
        get: function () {
            return this.i("trackStartInset");
        },
        set: function (a) {
            this.n("trackStartInset", a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSliderWidget.prototype, "e", {
        get: function () {
            return this.i("trackEndInset");
        },
        set: function (a) {
            this.n("trackEndInset", a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSliderWidget.prototype, "b", {
        get: function () {
            return this.i("barExtent");
        },
        set: function (a) {
            this.n("barExtent", a);
        },
        enumerable: true,
        configurable: true
    });
    ZoomSliderWidget.prototype.i = function (a) {
        return this.j[a];
    };
    ZoomSliderWidget.prototype.n = function (a, b) {
        this.j[a] = b;
    };
    ZoomSliderWidget.prototype.hide = function () {
        this.h.hide();
    };
    ZoomSliderWidget.prototype.show = function () {
        this.h.show();
    };
    ZoomSliderWidget.prototype.m = function () {
        this.j.i.notifySizeChanged();
    };
    ZoomSliderWidget.$t = markType(ZoomSliderWidget, 'ZoomSliderWidget');
    return ZoomSliderWidget;
}(Base));
export { ZoomSliderWidget };
//# sourceMappingURL=ZoomSliderWidget.js.map