import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialIndicatorComponent } from './igx-financial-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { MassIndexIndicator } from "./MassIndexIndicator";
/**
 * Represents a IgxDataChartComponent Mass Index indicator series.
 * Default required members: High, Low
*/
export var IgxMassIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }];
var IgxMassIndexIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxMassIndexIndicatorComponent, _super);
    function IgxMassIndexIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxMassIndexIndicatorComponent.prototype.createImplementation = function () {
        return new MassIndexIndicator();
    };
    Object.defineProperty(IgxMassIndexIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxMassIndexIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-mass-index-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxMassIndexIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxMassIndexIndicatorComponent.ctorParameters = function () { return []; };
    return IgxMassIndexIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxMassIndexIndicatorComponent };
//# sourceMappingURL=igx-mass-index-indicator-component.js.map