import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxItemwiseStrategyBasedIndicatorComponent } from './igx-itemwise-strategy-based-indicator-component';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialIndicatorComponent } from './igx-financial-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { MedianPriceIndicator } from "./MedianPriceIndicator";
/**
 * Represents a IgxDataChartComponent Median Price indicator series.
 * Default required members: High, Low
*/
export var IgxMedianPriceIndicatorComponent_PROVIDERS = [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }];
var IgxMedianPriceIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxMedianPriceIndicatorComponent, _super);
    function IgxMedianPriceIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxMedianPriceIndicatorComponent.prototype.createImplementation = function () {
        return new MedianPriceIndicator();
    };
    Object.defineProperty(IgxMedianPriceIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxMedianPriceIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-median-price-indicator',
                    template: "",
                    providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxMedianPriceIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxMedianPriceIndicatorComponent.ctorParameters = function () { return []; };
    return IgxMedianPriceIndicatorComponent;
}(IgxItemwiseStrategyBasedIndicatorComponent));
export { IgxMedianPriceIndicatorComponent };
//# sourceMappingURL=igx-median-price-indicator-component.js.map