import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxNumericYAxisComponent } from './igx-numeric-y-axis-component';
import { IgxStraightNumericAxisBaseComponent } from './igx-straight-numeric-axis-base-component';
import { IgxNumericAxisBaseComponent } from './igx-numeric-axis-base-component';
import { IgxAxisComponent } from './igx-axis-component';
import { PercentChangeYAxis } from "./PercentChangeYAxis";
/**
 * A horizontal axis that uses a DateTime scale.
*/
export var IgxPercentChangeYAxisComponent_PROVIDERS = [{ provide: IgxNumericYAxisComponent, useExisting: forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }];
var IgxPercentChangeYAxisComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxPercentChangeYAxisComponent, _super);
    function IgxPercentChangeYAxisComponent() {
        return _super.call(this) || this;
    }
    IgxPercentChangeYAxisComponent.prototype.createImplementation = function () {
        return new PercentChangeYAxis();
    };
    Object.defineProperty(IgxPercentChangeYAxisComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxPercentChangeYAxisComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-percent-change-y-axis',
                    template: "",
                    providers: [{ provide: IgxNumericYAxisComponent, useExisting: forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxPercentChangeYAxisComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxPercentChangeYAxisComponent.ctorParameters = function () { return []; };
    return IgxPercentChangeYAxisComponent;
}(IgxNumericYAxisComponent));
export { IgxPercentChangeYAxisComponent };
//# sourceMappingURL=igx-percent-change-y-axis-component.js.map