import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxHorizontalAnchoredCategorySeriesComponent } from './igx-horizontal-anchored-category-series-component';
import { IgxAnchoredCategorySeriesComponent } from './igx-anchored-category-series-component';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { PointSeries } from "./PointSeries";
/**
 * Represents a IgxDataChartComponent point series.
*/
export var IgxPointSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }];
var IgxPointSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxPointSeriesComponent, _super);
    function IgxPointSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxPointSeriesComponent.prototype.createImplementation = function () {
        return new PointSeries();
    };
    Object.defineProperty(IgxPointSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPointSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
        get: function () {
            return this.i.cw;
        },
        enumerable: true,
        configurable: true
    });
    IgxPointSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-point-series',
                    template: "",
                    providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPointSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxPointSeriesComponent.ctorParameters = function () { return []; };
    return IgxPointSeriesComponent;
}(IgxHorizontalAnchoredCategorySeriesComponent));
export { IgxPointSeriesComponent };
//# sourceMappingURL=igx-point-series-component.js.map