/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting_$type } from "./IUnknownValuePlotting";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting_$type } from "./UnknownValuePlotting";
import { DependencyProperty } from "./DependencyProperty";
import { Type, typeCast, runOn, enumGetBox, markType } from "./type";
import { Path } from "./Path";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "./PropertyMetadata";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "./Color";
export class AreaSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.px = null;
        this.px = new CategoryLineRasterizer();
        this.ab = AreaSeries.$;
        this.pg = 0;
    }
    be() {
        return new AreaSeriesView(this);
    }
    mv() {
        return 1;
    }
    h9(a) {
        super.h9(a);
        this.pw = a;
    }
    get_ci() {
        return true;
    }
    get ci() {
        return this.get_ci();
    }
    preferredCategoryMode(a) {
        return this.pg;
    }
    dd(a, b) {
        let c = this.k0(this.k3(a), true, false);
        if (this.pn(a, c, b)) {
            return true;
        }
        if (this.dc(a, b)) {
            return true;
        }
        if (this.lj(a, b)) {
            return true;
        }
        return false;
    }
    he(a, b) {
        super.he(a, b);
        let c = b;
        c.c5();
    }
    n2(a, b) {
        super.n2(a, b);
        let c = b.cl.d;
        let d = typeCast(AreaSeriesView.$, b);
        let e = a.f;
        let f = this.getEffectiveViewport1(d);
        this.mt.x(this, this.ne(), this.pd, runOn(this, this.mf), this.nm(b), this.nn(b));
        let g = false;
        let h = this.mt.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            let i = new ScalerParams(0, b.bq, b.bp, this.pd.bz, f);
            this.ny(e, -1, this.valueColumn.count, this.pd, i, b.n);
        }
        let j = d.dc;
        let k = d.dd;
        let l = d.df;
        let m = d.dh;
        this.mt.ae(j, true, false, true, true);
        this.mt.ae(k, true, false, true, true);
        this.mt.ae(l, false, true, false, false);
        this.mt.ae(m, false, true, false, false);
        if (b.cp(a)) {
            d.c7(e.count, e, true, c, this.ej, (n, o, p, q, r) => this.oy(n, a.f.count, b), this.unknownValuePlotting, e.count == 1 ? null : this.od(e, e.count - 1, b.bp, b.bq, true));
            b.cs(a);
        }
        let n = this.fetchYAxis();
        l._opacity = this.mt.i * this.dy;
        m._opacity = 0.5 * this.mt.i * this.dy;
    }
    ie(a, b, c, d) {
        super.ie(a, b, c, d);
        switch (b) {
            case AreaSeries.$$p[0]:
                this.mq.m = this.unknownValuePlotting == 0;
                this.it(false);
                this.h1();
                break;
        }
    }
    get useHighMarkerFidelity() {
        return this.nh;
    }
}
AreaSeries.$t = markType(AreaSeries, 'AreaSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
Type.dep(DependencyProperty, PropertyMetadata, AreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting::pz', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
export class AreaSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c4 = null;
        this.de = new Path();
        this.di = new Path();
        this.dg = new Path();
        this.dj = new Path();
        this.c8 = new Path();
        this.da = new Path();
        this.c9 = new Path();
        this.db = new Path();
        this.c4 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bi = 1;
        }
    }
    get dc() {
        return this.di;
    }
    get dd() {
        return this.dj;
    }
    get df() {
        return this.de;
    }
    get dh() {
        return this.dg;
    }
    c5() {
        this.de.aj = null;
        this.dg.aj = null;
        this.di.aj = null;
        this.dj.aj = null;
        this.an();
    }
    c6(a, b, c, d, e, f, g) {
        this.c7(a, b, c, d, e, f, g, null);
    }
    c7(a, b, c, d, e, f, g, h) {
        this.c4.px.a = typeCast(ISortingAxis_$type, this.cn.fetchXAxis()) !== null ? true : false;
        this.c4.px.j(this.de, this.di, this.dg, this.dj, a, b, c, d, e, f, g, h);
        this.an();
    }
    a9() {
        super.a9();
        this.c8.aj = this.de.aj;
        this.da.aj = this.di.aj;
        this.c9.aj = this.dg.aj;
        this.db.aj = this.dj.aj;
        let a = this.bk();
        this.c8._fill = a;
        this.c8._opacity = 1;
        this.c9._fill = a;
        this.c9._opacity = 1;
        this.da._stroke = a;
        this.da.ac = this.e.en + 3;
        this.db._stroke = a;
        this.db.ac = this.e.en + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            a.s(this.c8);
            a.s(this.c9);
            a.s(this.da);
            a.s(this.db);
        }
        else {
            a.s(this.de);
            a.s(this.dg);
            a.s(this.di);
            a.s(this.dj);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a1.exportPathData(a, this.di, "lowerShape", ["Lower"]);
        this.e.a1.exportPathData(a, this.dj, "upperShape", ["Upper", "Main"]);
        this.e.a1.exportPathData(a, this.dg, "translucentShape", ["Translucent"]);
        this.e.a1.exportPathData(a, this.de, "fillShape", ["Fill"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kp = a;
        this.e.ek = 5;
        this.e.el = 1;
        this.e.em = -3;
    }
}
AreaSeriesView.$t = markType(AreaSeriesView, 'AreaSeriesView', AnchoredCategorySeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.AreaSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AreaSeries" />*/
//# sourceMappingURL=AreaSeries_combined.js.map