/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "./type";
import { Brush } from "./Brush";
export class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_pp() {
        return new FullStochasticOscillatorIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return FullStochasticOscillatorIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get qa() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.qf));
    }
    set qa(a) {
        this.h(FullStochasticOscillatorIndicator.qf, a);
    }
    pv() {
        return this.qa;
    }
    p4(a) {
        this.qa = a;
    }
    get smoothingPeriod() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.qg));
    }
    set smoothingPeriod(a) {
        this.h(FullStochasticOscillatorIndicator.qg, a);
    }
    px() {
        return this.smoothingPeriod;
    }
    get qc() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.qh));
    }
    set qc(a) {
        this.h(FullStochasticOscillatorIndicator.qh, a);
    }
    pu() {
        return this.qc;
    }
    o5() {
        return this.qc;
    }
}
FullStochasticOscillatorIndicator.qf = StrategyBasedIndicator.p7(14, FullStochasticOscillatorIndicator.$);
FullStochasticOscillatorIndicator.qg = StrategyBasedIndicator.p8(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
FullStochasticOscillatorIndicator.qh = StrategyBasedIndicator.p8(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.FullStochasticOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FullStochasticOscillatorIndicator" />*/
//# sourceMappingURL=FullStochasticOscillatorIndicator.js.map