/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "./DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Type, Point_$type, runOn, typeCast, markType } from "./type";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "./PropertyMetadata";
export class HorizontalRangeCategorySeries extends RangeCategorySeries {
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    hc() {
        super.hc();
        this.xAxis = null;
        this.yAxis = null;
    }
    ag(a) {
        let b = this.ai(this.ml(), this.mm.f, this.nm(this.bh), this.nn(this.bh), this.k3(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    }
    ah(a) {
        let b = this.ai(this.ml(), this.mm.f, this.nm(this.bh), this.nn(this.bh), this.k3(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    get_c1() {
        return true;
    }
    get c1() {
        return this.get_c1();
    }
    bc() {
        if (this.bd == 0) {
            return 1;
        }
        else {
            return super.bc();
        }
    }
    getOffsetValue() {
        return this.RangeFramePreparer.r(this.xAxis, this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    }
    getCategoryWidth() {
        return this.xAxis.getCategorySize(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    }
    e1(a, b) {
        return this.e2(a, b, this.xAxis, runOn(this, this.nk), new RangeValueList(this.highColumn, this.lowColumn));
    }
    e3(a, b) {
        return this.e4(a, b, this.xAxis, runOn(this, this.nk), new RangeValueList(this.highColumn, this.lowColumn));
    }
    d0(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.xAxis.ja;
        return this.d1(a, b, this.xAxis, d, e, f, runOn(this, this.nk));
    }
    ed(a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bh);
        let e = new ScalerParams(0, this.br.mk, this.bh.bp, this.xAxis.bz, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.br.mk, this.bh.bp, d);
        return this.ef(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.nk), b, c);
    }
    eb(a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bh);
        let e = new ScalerParams(0, this.br.mk, this.bh.bp, this.xAxis.bz, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.br.mk, this.bh.bp, d);
        return this.ef(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.nk), b, c);
    }
    d9(a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bh);
        let e = new ScalerParams(0, this.br.mk, this.bh.bp, this.xAxis.bz, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.br.mk, this.bh.bp, d);
        return this.ef(this.highColumn, a, this.xAxis, e, f, runOn(this, this.nk), b, c);
    }
    kw(a, b, c) {
        return this.k2(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.yAxis, this.xAxis, runOn(this, this.d9), (d, e) => this.e4(d, e, this.xAxis, runOn(this, this.nk), this.highColumn), (d, e) => this.e2(d, e, this.xAxis, runOn(this, this.nk), this.highColumn));
    }
    ky(a, b, c) {
        return this.k2(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.yAxis, this.xAxis, runOn(this, this.eb), (d, e) => this.e4(d, e, this.xAxis, runOn(this, this.nk), this.lowColumn), (d, e) => this.e2(d, e, this.xAxis, runOn(this, this.nk), this.lowColumn));
    }
    k0(a, b, c) {
        return this.k2(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.yAxis, this.xAxis, null, null, null);
    }
    ng() {
        return this.yAxis != null && this.yAxis.cb();
    }
    ie(a, b, c, d) {
        super.ie(a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.hi(typeCast(Axis.$, c));
                this.ik(typeCast(Axis.$, d));
                this.mu.cl.g(this.ej);
                this.it(false);
                this.h1();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.hi(typeCast(Axis.$, c));
                this.ik(typeCast(Axis.$, d));
                this.mu.cl.g(this.ej);
                this.ng();
                this.it(false);
                this.h1();
                break;
        }
    }
    ou(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    ot(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.bw) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.nh;
    }
}
HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::ox', [CategoryAxisBase.$, null], 'YAxis::oy', [NumericYAxis.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
//# sourceMappingURL=HorizontalRangeCategorySeries.js.map