/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { NumericScaler } from "./NumericScaler";
import { AutoRangeCalculator } from "./AutoRangeCalculator";
import { markType } from "./type";
export class LinearScaler extends NumericScaler {
    t(a, b, c, d, e) {
        let f;
        let g;
        let h = AutoRangeCalculator.a(a, b, c, false, -1, f, g);
        f = h.p5;
        g = h.p6;
        d = f;
        e = g;
        return {
            p3: d,
            p4: e
        };
    }
}
LinearScaler.$t = markType(LinearScaler, 'LinearScaler', NumericScaler.$);
//# sourceMappingURL=LinearScaler.js.map