/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { PercentageVolumeOscillatorIndicatorStrategy } from "./PercentageVolumeOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "./type";
export class PercentageVolumeOscillatorIndicator extends StrategyBasedIndicator {
    get_pp() {
        return new PercentageVolumeOscillatorIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return PercentageVolumeOscillatorIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get shortPeriod() {
        return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.qb));
    }
    set shortPeriod(a) {
        this.h(PercentageVolumeOscillatorIndicator.qb, a);
    }
    px() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.qa));
    }
    set longPeriod(a) {
        this.h(PercentageVolumeOscillatorIndicator.qa, a);
    }
    pu() {
        return this.longPeriod;
    }
}
PercentageVolumeOscillatorIndicator.qb = StrategyBasedIndicator.p9(10, PercentageVolumeOscillatorIndicator.$);
PercentageVolumeOscillatorIndicator.qa = StrategyBasedIndicator.p5(30, PercentageVolumeOscillatorIndicator.$);
PercentageVolumeOscillatorIndicator.$t = markType(PercentageVolumeOscillatorIndicator, 'PercentageVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
/*<BeginStatics Name="Infragistics.Controls.Charts.PercentageVolumeOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.PercentageVolumeOscillatorIndicator" />*/
//# sourceMappingURL=PercentageVolumeOscillatorIndicator.js.map