/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ItemwiseIndicatorCalculationStrategy } from "./ItemwiseIndicatorCalculationStrategy";
import { String_$type, markType } from "./type";
import { List$1 } from "./List$1";
export class WeightedCloseIndicatorStrategy extends ItemwiseIndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("CloseColumn");
        return c;
    }
    a(a, b, c) {
        a.indicatorColumn.item(c, (a.highColumn.item(c) + a.lowColumn.item(c) + (a.closeColumn.item(c) * 2)) / 4);
        return true;
    }
}
WeightedCloseIndicatorStrategy.$t = markType(WeightedCloseIndicatorStrategy, 'WeightedCloseIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);
//# sourceMappingURL=WeightedCloseIndicatorStrategy.js.map