import { Type } from '@angular/core';
import { IgxStraightNumericAxisBaseComponent } from './igx-straight-numeric-axis-base-component';
import { IgxAxisComponent } from './igx-axis-component';
import { NumericXAxis } from "./NumericXAxis";
/**
 * Represents a IgxDataChartComponent numeric X axis.
*/
export declare const IgxNumericXAxisComponent_PROVIDERS: {
    provide: typeof IgxAxisComponent;
    useExisting: Type<any>;
}[];
export declare class IgxNumericXAxisComponent extends IgxStraightNumericAxisBaseComponent {
    protected createImplementation(): NumericXAxis;
    readonly i: NumericXAxis;
    constructor();
    scrollRangeIntoView(minimum: number, maximum: number): void;
}
