import { Type } from '@angular/core';
import { IgxLegendBaseComponent } from './igx-legend-base-component';
import { ScaleLegend } from "./ScaleLegend";
/**
 * Represents a legend that indicates the size and the color scale for a collection of series.
*/
export declare const IgxScaleLegendComponent_PROVIDERS: {
    provide: typeof IgxLegendBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxScaleLegendComponent extends IgxLegendBaseComponent {
    protected createImplementation(): ScaleLegend;
    readonly i: ScaleLegend;
    constructor();
}
