/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "./DVContainer";
import { Type, enumGetBox, typeCast, Point_$type, markType } from "./type";
import { DependencyProperty } from "./DependencyProperty";
import { TrendLineType_$type } from "./TrendLineType";
import { Brush } from "./Brush";
import { PenLineCap_$type } from "./PenLineCap";
import { DoubleCollection } from "./DoubleCollection";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { Rect } from "./Rect";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_ } from "./number";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
var AnchoredCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredCategorySeries, _super);
    function AnchoredCategorySeries() {
        var _this = _super.call(this) || this;
        _this.oi = null;
        _this.om = false;
        _this.ok = null;
        _this.of = null;
        _this.op = null;
        _this.mq = new CategoryFramePreparer(1, _this, _this.mu, _this, _this, _this.mu.cl);
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeries.prototype, "oj", {
        get: function () {
            var _this = this;
            if (this.oi == null) {
                this.oi = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b1.n; });
            }
            return this.oi;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.be = function () {
        var a = new AnchoredCategorySeriesView(this);
        return a;
    };
    AnchoredCategorySeries.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        this.oe = a;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "valueColumn", {
        get: function () {
            return this.ok;
        },
        set: function (a) {
            if (this.ok != a) {
                var b = this.ok;
                this.ok = a;
                if (!this.om) {
                    this.raisePropertyChanged("ValueColumn", b, this.ok);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "pa", {
        get: function () {
            return this.c(AnchoredCategorySeries.oz);
        },
        set: function (a) {
            this.h(AnchoredCategorySeries.oz, a);
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.c5 = function (a) {
        var b = new Rect(0, 0, 0, 1, 1);
        var c = this.fetchXAxis();
        var d = this.fetchYAxis();
        var e = this.k7(this.bh);
        var f = c != null ? this.mq.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
        return this.oj.c$a(this, this.valueColumn, c, d, f, a);
    };
    AnchoredCategorySeries.prototype.ob = function (a, b, c) {
        if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.b3;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.by.item(g);
        }
        return d;
    };
    AnchoredCategorySeries.prototype.ie = function (a, b, c, d) {
        _super.prototype.ie.call(this, a, b, c, d);
        if (this.oe.cx && this.oe.cw.g$b(a, b, c, d)) {
            this.it(false);
            this.h1();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.valueColumn);
                    this.valueColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.valueColumn = this.bv(this.ot);
                }
                var e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (e != null && !e.cb()) {
                    this.oe.cl.g(this.ej);
                    this.it(false);
                }
                break;
            case AnchoredCategorySeries.$$p[2]:
                if (this.by != null) {
                    this.by.deregisterColumn(this.valueColumn);
                    this.valueColumn = this.bv(this.ot);
                }
                this.op = this.ot;
                break;
            case "ValueColumn":
                if (this.oe.cx) {
                    this.oe.cw.g$i();
                }
                var f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (f != null && !f.cb()) {
                    this.oe.cl.g(this.ej);
                    this.it(false);
                }
                break;
            case "TrendLineBrush":
                this.i4();
                break;
            case "ErrorBarSettings":
                this.it(false);
                break;
            case "TrendLineType":
                this.h1();
                break;
            case AnchoredCategorySeries.$$p[1]:
                this.it(false);
                break;
        }
    };
    AnchoredCategorySeries.prototype.am = function (a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    };
    AnchoredCategorySeries.prototype.hh = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.oe.cl.g(this.ej);
                break;
        }
        if (this.oe.cx) {
            this.oe.cw.g$e(a, b, c, d);
        }
    };
    AnchoredCategorySeries.prototype.nl = function () {
        return this.on(this.mu);
    };
    AnchoredCategorySeries.prototype.on = function (a) {
        var b = 0;
        var c = a.bq;
        var d = a.bp;
        var e = this.getEffectiveViewport1(a);
        var f = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!c.isEmpty && !d.isEmpty && f != null) {
            var g = new ScalerParams(0, c, d, f.bz, e);
            b = f.dj(f.jq, g);
        }
        return b;
    };
    AnchoredCategorySeries.prototype.oy = function (a, b, c) {
        var d = this.on(c);
        if (a.count > 0) {
            var e = d;
            a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
            a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
        }
    };
    AnchoredCategorySeries.prototype.oc = function (a, b, c, d) {
        return this.od(a, b, c, d, false);
    };
    AnchoredCategorySeries.prototype.od = function (a, b, c, d, e) {
        return CategorySeries.mg(a, b, c, d, e);
    };
    AnchoredCategorySeries.prototype.ds = function (a, b, c) {
        var d = _super.prototype.ds.call(this, a, b, c);
        var e = c;
        if (this.valueColumn == null || this.valueColumn.count == 0 || e.cl.d < 1) {
            d = false;
        }
        return d;
    };
    AnchoredCategorySeries.prototype.he = function (a, b) {
        _super.prototype.he.call(this, a, b);
        var c = b;
        c.cr();
        if (c.cx) {
            c.cw.g$d();
        }
    };
    AnchoredCategorySeries.prototype.nz = function (a, b) {
        _super.prototype.nz.call(this, a, b);
        this.mr(b).d(a, b);
    };
    AnchoredCategorySeries.prototype.n2 = function (a, b) {
        _super.prototype.n2.call(this, a, b);
        var c = typeCast(AnchoredCategorySeriesView.$, b);
        c.by = true;
        if (c.cx) {
            c.cw.g$g(a.p);
        }
        if (this.li()) {
            CategoryMarkerManager.b(this, a.m, b.co, this.lk);
            this.nw(b, a);
            b.ch();
        }
        this.ov(a, b);
    };
    AnchoredCategorySeries.prototype.is = function (a, b, c, d, e) {
        _super.prototype.is.call(this, a, b, c, d, e);
        var f = this.az.a$h.item(d);
        var g = f;
        g.cl.g(this.ej);
        f.ay(c);
        if (this.cb(g)) {
            return;
        }
        if (this.of == null) {
            this.of = new CategoryFrame(3);
        }
        this.of.u();
        this.nz(this.of, g);
        this.n2(this.of, g);
    };
    AnchoredCategorySeries.prototype.ov = function (a, b) {
    };
    AnchoredCategorySeries.prototype.i4 = function () {
        _super.prototype.i4.call(this);
        if (this.e6 < 0) {
            return;
        }
        this.oe.c1();
        if (this.trendLineBrush != null) {
            this.oe.cz();
        }
        else {
            this.oe.cy();
        }
    };
    AnchoredCategorySeries.prototype.fh = function (a, b) {
        if (this.oe.cx && a == this.oe.cw.g$j) {
            return null;
        }
        return _super.prototype.fh.call(this, a, b);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "scaler", {
        get: function () {
            return typeCast(ICategoryScaler_$type, this.fetchXAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "yScaler", {
        get: function () {
            return typeCast(IScaler_$type, this.fetchYAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "bucketizer", {
        get: function () {
            return this.oe.cl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentMode2Index", {
        get: function () {
            return this.no();
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.provideCollisionDetector = function () {
        if (this.og == 1) {
            return new CollisionAvoider();
        }
        return NonCollisionAvoider.a;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "trendlinePreparer", {
        get: function () {
            return this.oe.cx ? this.oe.cw : null;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.hn = function (a) {
        _super.prototype.hn.call(this, a);
        if (this.oe.cx) {
            this.a1.exportTrendlineData(this, a, this.oe.cw.g$j);
        }
    };
    AnchoredCategorySeries.prototype.fe = function (a) {
        var _this = this;
        var b = this.fetchXAxis();
        var c = this.fetchYAxis();
        return this.oj.c$b(this, a, this.nm(this.bh), this.valueColumn, b, c, this.oh == 1, function (d) { return _super.prototype.fe.call(_this, d); });
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "mayContainUnknowns", {
        get: function () {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.d8 = function () {
        return this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(0);
    };
    AnchoredCategorySeries.prototype.an = function () {
        if (this.valueColumn == null) {
            return null;
        }
        var a = this.ml();
        var b = new ScalerParams(0, this.br.mk, this.br.mx, a.bz, this.getEffectiveViewport());
        var c = (a.dm(this.br.mx.left, b));
        var d = (a.dm(this.br.mx.right, b));
        var e = null;
        if (a.b3) {
            e = a;
            c = e.i$f(c);
            d = e.i$f(d);
        }
        else {
            c = Math.floor(c);
            d = Math.ceil(d);
        }
        if (isNaN_(c) || isNaN_(d)) {
            return null;
        }
        c = Math.max(0, Math.min(this.valueColumn.count - 1, c));
        d = Math.max(0, Math.min(this.valueColumn.count - 1, d));
        var f = 1.7976931348623157E+308;
        var g = -1.7976931348623157E+308;
        for (var h = truncate(c); h <= truncate(d); h++) {
            var i = h;
            if (e != null) {
                i = e.i$b._inner[h];
            }
            f = Math.min(f, this.valueColumn.item(i));
            g = Math.max(g, this.valueColumn.item(i));
        }
        return new AxisRange(f, g);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.oz = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    return AnchoredCategorySeries;
}(CategorySeries));
export { AnchoredCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:oh:o0', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:og:o1', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:ot:o9', [2, null], 'TrendLineType::o7', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::o6', [1, 1.5], 'TrendLinePeriod::o5', [1, 7], 'TrendLineBrush::o2', [Brush.$, null], 'TrendLineZIndex:oo:o8', [1, 1001], 'TrendLineDashArray:pb:o3', [DoubleCollection.$], 'TrendLineDashCap:pc:o4', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
var AnchoredCategoryBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredCategoryBucketCalculator, _super);
    function AnchoredCategoryBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.i = null;
        _this.h = null;
        _this.j = 0;
        _this.i = a;
        return _this;
    }
    AnchoredCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 1.7976931348623157E+308;
        var h = -1.7976931348623157E+308;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.getBucket = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 0;
        var h = 0;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            if (!i) {
                if (!isNaN_(k)) {
                    g = g < k ? g : k;
                    h = h > k ? h : k;
                }
            }
            else {
                if (!isNaN_(k)) {
                    g = k;
                    h = k;
                    i = false;
                }
            }
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.cacheValues = function () {
        this.j = this.i.cu.valueColumn.count;
        this.h = this.i.cu.valueColumn.asArray();
    };
    AnchoredCategoryBucketCalculator.prototype.unCacheValues = function () {
        this.h = null;
    };
    AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
}(CategoryBucketCalculator));
export { AnchoredCategoryBucketCalculator };
var AnchoredCategorySeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredCategorySeriesView, _super);
    function AnchoredCategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cu = null;
        _this.cv = null;
        _this.cu = a;
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "cw", {
        get: function () {
            if (this.cv == null) {
                this.cv = CategoryTrendLineManagerFactory.a(this.cv, this.e.ao(), this.e.jc, this.e, this.e.b1);
            }
            return this.cv;
        },
        set: function (a) {
            this.cv = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "cx", {
        get: function () {
            return this.cv != null;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeriesView.prototype.c1 = function () {
        this.cu.pa = null;
    };
    AnchoredCategorySeriesView.prototype.cz = function () {
        this.cu.pa = this.cu.trendLineBrush;
    };
    AnchoredCategorySeriesView.prototype.cy = function () {
        this.cu.pa = this.cu.ki;
    };
    AnchoredCategorySeriesView.prototype.cm = function () {
        return new AnchoredCategoryBucketCalculator(this);
    };
    AnchoredCategorySeriesView.prototype.c0 = function () {
        this.cl.cacheValues();
    };
    AnchoredCategorySeriesView.prototype.c2 = function () {
        this.cl.unCacheValues();
    };
    AnchoredCategorySeriesView.prototype.c3 = function (a) {
        var b = this.co.item(a);
        return this.ck(b);
    };
    AnchoredCategorySeriesView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.cu.trendLineType != 0 && !b) {
                var c = this.cw.g$j;
                c.ac = this.cu.trendLineThickness;
                c._stroke = this.cu.pa;
                c.ai = this.cu.pb;
                c.ad = this.cu.pc;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    AnchoredCategorySeriesView.prototype.getDefaultTooltipTemplate = function () {
        return this.cu.oj.c$c(this.e, this.cu.ot);
    };
    AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
}(CategorySeriesView));
export { AnchoredCategorySeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.AnchoredCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AnchoredCategorySeries" />*/
//# sourceMappingURL=AnchoredCategorySeries_combined.js.map