/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { typeCast, Type, markType, Point_$type, typeGetValue, fromEnum, runOn, Number_$type } from "./type";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "./Rect";
import { Extensions } from "./Extensions";
import { Axis } from "./Axis";
import { List$1 } from "./List$1";
import { LabelPosition } from "./LabelPosition";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler_$type } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "./DependencyProperty";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { AxisLabelManager } from "./AxisLabelManager";
import { ViewportUtils } from "./ViewportUtils";
import { RadialAxisRenderingParameters } from "./RadialAxisRenderingParameters";
import { CategoryTickmarkValues } from "./CategoryTickmarkValues";
import { MathUtil } from "./MathUtil";
import { SeriesViewer } from "./SeriesViewer";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "./PropertyMetadata";
import { isNaN_, isInfinity } from "./number";
import { NumericAxisBase } from "./NumericAxisBase";
import { LogarithmicTickmarkValues } from "./LogarithmicTickmarkValues";
import { PolarAxisRenderingParameters } from "./PolarAxisRenderingParameters";
import { RadialAxisLabelPanel } from "./RadialAxisLabelPanel";
import { LinearTickmarkValues } from "./LinearTickmarkValues";
import { RangeInfo } from "./RangeInfo";
import { IPolarRadialRenderingParameters_$type } from "./IPolarRadialRenderingParameters";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
var AngleAxisLabelPanel = /** @class */ (function (_super) {
    tslib_1.__extends(AngleAxisLabelPanel, _super);
    function AngleAxisLabelPanel() {
        var _this = _super.call(this) || this;
        _this.cr = false;
        _this.cx = null;
        _this.cv = 0;
        _this.cs = 0;
        _this.cu = 0;
        _this.ct = 0;
        return _this;
    }
    AngleAxisLabelPanel.prototype.ad = function () {
        return new AngleAxisLabelPanelView(this);
    };
    AngleAxisLabelPanel.prototype.b6 = function (a) {
        _super.prototype.b6.call(this, a);
        this.cq = a;
    };
    AngleAxisLabelPanel.prototype.ao = function (a, b) {
        if (!Extensions.b(b)) {
            return false;
        }
        if (this.ac == null || this.ac.ib.isEmpty) {
            return _super.prototype.ao.call(this, a, b);
        }
        return true;
    };
    AngleAxisLabelPanel.prototype.ay = function () {
        var a = new List$1(Rect.$, 0);
        if (this.a3.count != this.a2.count) {
            return a;
        }
        this.cq.aw(a);
        var b = false;
        this.am = this.al(a);
        if (!this.ac.br()) {
            b = true;
            this.a7 = this.cv / 2;
            this.a7 = this.a7 + this.cw();
        }
        else {
            b = true;
            this.cq.ab();
        }
        if (b) {
            for (var c = 0; c < a.count; c++) {
                var d = this.a3._inner[c];
                var e = this.a2._inner[c];
                var f = a._inner[c];
                var g = this.cx(e.a);
                var h = g.x - this.ba(d) / 2;
                var i = g.y - this.a9(d) / 2;
                f.x = h;
                f.y = i;
                a._inner[c] = f;
            }
        }
        return a;
    };
    AngleAxisLabelPanel.prototype.cw = function () {
        var a;
        var b;
        b = this.ac;
        a = null;
        if (b != null) {
            a = typeCast(XamDataChart.$, b.a9);
        }
        if (a == null || b == null) {
            return 0;
        }
        var c = new List$1(Axis.$, 0);
        for (var d = 0; d < a.axes.count; d++) {
            var e = a.axes._inner[d];
            if ((typeCast(NumericAngleAxis.$, e) !== null || typeCast(CategoryAngleAxis.$, e) !== null) && typeCast(AngleAxisLabelPanel.$, e.ap) !== null && e.ap.a3.count > 0 && (!e.br()) && !e.bq() && (e.ag == null || this.ac.ag == null || e.ag.kv == b.ag.kv)) {
                c.add(e);
            }
        }
        var f = c.indexOf(b);
        if (f == -1) {
            return 0;
        }
        var g = 0;
        var h = 5;
        if (f == 0) {
            g += h;
        }
        else {
            g += c._inner[f - 1].ap.a7;
            g += c._inner[f].ap.a7 * 2 + h;
        }
        return g;
    };
    AngleAxisLabelPanel.prototype.ah = function () {
        return 4;
    };
    AngleAxisLabelPanel.prototype.as = function (a) {
        return a == 4 || a == 5;
    };
    AngleAxisLabelPanel.$t = markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
    return AngleAxisLabelPanel;
}(AxisLabelPanelBase));
export { AngleAxisLabelPanel };
var CategoryAngleAxis = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryAngleAxis, _super);
    function CategoryAngleAxis() {
        var _this = _super.call(this) || this;
        _this.ke = null;
        _this.kb = null;
        _this.kf = false;
        _this.kj = NaN;
        _this.kc = null;
        _this.kk = 0;
        _this.kh = 0;
        _this.ki = 0;
        _this.kv = 1;
        _this.ab = CategoryAngleAxis.$;
        _this.kb = _this.ka();
        _this.ke = new PolarAxisRenderingManager();
        return _this;
    }
    CategoryAngleAxis.prototype.ax = function () {
        return new CategoryAngleAxisView(this);
    };
    CategoryAngleAxis.prototype.f5 = function (a) {
        _super.prototype.f5.call(this, a);
        this.j9 = a;
    };
    CategoryAngleAxis.prototype.get_bs = function () {
        return true;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "bs", {
        get: function () {
            return this.get_bs();
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.ao = function () {
        var _this = this;
        var a = new AngleAxisLabelPanel();
        a.cx = function (b) {
            var c = _this.a9 != null ? _this.a9.mk : Rect.empty;
            var d = !c.isEmpty ? _this.ib : Rect.empty;
            return _this.k8(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, _this.ap.a7);
        };
        return a;
    };
    CategoryAngleAxis.prototype.kt = function (a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    };
    CategoryAngleAxis.prototype.ka = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new AxisLabelManager();
            $ret.a = _this;
            $ret.f = _this.ck;
            $ret.e = _this.cj;
            $ret.b = _this.ap;
            return $ret;
        })());
        if (this.as != null) {
            this.as.registerAxis(this);
        }
        var b = new CategoryAxisRenderer(a);
        b.u = function () {
            var c = _this.ay.at();
            var d = _this.ay.aw();
            var e = _this.ay.au();
            var f = _this.ay.av();
            _this.gr();
            _this.fv(c);
            _this.fv(d);
            _this.fv(e);
            _this.fv(f);
        };
        b.o = function (c, d) { return !d.isEmpty && !c.isEmpty && _this.kd != null; };
        b.d = function (c, d, e, f) { return _this.j8(c, d, e, f); };
        b.v = function () {
            if (!_this.kf) {
                _this.kf = true;
                _this.kd.cb();
                _this.kf = false;
            }
        };
        b.g = function (c) {
            var d = typeGetValue(c);
            if (d > _this.ir.count - 1) {
                d -= _this.ir.count;
            }
            var e = _this.ir.item(d);
            return _this.eq(e);
        };
        b.b.c = function (c) {
            if ((_this.as == null || _this.as.visibility == 0) && _this.kd != null && _this.kj != c) {
                var d = typeCast(XamDataChart.$, _this.a9);
                if (d == null) {
                    return;
                }
                _this.kj = c;
                _this.ap.a6 = c;
                d.hp();
                try {
                    for (var _a = tslib_1.__values(fromEnum(d.axes)), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var e = _b.value;
                        if (e != _this && typeCast(AngleAxisLabelPanel.$, e.ap) !== null) {
                            e.ay.y();
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            var e_1, _c;
        };
        b.k = function (c, d, e) {
            var f = typeCast(RadialAxisRenderingParameters.$, c);
            _this.ke.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
        };
        b.l = function (c, d, e, f) {
            var g = typeCast(RadialAxisRenderingParameters.$, c);
            _this.ke.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
        };
        b.m = function (c, d) { return _this.getScaledAngle(d); };
        b.q = function (c, d) {
            if (_this.kt(d - _this.kk) < 0) {
                return false;
            }
            if (_this.kt(d - _this.kk - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        b.j = function (c) {
            var d = typeCast(RadialAxisRenderingParameters.$, c);
            if (d.e == d.k._inner[0]) {
                _this.ke.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
            }
        };
        b.e = function (c) {
            c.n = _this.kn();
            c.r = c.n;
        };
        b.p = function (c, d, e) {
            var f = typeCast(RadialAxisRenderingParameters.$, c);
            if (e) {
                return false;
            }
            var g = _this.k8(d, f.center, c.aa, c.z, 0);
            if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                return true;
            }
            return false;
        };
        b.a = function (c, d, e, f) {
            var g = c.y;
            var h = new ScalerParams(0, c.aa, c.z, _this.bz, g);
            var i = d;
            if (_this.categoryMode != 0) {
                var j = (e * f) + 1;
                j = Math.min(j, _this.ja);
                var k = _this.dj(j, h);
                i = (d + k) / 2;
            }
            return i;
        };
        b.f = runOn(this, this.getGroupCenter);
        b.i = runOn(this, this.kq);
        return b;
    };
    CategoryAngleAxis.prototype.k8 = function (a, b, c, d, e) {
        var f = this.kn();
        var g = ViewportUtils.b(e, c, d);
        if (this.as != null && (this.as.c == 5 || this.as.c == 1)) {
            g *= -1;
        }
        var h = b.x + (f + g) * Math.cos(a);
        var i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    };
    CategoryAngleAxis.prototype.kn = function () {
        if (this.kd == null) {
            return 0;
        }
        if (!this.bq()) {
            return this.kd.k0();
        }
        else {
            return this.kd.k1((this.eo));
        }
    };
    CategoryAngleAxis.prototype.j8 = function (a, b, c, d) {
        if (this.ir == null) {
            return null;
        }
        var e = new RadialAxisRenderingParameters();
        var f = this.ir.count - 1;
        var g = this.ay.at();
        var h = this.ay.aw();
        var i = this.ay.au();
        var j = this.ay.av();
        e.t = g;
        e.w = h;
        e.u = i;
        e.v = j;
        e.l = f;
        e.m = 0;
        e.h = false;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.g = this.kg();
        e.p = this.kr;
        e.o = this.dw();
        e.q = this.ks;
        e.s = this.er;
        var k = this.ke.f(b);
        var l = this.ke.g(b);
        var m = 0.5 * this.kd.kv;
        var n = 0.5 * this.kd.ku;
        var o = k;
        var p = l;
        var q = this.kd.k0();
        if (isNaN_(q) || isInfinity(q)) {
            return null;
        }
        if (p >= m) {
            p = q;
        }
        if (o < n) {
            o = n;
        }
        var r = a.width;
        this.ke.k(b, e, 0, this.ir.count, this.bz, runOn(this, this.getUnscaledAngle), r);
        var s = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = s;
        e.maxLength = p;
        e.minLength = o;
        e.effectiveMaximum = q;
        e.ae = this.ir.count;
        e.ab = this.categoryMode;
        e.ad = true;
        e.ac = this.bz;
        e.af = this.jd;
        e.f = new CategoryTickmarkValues();
        e.j = this.b9;
        return e;
    };
    CategoryAngleAxis.prototype.getMinMaxAngle = function (a, b, c) {
        var d = this.ke.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    };
    CategoryAngleAxis.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.gj(false);
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "kd", {
        get: function () {
            if (this.kc != null) {
                return this.kc;
            }
            var a = typeCast(XamDataChart.$, this.a9);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.kc;
        },
        set: function (a) {
            this.kc = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.ah = function () {
        return this.kd;
    };
    CategoryAngleAxis.prototype.getCategorySize = function (a, b, c) {
        return 2 * Math.PI / this.ja;
    };
    CategoryAngleAxis.prototype.i3 = function (a, b, c) {
        var d = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
        var e = 0;
        if (!isNaN_(this.i7)) {
            e = Math.min(this.i7, 1);
        }
        var f = 1 - 0.5 * d;
        return this.getCategorySize(a, b, c) * f / (this.jd - (this.jd - 1) * e);
    };
    CategoryAngleAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.jd > 1) {
            var f = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
            var g = 0;
            if (!isNaN_(this.i7)) {
                g = Math.min(this.i7, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.jd - (this.jd - 1) * g);
            var j = (h - i) / (this.jd - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryAngleAxis.prototype.kq = function (a) {
        var b = 0.5;
        if (this.jd > 1) {
            var c = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
            var d = 0;
            if (!isNaN_(this.i7)) {
                d = Math.min(this.i7, 1);
            }
            var e = 1 - 0.5 * c;
            var f = e / (this.jd - (this.jd - 1) * d);
            var g = (e - f) / (this.jd - 1);
            b = 0.25 * c + 0.5 * f + a * g;
        }
        return b;
    };
    CategoryAngleAxis.prototype.gk = function (a) {
        _super.prototype.gk.call(this, a);
        var b = this.a9 != null ? this.a9.mk : Rect.empty;
        var c = !b.isEmpty ? this.ib : Rect.empty;
        var d = this.h6();
        var e = this.h5();
        var f = this.kb.c(a, c, b, d, e);
        if (f != null) {
            this.kl = f.f.m;
            this.km = f.f.l;
        }
    };
    CategoryAngleAxis.prototype.kp = function (a, b) {
        var c;
        var d;
        var e = this.ke.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (c == 0) {
            if (this.bz) {
                return this.ja;
            }
            else {
                return 0;
            }
        }
        var f = this.getUnscaledAngle(c);
        if (f < 0 || f > this.ja) {
            f = this.getUnscaledAngle(c + Math.PI * 2);
        }
        return f;
    };
    CategoryAngleAxis.prototype.ko = function (a, b) {
        var c;
        var d;
        var e = this.ke.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (d > Math.PI * 2) {
            d = d - Math.PI * 2;
        }
        if (d == Math.PI * 2) {
            if (this.bz) {
                return 0;
            }
            else {
                return this.ja;
            }
        }
        var f = this.getUnscaledAngle(d);
        if (f < 0 || f > this.ja) {
            f = this.getUnscaledAngle(d + Math.PI * 2);
        }
        return f;
    };
    CategoryAngleAxis.prototype.getScaledAngle = function (a) {
        var b = this.ja;
        var c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
        if (this.b0) {
            c = 1 - c;
        }
        return (c * 2 * Math.PI) + this.kk;
    };
    CategoryAngleAxis.prototype.getUnscaledAngle = function (a) {
        if (a < this.kk) {
            a += 2 * Math.PI;
        }
        var b = (a - this.kk) / (2 * Math.PI);
        if (this.bz) {
            b = 1 - b;
        }
        return b * (this.ja);
    };
    CategoryAngleAxis.prototype.dj = function (a, b) {
        return this.getScaledAngle(a);
    };
    CategoryAngleAxis.prototype.dm = function (a, b) {
        return this.getUnscaledAngle(a);
    };
    CategoryAngleAxis.prototype.f7 = function (a, b, c, d) {
        _super.prototype.f7.call(this, a, b, c, d);
        var e = typeCast(XamDataChart.$, this.a9);
        switch (b) {
            case "CrossingAxis":
                var f = typeCast(NumericRadiusAxis.$, d);
                this.k4(f);
                if (f != null) {
                    f.la(this);
                }
                this.b6 = true;
                this.gj(false);
                break;
            case CategoryAngleAxis.$$p[0]:
                this.kk = this.ku;
                while (this.kk < 0) {
                    this.kk += 360;
                }
                while (this.kk >= 360) {
                    this.kk -= 360;
                }
                this.kk = (this.kk * Math.PI) / 180;
                this.b6 = true;
                this.gj(false);
                try {
                    for (var _a = tslib_1.__values(fromEnum(this.cl)), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var g = _b.value;
                        g.it(false);
                        g.h1();
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                break;
            case "Label":
                if (e != null) {
                    try {
                        for (var _d = tslib_1.__values(fromEnum(e.axes)), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var h = _e.value;
                            h.b6 = true;
                            h.gi();
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    try {
                        for (var _g = tslib_1.__values(fromEnum(e.axes)), _h = _g.next(); !_h.done; _h = _g.next()) {
                            var i = _h.value;
                            if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                                i.b6 = true;
                                i.gi();
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_h && !_h.done && (_j = _g.return)) _j.call(_g);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                }
                break;
            case "LabelSettings":
                this.kb = this.ka();
                this.k2();
                this.b6 = true;
                this.gj(false);
                break;
        }
        var e_2, _c, e_3, _f, e_4, _j;
    };
    CategoryAngleAxis.prototype.k2 = function () {
        this.kj = NaN;
    };
    CategoryAngleAxis.prototype.k4 = function (a) {
        this.kd = a;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "kr", {
        get: function () {
            return this.c(CategoryAngleAxis.k5);
        },
        set: function (a) {
            this.h(CategoryAngleAxis.k5, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAngleAxis.prototype, "kl", {
        get: function () {
            return this.kh;
        },
        set: function (a) {
            if (this.kl != a) {
                var b = this.kh;
                this.kh = a;
                this.gd("ActualInterval", b, this.kl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAngleAxis.prototype, "ks", {
        get: function () {
            return this.c(CategoryAngleAxis.k6);
        },
        set: function (a) {
            this.h(CategoryAngleAxis.k6, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAngleAxis.prototype, "km", {
        get: function () {
            return this.ki;
        },
        set: function (a) {
            if (this.km != a) {
                var b = this.ki;
                this.ki = a;
                this.gd("ActualMinorInterval", b, this.km);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.kg = function () {
        return false;
    };
    CategoryAngleAxis.prototype.get_av = function () {
        return 2;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "av", {
        get: function () {
            return this.get_av();
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.cd = function () {
        if (this.b6 && this.ce) {
            this.a3 = this.a2();
        }
        if (this.ir == null) {
            return false;
        }
        var a = this.ir.count;
        if (a != this.kw) {
            var b = new AxisRangeChangedEventArgs(1, 1, this.kw, a);
            this.kw = a;
            this.ge(b);
            return true;
        }
        return false;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "kw", {
        get: function () {
            return this.kv;
        },
        set: function (a) {
            this.kv = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAngleAxis.prototype, "isVertical", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.j$c = function (a, b) {
        return this.dm.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$b = function (a, b) {
        return this.dj.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$d = function (a, b, c, d, e) {
        this.fz.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$e = function (a, b, c, d) {
        this.f0.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$f = function (a, b, c, d) {
        this.f1.apply(this, arguments);
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "j$a", {
        get: function () {
            return this.bz;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.k5 = DependencyProperty.i("Interval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.gd("Interval", b.oldValue, b.newValue);
        a.gj(false);
    }));
    CategoryAngleAxis.k6 = DependencyProperty.i("MinorInterval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryAngleAxis.$, a)).gd("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryAngleAxis.$, a)).gj(false);
    }));
    CategoryAngleAxis.$t = markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
    return CategoryAngleAxis;
}(CategoryAxisBase));
export { CategoryAngleAxis };
Type.dep(DependencyProperty, PropertyMetadata, CategoryAngleAxis, 'gd', ['StartAngleOffset:ku:k7', [1, 0]]);
var NumericAngleAxis = /** @class */ (function (_super) {
    tslib_1.__extends(NumericAngleAxis, _super);
    function NumericAngleAxis() {
        var _this = _super.call(this) || this;
        _this.kr = null;
        _this.ks = false;
        _this.kt = NaN;
        _this.ku = 0;
        _this.kp = null;
        _this.ab = NumericAngleAxis.$;
        _this.kr = new PolarAxisRenderingManager();
        _this.ir = _this.ip();
        return _this;
    }
    NumericAngleAxis.prototype.ax = function () {
        return new NumericAngleAxisView(this);
    };
    NumericAngleAxis.prototype.f5 = function (a) {
        _super.prototype.f5.call(this, a);
        this.ko = a;
    };
    NumericAngleAxis.prototype.get_bs = function () {
        return true;
    };
    Object.defineProperty(NumericAngleAxis.prototype, "bs", {
        get: function () {
            return this.get_bs();
        },
        enumerable: true,
        configurable: true
    });
    NumericAngleAxis.prototype.ao = function () {
        var _this = this;
        var a = new AngleAxisLabelPanel();
        a.cx = function (b) {
            var c = _this.a9 != null ? _this.a9.mk : Rect.empty;
            var d = !c.isEmpty ? _this.ib : Rect.empty;
            return _this.k4(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, _this.ap.a7);
        };
        return a;
    };
    NumericAngleAxis.prototype.kv = function () {
        if (this.kq == null) {
            return 0;
        }
        if (!this.bq()) {
            return this.kq.k0();
        }
        else {
            return this.kq.k1((this.eo));
        }
    };
    NumericAngleAxis.prototype.kx = function (a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    };
    NumericAngleAxis.prototype.ip = function () {
        var _this = this;
        var a = _super.prototype.ip.call(this);
        a.b.c = function (b) {
            if ((_this.as == null || _this.as.visibility == 0) && _this.kq != null && _this.kt != b) {
                var c = typeCast(XamDataChart.$, _this.a9);
                if (c == null) {
                    return;
                }
                _this.kt = b;
                _this.ap.a6 = b;
                c.hp();
                try {
                    for (var _a = tslib_1.__values(fromEnum(c.axes)), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var d = _b.value;
                        if (d != _this && typeCast(AngleAxisLabelPanel.$, d.ap) !== null) {
                            d.ay.y();
                        }
                    }
                }
                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_5) throw e_5.error; }
                }
            }
            var e_5, _c;
        };
        a.e = function (b) {
            b.n = _this.kv();
            b.r = b.n;
        };
        a.j = function (b) {
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            if (c.e == c.k._inner[0]) {
                _this.kr.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
            }
        };
        a.k = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            _this.kr.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
        };
        a.l = function (b, c, d, e) {
            var f = typeCast(PolarAxisRenderingParameters.$, b);
            _this.kr.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
        };
        a.d = function (b, c, d, e) {
            var f = typeCast(PolarAxisRenderingParameters.$, _this.is(b, c, d, e));
            return f;
        };
        a.v = function () {
            if (!_this.ks) {
                _this.ks = true;
                _this.kq.cb();
                _this.ks = false;
            }
        };
        a.m = function (b, c) { return _this.getScaledAngle(c); };
        a.o = function (b, c) { return !c.isEmpty && !b.isEmpty && _this.kq != null; };
        a.q = function (b, c) {
            if (_this.kx(c - _this.ku) < 0) {
                return false;
            }
            if (_this.kx(c - _this.ku - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        a.p = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            var f = _this.k4(_this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
            var g = _this.k4(c, e.center, b.aa, b.z, 0);
            if (d && MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                return false;
            }
            if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                return true;
            }
            return false;
        };
        a.r = function (b, c, d, e) {
            if (c < b.m && typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                return b.m;
            }
            else if (c > b.l && (typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                return b.l;
            }
            return c;
        };
        return a;
    };
    NumericAngleAxis.prototype.k4 = function (a, b, c, d, e) {
        var f = this.kv();
        var g = ViewportUtils.b(e, c, d);
        if (this.as != null && (this.as.c == 5 || this.as.c == 1)) {
            g *= -1;
        }
        var h = b.x + (f + g) * Math.cos(a);
        var i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    };
    NumericAngleAxis.prototype.dj = function (a, b) {
        return this.getScaledAngle(a);
    };
    NumericAngleAxis.prototype.getScaledAngle1 = function (a, b, c) {
        var d = 0;
        if (b) {
            d = (Math.log(a) - this.jm) / (this.jl - this.jm);
        }
        else {
            d = (a - this.jg) / (this.jf - this.jg);
        }
        if (c) {
            d = 1 - d;
        }
        return (d * 2 * Math.PI) + this.ku;
    };
    NumericAngleAxis.prototype.getScaledAngle = function (a) {
        return this.getScaledAngle1(a, this.i6, this.b0);
    };
    NumericAngleAxis.prototype.dm = function (a, b) {
        return this.getUnscaledAngle(a);
    };
    NumericAngleAxis.prototype.getUnscaledAngle = function (a) {
        var b = (a - this.ku) / (2 * Math.PI);
        if (this.bz) {
            b = 1 - b;
        }
        if (this.i6) {
            return Math.exp(b * (this.jl - this.jm) + this.jm);
        }
        else {
            return this.jg + b * (this.jf - this.jg);
        }
    };
    NumericAngleAxis.prototype.f7 = function (a, b, c, d) {
        _super.prototype.f7.call(this, a, b, c, d);
        var e = typeCast(XamDataChart.$, this.a9);
        switch (b) {
            case "CrossingAxis":
                var f = typeCast(NumericRadiusAxis.$, d);
                this.k2(f);
                if (f != null) {
                    f.la(this);
                }
                this.gj(false);
                break;
            case NumericAngleAxis.$$p[0]:
                this.ku = this.ky;
                while (this.ku < 0) {
                    this.ku += 360;
                }
                while (this.ku >= 360) {
                    this.ku -= 360;
                }
                this.ku = (this.ky * Math.PI) / 180;
                this.gj(false);
                try {
                    for (var _a = tslib_1.__values(fromEnum(this.ci())), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var g = _b.value;
                        g.it(false);
                        g.h1();
                    }
                }
                catch (e_6_1) { e_6 = { error: e_6_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_6) throw e_6.error; }
                }
                break;
            case "Label":
                if (e != null) {
                    try {
                        for (var _d = tslib_1.__values(fromEnum(e.axes)), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var h = _e.value;
                            h.gi();
                        }
                    }
                    catch (e_7_1) { e_7 = { error: e_7_1 }; }
                    finally {
                        try {
                            if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                        }
                        finally { if (e_7) throw e_7.error; }
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    try {
                        for (var _g = tslib_1.__values(fromEnum(e.axes)), _h = _g.next(); !_h.done; _h = _g.next()) {
                            var i = _h.value;
                            if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                                i.gi();
                            }
                        }
                    }
                    catch (e_8_1) { e_8 = { error: e_8_1 }; }
                    finally {
                        try {
                            if (_h && !_h.done && (_j = _g.return)) _j.call(_g);
                        }
                        finally { if (e_8) throw e_8.error; }
                    }
                }
                break;
            case "LabelSettings":
                this.ir = this.ip();
                this.k0();
                this.b6 = true;
                this.gj(false);
                break;
        }
        var e_6, _c, e_7, _f, e_8, _j;
    };
    NumericAngleAxis.prototype.k0 = function () {
        this.kt = NaN;
    };
    NumericAngleAxis.prototype.it = function () {
        return new PolarAxisRenderingParameters();
    };
    NumericAngleAxis.prototype.is = function (a, b, c, d) {
        var e = typeCast(PolarAxisRenderingParameters.$, _super.prototype.is.call(this, a, b, c, d));
        var f = this.kr.f(b);
        var g = this.kr.g(b);
        var h = 0.5 * this.kq.kv;
        var i = 0.5 * this.kq.ku;
        var j = f;
        var k = g;
        var l = this.kq.k0();
        if (isNaN_(l) || isInfinity(l)) {
            return null;
        }
        if (k >= h) {
            k = l;
        }
        if (j < i) {
            j = i;
        }
        var m = a.width;
        this.kr.k(b, e, this.jg, this.jf, this.bz, runOn(this, this.getUnscaledAngle), m);
        var n = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = n;
        e.maxLength = k;
        e.minLength = j;
        e.effectiveMaximum = l;
        return e;
    };
    NumericAngleAxis.prototype.getMinMaxAngle = function (a, b, c) {
        var d = this.kr.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    };
    NumericAngleAxis.prototype.gk = function (a) {
        _super.prototype.gk.call(this, a);
        var b = this.a9 != null ? this.a9.mk : Rect.empty;
        var c = !b.isEmpty ? this.ib : Rect.empty;
        var d = this.h6();
        var e = this.h5();
        var f = this.ir.c(a, c, b, d, e);
        if (f != null) {
            this.je = f.f.m;
            this.jh = f.f.l;
        }
    };
    Object.defineProperty(NumericAngleAxis.prototype, "kq", {
        get: function () {
            if (this.kp != null) {
                return this.kp;
            }
            var a = typeCast(XamDataChart.$, this.a9);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (a.axes._inner[b].b2) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.kp;
        },
        set: function (a) {
            this.kp = a;
        },
        enumerable: true,
        configurable: true
    });
    NumericAngleAxis.prototype.ah = function () {
        return this.kq;
    };
    NumericAngleAxis.prototype.k2 = function (a) {
        this.kq = a;
    };
    NumericAngleAxis.prototype.gu = function (a, b) {
        _super.prototype.gu.call(this, a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cb();
        }
    };
    NumericAngleAxis.prototype.get_av = function () {
        return 2;
    };
    Object.defineProperty(NumericAngleAxis.prototype, "av", {
        get: function () {
            return this.get_av();
        },
        enumerable: true,
        configurable: true
    });
    NumericAngleAxis.$t = markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
    return NumericAngleAxis;
}(NumericAxisBase));
export { NumericAngleAxis };
Type.dep(DependencyProperty, PropertyMetadata, NumericAngleAxis, 'gd', ['StartAngleOffset:ky:k3', [1, 0]]);
var NumericRadiusAxis = /** @class */ (function (_super) {
    tslib_1.__extends(NumericRadiusAxis, _super);
    function NumericRadiusAxis() {
        var _this = _super.call(this) || this;
        _this.kr = null;
        _this.ks = false;
        _this.kt = NaN;
        _this.kv = 0;
        _this.ku = 0;
        _this.kx = 0;
        _this.ko = null;
        _this.ab = NumericRadiusAxis.$;
        _this.kv = _this.k5;
        _this.ku = _this.k4;
        _this.kr = new PolarAxisRenderingManager();
        _this.ir = _this.ip();
        return _this;
    }
    NumericRadiusAxis.prototype.ax = function () {
        return new NumericRadiusAxisView(this);
    };
    NumericRadiusAxis.prototype.f5 = function (a) {
        _super.prototype.f5.call(this, a);
        this.kq = a;
    };
    NumericRadiusAxis.prototype.get_b2 = function () {
        return true;
    };
    Object.defineProperty(NumericRadiusAxis.prototype, "b2", {
        get: function () {
            return this.get_b2();
        },
        enumerable: true,
        configurable: true
    });
    NumericRadiusAxis.prototype.di = function () {
        var a = this.kv;
        var b = this.ku;
        var c = Math.min(this.kz(), this.ky()) * (a - b) / 2;
        c = Math.max(c, 14);
        return c;
    };
    NumericRadiusAxis.prototype.kz = function () {
        return this.ib.width;
    };
    NumericRadiusAxis.prototype.ky = function () {
        return this.ib.height;
    };
    NumericRadiusAxis.prototype.ao = function () {
        return new RadialAxisLabelPanel();
    };
    NumericRadiusAxis.prototype.kw = function (a) {
        if (a == null) {
            return 0;
        }
        return a;
    };
    NumericRadiusAxis.prototype.ip = function () {
        var _this = this;
        var a = _super.prototype.ip.call(this);
        a.b.c = function (b) {
            if ((_this.as == null || _this.as.visibility == 0) && _this.kp != null) {
                if ((_this.as == null || (_this.as.c == 4 || _this.as.c == 5)) && _this.kt != b) {
                    _this.kt = b;
                    _this.ap.a6 = b;
                    _this.a9.hp();
                }
            }
        };
        a.k = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            _this.kr.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
        };
        a.l = function (b, c, d, e) {
            if (d == e) {
                return;
            }
            var f = typeCast(PolarAxisRenderingParameters.$, b);
            _this.kr.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
        };
        a.m = function (b, c) { return _this.k1(c); };
        a.q = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.n = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.j = function (b) {
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            _this.kr.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
        };
        a.e = function (b) {
            b.n = _this.as == null || (_this.as.c == 4 || _this.as.c == 0) ? b.z.top : b.z.bottom;
            b.r = b.n;
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            c.crossingAngleRadians = (_this.kw(_this.eo) * Math.PI) / 180;
            if (_this.as == null || (_this.as.c == 4 || _this.as.c == 5)) {
                c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                c.r = c.n;
                var d = typeCast(RadialAxisLabelPanel.$, _this.ap);
                if (d != null) {
                    var e = 0;
                    if (_this.as != null && _this.as.c == 4) {
                        e = 1;
                    }
                    d.de = { $type: Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                    d.db = c.crossingAngleRadians;
                }
            }
        };
        a.p = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            if (_this.kp == null) {
                return false;
            }
            if (c > e.effectiveMaximum) {
                return false;
            }
            var f = false;
            f = _this.as == null || (_this.as.c == 4 || _this.as.c == 5);
            var g = 0;
            if (f) {
                g = _this.kx;
            }
            var h = e.center.x + c * Math.cos(g);
            var i = e.center.y + c * Math.sin(g);
            h = ViewportUtils.c(h, e.aa, e.z);
            i = ViewportUtils.f(i, e.aa, e.z);
            if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                return true;
            }
            return false;
        };
        a.h = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
        };
        a.r = function (b, c, d, e) {
            if (c < b.m) {
                return b.m;
            }
            else if (c > b.l) {
                return b.l;
            }
            return c;
        };
        return a;
    };
    NumericRadiusAxis.prototype.dj = function (a, b) {
        return this.k1(a);
    };
    NumericRadiusAxis.prototype.k2 = function (a, b, c, d, e) {
        var f = 0;
        if (b) {
            if (a <= 0) {
                f = (Math.log(this.jg) - this.jm) / (this.jl - this.jm);
            }
            else {
                f = (Math.log(a) - this.jm) / (this.jl - this.jm);
            }
        }
        else {
            f = (a - this.jg) / (this.jf - this.jg);
        }
        if (c) {
            f = 1 - f;
        }
        f = e + (f * (d - e));
        f /= 2;
        return f;
    };
    NumericRadiusAxis.prototype.k1 = function (a) {
        return this.k2(a, this.i6, this.b0, this.kv, this.ku);
    };
    NumericRadiusAxis.prototype.k3 = function (a) {
        var b = a * 2;
        b = (b - this.ku) / (this.kv - this.ku);
        if (this.bz) {
            b = 1 - b;
        }
        if (this.i6) {
            return Math.exp(b * (this.jl - this.jm) + this.jm);
        }
        else {
            return this.jg + b * (this.jf - this.jg);
        }
    };
    NumericRadiusAxis.prototype.dm = function (a, b) {
        return this.k3(a);
    };
    NumericRadiusAxis.prototype.f7 = function (a, b, c, d) {
        switch (b) {
            case "CrossingValue":
                this.kx = this.kw(this.eo) * Math.PI / 180;
                break;
        }
        _super.prototype.f7.call(this, a, b, c, d);
        switch (b) {
            case NumericRadiusAxis.$$p[1]:
                this.kv = this.k5;
                if (this.kv < 0) {
                    this.kv = 0.1;
                }
                if (this.kv > 1) {
                    this.kv = 1;
                }
                if (this.ku >= this.kv) {
                    this.ku = this.kv - 0.01;
                    if (this.ku < 0) {
                        this.ku = 0;
                        this.kv = 0.01;
                    }
                }
                this.b6 = true;
                this.gj(false);
                if (this.kp != null) {
                    this.kp.gi();
                }
                try {
                    for (var _a = tslib_1.__values(fromEnum(this.ci())), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var e = _b.value;
                        e.it(false);
                    }
                }
                catch (e_9_1) { e_9 = { error: e_9_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_9) throw e_9.error; }
                }
                break;
            case NumericRadiusAxis.$$p[0]:
                this.ku = this.k4;
                if (this.ku < 0) {
                    this.ku = 0.1;
                }
                if (this.ku > 1) {
                    this.ku = 1;
                }
                if (this.ku >= this.kv) {
                    this.ku = this.kv - 0.01;
                    if (this.ku < 0) {
                        this.ku = 0;
                        this.kv = 0.01;
                    }
                }
                this.b6 = true;
                this.gj(false);
                if (this.kp != null) {
                    this.kp.gi();
                }
                try {
                    for (var _d = tslib_1.__values(fromEnum(this.ci())), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var f = _e.value;
                        f.dh = true;
                        f.it(false);
                    }
                }
                catch (e_10_1) { e_10 = { error: e_10_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                    }
                    finally { if (e_10) throw e_10.error; }
                }
                if (this.a9 != null) {
                    this.a9.hx();
                }
                break;
            case "CrossingAxis":
                var g = typeCast(NumericAngleAxis.$, d);
                var h = typeCast(CategoryAngleAxis.$, d);
                if (g == null && h == null) {
                    this.la(null);
                }
                if (g != null) {
                    this.la(g);
                    g.k2(this);
                }
                if (h != null) {
                    this.la(h);
                    h.k4(this);
                }
                this.b6 = true;
                this.gj(false);
                break;
            case "IsInverted":
                if (this.kp != null) {
                    this.kp.b6 = true;
                    this.kp.gj(false);
                }
                break;
        }
        var e_9, _c, e_10, _f;
    };
    NumericRadiusAxis.prototype.la = function (a) {
        this.kp = a;
    };
    Object.defineProperty(NumericRadiusAxis.prototype, "kp", {
        get: function () {
            if (this.ko != null) {
                return this.ko;
            }
            var a = typeCast(XamDataChart.$, this.a9);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.ko;
        },
        set: function (a) {
            this.ko = a;
        },
        enumerable: true,
        configurable: true
    });
    NumericRadiusAxis.prototype.ah = function () {
        return this.kp;
    };
    NumericRadiusAxis.prototype.it = function () {
        return new PolarAxisRenderingParameters();
    };
    NumericRadiusAxis.prototype.is = function (a, b, c, d) {
        var e = typeCast(PolarAxisRenderingParameters.$, _super.prototype.is.call(this, a, b, c, d));
        var f = this.kr.f(b);
        var g = this.kr.g(b);
        var h = 0.5 * this.kv;
        var i = 0.5 * this.ku;
        var j, k;
        if (Rect.l_op_Equality(b, SeriesViewer.mu)) {
            k = this.jf;
            j = this.jg;
        }
        else {
            k = Math.min(g, h);
            j = this.k3(f);
            k = this.k3(k);
            var l = this.lb(a, b, j, k);
            j = l.p2;
            k = l.p3;
        }
        var m = { $type: Point_$type, x: 0.5, y: 0.5 };
        var n = f;
        var o = g;
        var p = Math.min(a.width, a.height) * (this.kv - this.ku) / 2;
        e.center = m;
        var q = Math.max(o, n);
        var r = Math.min(n, o);
        e.maxLength = q;
        e.minLength = r;
        var s = Math.min(j, k);
        var t = Math.max(j, k);
        if (s < this.jg) {
            s = this.jg;
        }
        if (t > this.jf) {
            t = this.jf;
        }
        this.jj = s;
        this.ji = t;
        e.k.add(((function () {
            var $ret = new RangeInfo();
            $ret.d = s;
            $ret.c = t;
            $ret.b = p;
            return $ret;
        })()));
        var u = typeCast(IAngleScaler_$type, this.kp);
        if (u != null) {
            var v = void 0;
            var w = void 0;
            var x = u.getMinMaxAngle(b, v, w);
            v = x.p1;
            w = x.p2;
            e.minAngle = Math.min(v, w);
            e.maxAngle = Math.max(v, w);
        }
        var y = this.k0();
        if (o >= h) {
            o = y;
        }
        if (n < i) {
            n = i;
        }
        e.minLength = n;
        e.maxLength = o;
        e.effectiveMaximum = y;
        e.f = this.iw;
        var z = typeCast(LinearTickmarkValues.$, e.f);
        if (z != null) {
            z.y = this.k6(m, e.minLength, e.maxLength, b, a);
        }
        return e;
    };
    NumericRadiusAxis.prototype.lb = function (a, b, c, d) {
        var e = { $type: Point_$type, x: 0.5, y: 0.5 };
        var f = 0;
        if (this.bz) {
            f = this.k1(this.jg);
        }
        else {
            f = this.k1(this.jf);
        }
        var g = 0;
        if (this.eo != null) {
            g = this.kx;
        }
        var h = e.x + f * Math.cos(g);
        var i = e.y + f * Math.sin(g);
        e.x = ViewportUtils.c(e.x, b, a);
        e.y = ViewportUtils.f(e.y, b, a);
        h = ViewportUtils.c(h, b, a);
        i = ViewportUtils.f(i, b, a);
        if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
            if (this.bz) {
                d = this.jg;
            }
            else {
                d = this.jf;
            }
        }
        if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
            if (this.bz) {
                c = this.jf;
            }
            else {
                c = this.jg;
            }
        }
        return {
            p2: c,
            p3: d
        };
    };
    NumericRadiusAxis.prototype.k6 = function (a, b, c, d, e) {
        var f = ViewportUtils.d(c - b, d, e);
        var g = f / Math.min(e.width, e.height);
        if (g > 0.7) {
            return 10;
        }
        return 5;
    };
    NumericRadiusAxis.prototype.k0 = function () {
        var a = 0;
        if (!this.bz) {
            a = this.k1(this.jf);
        }
        else {
            a = this.k1(this.jg);
        }
        return a;
    };
    NumericRadiusAxis.prototype.ke = function (a) {
        if (this.kp != null) {
            this.kp.gi();
        }
    };
    NumericRadiusAxis.prototype.gk = function (a) {
        _super.prototype.gk.call(this, a);
        var b = this.a9 != null ? this.a9.mk : Rect.empty;
        var c = !b.isEmpty ? this.ib : Rect.empty;
        var d = this.h6();
        var e = this.h5();
        var f = this.ir.c(a, c, b, d, e);
        if (f != null) {
            this.je = f.f.m;
            this.jh = f.f.l;
        }
    };
    NumericRadiusAxis.prototype.gu = function (a, b) {
        _super.prototype.gu.call(this, a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cb();
        }
    };
    NumericRadiusAxis.prototype.k9 = function (a, b, c, d, e) {
        var f = typeCast(IPolarRadialRenderingParameters_$type, this.is(b, c, d, e));
        if (f == null) {
            return;
        }
        this.kr.j(a.c, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
    };
    NumericRadiusAxis.prototype.get_av = function () {
        return 3;
    };
    Object.defineProperty(NumericRadiusAxis.prototype, "av", {
        get: function () {
            return this.get_av();
        },
        enumerable: true,
        configurable: true
    });
    NumericRadiusAxis.$t = markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
    return NumericRadiusAxis;
}(NumericAxisBase));
export { NumericRadiusAxis };
Type.dep(DependencyProperty, PropertyMetadata, NumericRadiusAxis, 'gd', ['InnerRadiusExtentScale:k4:lc', [1, 0], 'RadiusExtentScale:k5:ld', [1, 0.75]]);
var AngleAxisLabelPanelView = /** @class */ (function (_super) {
    tslib_1.__extends(AngleAxisLabelPanelView, _super);
    function AngleAxisLabelPanelView(a) {
        var _this = _super.call(this, a) || this;
        _this.av = null;
        _this.av = a;
        return _this;
    }
    AngleAxisLabelPanelView.prototype.al = function () {
        _super.prototype.al.call(this);
        this.av.cr = true;
    };
    AngleAxisLabelPanelView.prototype.aw = function (a) {
        this.av.cv = -1.7976931348623157E+308;
        this.av.cs = -1.7976931348623157E+308;
        this.av.cu = -1.7976931348623157E+308;
        this.av.ct = -1.7976931348623157E+308;
        for (var b = 0; b < this.a.a3.count; b++) {
            var c = this.a.a3._inner[b];
            var d = this.a.a2._inner[b];
            var e = this.av.cx(d.a);
            var f = this.m(c);
            var g = this.l(c);
            var h = f + this.p() + this.q();
            var i = g + this.r() + this.o();
            var j = e.x - h / 2;
            var k = e.y - i / 2;
            this.av.cu = Math.max(f, this.av.cu);
            this.av.ct = Math.max(g, this.av.ct);
            this.av.cv = Math.max(h, this.av.cv);
            this.av.cs = Math.max(i, this.av.cs);
            var l = new Rect(0, j, k, h, i);
            a.add(l);
        }
    };
    AngleAxisLabelPanelView.prototype.o = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.p = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.q = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.r = function () {
        return 0;
    };
    AngleAxisLabelPanelView.$t = markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
    return AngleAxisLabelPanelView;
}(AxisLabelPanelBaseView));
export { AngleAxisLabelPanelView };
var CategoryAngleAxisView = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryAngleAxisView, _super);
    function CategoryAngleAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.ba = null;
        _this.ba = a;
        return _this;
    }
    CategoryAngleAxisView.$t = markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
    return CategoryAngleAxisView;
}(CategoryAxisBaseView));
export { CategoryAngleAxisView };
var NumericAngleAxisView = /** @class */ (function (_super) {
    tslib_1.__extends(NumericAngleAxisView, _super);
    function NumericAngleAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.ba = null;
        _this.ba = a;
        return _this;
    }
    NumericAngleAxisView.$t = markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
    return NumericAngleAxisView;
}(NumericAxisBaseView));
export { NumericAngleAxisView };
var NumericRadiusAxisView = /** @class */ (function (_super) {
    tslib_1.__extends(NumericRadiusAxisView, _super);
    function NumericRadiusAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.ba = null;
        _this.ba = a;
        return _this;
    }
    NumericRadiusAxisView.$t = markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);
    return NumericRadiusAxisView;
}(NumericAxisBaseView));
export { NumericRadiusAxisView };
/*<BeginStatics Name="Infragistics.Controls.Charts.CategoryAngleAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategoryAngleAxis" />*/
/*<BeginStatics Name="Infragistics.Controls.Charts.NumericAngleAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.NumericAngleAxis" />*/
/*<BeginStatics Name="Infragistics.Controls.Charts.NumericRadiusAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.NumericRadiusAxis" />*/
//# sourceMappingURL=AngleAxisLabelPanel_combined.js.map