/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { EventProxy } from "./EventProxy";
import { Point_$type, runOn, markType, String_$type, Delegate_$type } from "./type";
import { Rect } from "./Rect";
import { MouseEventArgs } from "./MouseEventArgs";
import { Dictionary$2 } from "./Dictionary$2";
import { List$1 } from "./List$1";
var BaseDOMEventProxy = /** @class */ (function (_super) {
    tslib_1.__extends(BaseDOMEventProxy, _super);
    function BaseDOMEventProxy() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.bp = null;
        _this.bo = null;
        _this.bd = false;
        _this.bm = 0;
        _this.bn = 0;
        _this.bk = 0;
        _this.bl = 0;
        _this.bq = 0;
        _this.cn = null;
        _this.cm = null;
        _this.bc = false;
        _this.br = -1;
        _this.bg = false;
        _this.be = false;
        _this.bb = false;
        return _this;
    }
    BaseDOMEventProxy.prototype.d = function () {
        var a = new DOMEventProxy(this.bp, this.bo);
        a.z = this.z;
        a.ai = this.ai;
        return a;
    };
    BaseDOMEventProxy.prototype.a9 = function (a) {
        return DOMEventProxy.co(a);
    };
    BaseDOMEventProxy.prototype.ce = function (a) {
        if (!this.aa) {
            if (this.bf(a)) {
                a.preventDefault();
            }
        }
    };
    BaseDOMEventProxy.prototype.bf = function (e_) {
        return (e_.originalEvent.cancelable || e_.originalEvent.cancelable == undefined);
    };
    BaseDOMEventProxy.prototype.ca = function () {
        var source_ = this.bp.getNativeElement();
        BaseDOMEventProxy.cd(source_);
    };
    BaseDOMEventProxy.cd = function (source_) {
        if (BaseDOMEventProxy.bi) {
            source_.style.touchAction = 'none';
        }
        else {
            source_.style.msTouchAction = 'none';
        }
        source_.style.msUserSelect = 'none';
        source_.style.webkitTouchCallout = 'none';
        source_.style.webkitUserSelect = 'none';
        source_.style.khtmlUserSelect = 'none';
        source_.style.mozUserSelect = 'none';
        source_.style.userSelect = 'none';
    };
    BaseDOMEventProxy.b7 = function (source_) {
        if (BaseDOMEventProxy.bi) {
            source_.style.touchAction = 'auto';
        }
        else {
            source_.style.msTouchAction = 'auto';
        }
        source_.style.msUserSelect = 'auto';
        source_.style.webkitTouchCallout = 'none';
        source_.style.webkitUserSelect = 'auto';
        source_.style.khtmlUserSelect = 'auto';
        source_.style.mozUserSelect = 'auto';
        source_.style.userSelect = 'auto';
    };
    BaseDOMEventProxy.prototype.b8 = function () {
        var source_ = this.bp.getNativeElement();
        BaseDOMEventProxy.b7(source_);
    };
    BaseDOMEventProxy.prototype.am = function () {
        _super.prototype.am.call(this);
        if (!this.aa) {
            this.ca();
        }
        else {
            this.b8();
        }
    };
    BaseDOMEventProxy.prototype.bw = function () {
        var ver_ = -1;
        var matchIE_ = /Trident\/([\d.]+)/;
        if ((matchIE_.exec(navigator.userAgent) != null)) {
            ver_ = (parseFloat(RegExp.$1));
        }
        return ver_;
    };
    BaseDOMEventProxy.prototype.bv = function () {
        var ver_ = -1;
        var matchIE_ = /Edge\/([\d.]+)/;
        if ((matchIE_.exec(navigator.userAgent) != null)) {
            ver_ = (parseFloat(RegExp.$1));
        }
        return ver_;
    };
    BaseDOMEventProxy.cc = function (e_) {
        var a = BaseDOMEventProxy.bx >= 6;
        var oe_ = e_.originalEvent;
        if ((((typeof e_.pageX == 'undefined')) || a) && oe_.clientX != null) {
            var od_ = e_.target.ownerDocument;
            var ed_ = od_ ? od_ : document;
            var doc_ = ed_.documentElement;
            var body_ = ed_.body;
            var clientX_ = oe_.clientX;
            var clientY_ = oe_.clientY;
            var scrollLeft_ = doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0;
            var scrollTop_ = doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0;
            var clientLeft_ = doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0;
            var clientTop_ = doc_ && doc_.clientTop || body_ && body_.clientTop || 0;
            e_.pageX = clientX_ + (scrollLeft_ - clientLeft_);
            e_.pageY = clientY_ + (scrollTop_ - clientTop_);
        }
        if ((!e_.pageX)) {
            e_.pageX = e_.originalEvent.pageX;
        }
        if ((!e_.pageY)) {
            e_.pageY = e_.originalEvent.pageY;
        }
        if (((typeof e_.button == 'undefined')) && ((typeof oe_.button != 'undefined'))) {
            e_.button = oe_.button;
        }
    };
    BaseDOMEventProxy.co = function (a) {
        var b = BaseDOMEventProxy.bx >= 6;
        var source_ = a.getNativeElement();
        var d_ = source_.ownerDocument;
        var doc_ = d_ ? d_.documentElement : null;
        var z_ = doc_ ? doc_.msContentZoomFactor : null;
        var body_ = doc_.body;
        if ((z_ && z_ > 1) || b) {
            var rect_ = source_.getBoundingClientRect();
            var x_ = (rect_.left);
            var y_ = (rect_.top);
            var scrollLeft_ = (doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0);
            var scrollTop_ = (doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0);
            var clientLeft_ = (doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0);
            var clientTop_ = (doc_ && doc_.clientTop || body_ && body_.clientTop || 0);
            var c = x_ + scrollLeft_ - clientLeft_;
            var d = y_ + scrollTop_ - clientTop_;
            return new Rect(0, c, d, 0, 0);
        }
        else {
            var e = a.getOffset();
            return new Rect(0, e.left, e.top, 0, 0);
        }
    };
    Object.defineProperty(BaseDOMEventProxy.prototype, "bt", {
        get: function () {
            return this.bq;
        },
        set: function (a) {
            this.bq = a;
        },
        enumerable: true,
        configurable: true
    });
    BaseDOMEventProxy.prototype.ch = function (a) {
        this.aj = a;
        BaseDOMEventProxy.cc(a);
        var b = BaseDOMEventProxy.co(this.bp);
        this.bm = a.pageX - b.left;
        this.bn = a.pageY - b.top;
        this.bk = this.bm - this.ba.left;
        this.bl = this.bn - this.ba.top;
        this.cn = { $type: Point_$type, x: this.bm, y: this.bn };
        this.cm = { $type: Point_$type, x: this.bk, y: this.bl };
    };
    BaseDOMEventProxy.prototype.ci = function (e_) {
        this.aj = e_;
        BaseDOMEventProxy.cc(e_);
        if (BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) {
            var a = e_.pageX;
            var b = e_.pageY;
            var c = BaseDOMEventProxy.co(this.bp);
            this.bm = a - c.left;
            this.bn = b - c.top;
        }
        else {
            this.bq = 0;
            if (!e_.originalEvent.targetTouches || e_.originalEvent.targetTouches.length < 1) {
                return;
            }
            ;
            this.bq = (e_.originalEvent.targetTouches.length);
            var d = (e_.originalEvent.targetTouches[0].pageX);
            var e = (e_.originalEvent.targetTouches[0].pageY);
            var f = BaseDOMEventProxy.co(this.bp);
            this.bm = d - f.left;
            this.bn = e - f.top;
        }
        this.bk = this.bm - this.ba.left;
        this.bl = this.bn - this.ba.top;
        this.cn = { $type: Point_$type, x: this.bm, y: this.bn };
        this.cm = { $type: Point_$type, x: this.bk, y: this.bl };
    };
    BaseDOMEventProxy.prototype.b5 = function (e_) {
        this.cg(e_);
        if (this.ah(this.cn)) {
            var delta_ = 0;
            if (e_.wheelDelta) {
                delta_ = e_.wheelDelta / 120;
            }
            ;
            if (e_.originalEvent && e_.originalEvent.wheelDelta) {
                delta_ = e_.originalEvent.wheelDelta / 120;
            }
            ;
            if (e_.detail) {
                delta_ = -e_.detail / 3;
            }
            ;
            if (e_.originalEvent && e_.originalEvent.detail) {
                delta_ = -e_.originalEvent.detail / 3;
            }
            ;
            delta_ = delta_ / 10;
            var a = this.ae(this.cm, delta_);
            if (a) {
                this.ce(e_);
            }
        }
    };
    BaseDOMEventProxy.prototype.cb = function () {
        if (this.bc) {
            if (this.br == -1) {
                this.br = this.bo.setTimeout(runOn(this, this.b9), 500);
            }
            else {
                window.clearTimeout(this.br);
                this.br = -1;
                this.br = this.bo.setTimeout(runOn(this, this.b9), 500);
            }
        }
    };
    BaseDOMEventProxy.prototype.by = function () {
        this.bc = true;
        if (this.br != -1) {
            window.clearTimeout(this.br);
            this.br = -1;
        }
    };
    BaseDOMEventProxy.prototype.b9 = function () {
        this.bc = false;
    };
    Object.defineProperty(BaseDOMEventProxy.prototype, "bj", {
        get: function () {
            return this.be;
        },
        set: function (a) {
            this.be = a;
        },
        enumerable: true,
        configurable: true
    });
    BaseDOMEventProxy.prototype.b3 = function (a) {
        if (this.be || this.bc) {
            return;
        }
        this.ch(a);
        if (this.bg) {
            this.bg = false;
            this.ay(this.cm);
        }
    };
    BaseDOMEventProxy.prototype.b4 = function (a) {
        if (this.be || this.bc) {
            return;
        }
        this.ch(a);
        this.cg(a);
        var b = new MouseEventArgs();
        b.position = this.cn;
        if (this.ah(this.cn)) {
            if (!this.bg) {
                this.bg = true;
                this.ax(this.cn);
            }
            this.az(this.cn, true, false);
            this.ao(this.cm, false);
        }
        else if (this.bg) {
            this.b3(a);
        }
    };
    BaseDOMEventProxy.prototype.cf = function (a) {
        this.bp.focus();
    };
    BaseDOMEventProxy.prototype.b2 = function (a) {
        if (this.be || this.bc) {
            return;
        }
        this.cf(a);
        this.ch(a);
        this.cg(a);
        if (this.ah(this.cn)) {
            this.bb = true;
            this.aw(this.cn);
            this.ap(this.cm, false);
            this.ce(a);
        }
    };
    BaseDOMEventProxy.prototype.cj = function (a) {
        if (this.be || this.bc) {
            return;
        }
        if (this.bb) {
            this.b6(a);
        }
    };
    BaseDOMEventProxy.prototype.b6 = function (a) {
        if (this.be || this.bc) {
            return;
        }
        this.cg(a);
        var b = this.ah(this.cn) || this.bb || this.bg;
        this.bb = false;
        this.a0(this.cn);
        this.an(this.cm, false);
        if (b) {
            this.ce(a);
        }
    };
    BaseDOMEventProxy.prototype.bz = function (a) {
        this.b0(a, true);
    };
    BaseDOMEventProxy.prototype.b1 = function (a) {
        this.b0(a, false);
    };
    BaseDOMEventProxy.prototype.cl = function (a) {
        return BaseDOMEventProxy.ck(a);
    };
    BaseDOMEventProxy.ck = function (a) {
        var b;
        switch (a.which) {
            case 33:
                b = 10;
                break;
            case 34:
                b = 11;
                break;
            case 36:
                b = 13;
                break;
            case 37:
                b = 14;
                break;
            case 38:
                b = 15;
                break;
            case 39:
                b = 16;
                break;
            case 40:
                b = 17;
                break;
            case 9:
                b = 2;
                break;
            case 32:
                b = 9;
                break;
            case 13:
                b = 3;
                break;
            case 27:
                b = 8;
                break;
            case 16:
                b = 4;
                break;
            case 17:
                b = 5;
                break;
            case 18:
                b = 6;
                break;
            case 8:
                b = 1;
                break;
            case 35:
                b = 12;
                break;
            case 45:
                b = 18;
                break;
            case 46:
                b = 19;
                break;
            case 106:
                b = 78;
                break;
            case 107:
                b = 79;
                break;
            case 109:
                b = 80;
                break;
            case 110:
                b = 81;
                break;
            case 111:
                b = 82;
                break;
            case 220:
                b = 85;
                break;
            case 192:
                b = 86;
                break;
            case 191:
                b = 84;
                break;
            case 186:
                b = 83;
                break;
            case 189:
                b = 88;
                break;
            case 187:
                b = 87;
                break;
            default:
                if (112 <= a.which && a.which <= 123) {
                    b = (56 + a.which - 112);
                }
                else if (65 <= a.which && a.which <= 90) {
                    b = (30 + a.which - 65);
                }
                else if (48 <= a.which && a.which <= 57) {
                    b = (20 + a.which - 48);
                }
                else if (96 <= a.which && a.which <= 105) {
                    b = (68 + a.which - 96);
                }
                else {
                    b = 0;
                }
                break;
        }
        return b;
    };
    BaseDOMEventProxy.prototype.b0 = function (a, b) {
        var c = this.cl(a);
        var d = c != 0;
        this.cg(a);
        if (d) {
            var e = false;
            if (b) {
                e = this.ac(c);
            }
            else {
                e = this.ad(c);
            }
            if (e) {
                this.ce(a);
            }
        }
    };
    BaseDOMEventProxy.prototype.cg = function (a) {
        this.aj = a;
        this.a7 = 0;
        if (a.shiftKey) {
            this.a7 = this.a7 | 4;
        }
        if (a.altKey) {
            this.a7 = this.a7 | 1;
        }
        if (a.ctrlKey) {
            this.a7 = this.a7 | 2;
        }
        this.af = a.button == 2;
    };
    BaseDOMEventProxy.prototype.a8 = function () {
        var a = BaseDOMEventProxy.co(this.bp);
        var b = a.left;
        var c = a.top;
        return { $type: Point_$type, x: b, y: c };
    };
    BaseDOMEventProxy.bh = false;
    BaseDOMEventProxy.bi = false;
    BaseDOMEventProxy.bx = 0;
    BaseDOMEventProxy.bu = 0;
    BaseDOMEventProxy.$t = markType(BaseDOMEventProxy, 'BaseDOMEventProxy', EventProxy.$);
    return BaseDOMEventProxy;
}(EventProxy));
export { BaseDOMEventProxy };
var DOMEventProxy = /** @class */ (function (_super) {
    tslib_1.__extends(DOMEventProxy, _super);
    function DOMEventProxy(a, b) {
        var _this = _super.call(this) || this;
        _this.c0 = 0;
        _this.c1 = "";
        _this.cq = false;
        _this.cx = null;
        _this.ct = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
        _this.dn = null;
        _this.cy = -1;
        _this.dp = null;
        _this.cv = 0;
        _this.cw = 0;
        _this.cu = 5;
        _this.cp = false;
        _this.dm = null;
        _this.bo = b;
        _this.ai = function (c) { return true; };
        _this.z = false;
        DOMEventProxy.cz++;
        _this.c0 = DOMEventProxy.cz;
        _this.c1 = ".DOMProxy" + _this.c0.toString();
        _this.a7 = 0;
        _this.bp = a;
        BaseDOMEventProxy.bh = false;
        try {
            BaseDOMEventProxy.bh = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        }
        catch (c) {
        }
        BaseDOMEventProxy.bi = false;
        try {
            BaseDOMEventProxy.bi = (window.navigator.pointerEnabled);
        }
        catch (d) {
        }
        BaseDOMEventProxy.bx = _this.bw();
        BaseDOMEventProxy.bu = _this.bv();
        _this.ak(_this.bp, "");
        _this.ah = function (e) { return true; };
        return _this;
    }
    DOMEventProxy.prototype.c2 = function (a, b, c) {
    };
    DOMEventProxy.prototype.ak = function (a, b) {
        var c = a;
        var d = this.c1 + b;
        if (!this.bo.supportsDOMEvents()) {
            return;
        }
        var e = new List$1(Delegate_$type, 0);
        this.ct.addItem(d, e);
        this.c2(a, b, e);
        if ((!BaseDOMEventProxy.bh && !BaseDOMEventProxy.bi)) {
            e.add(c.listen("mousemove", runOn(this, this.b4)));
            e.add(c.listen("mouseleave", runOn(this, this.b3)));
            e.add(c.listen("mousedown", runOn(this, this.b2)));
            e.add(c.listen("mouseup", runOn(this, this.b6)));
            e.add(this.bo.globalListen("window", "mouseup", runOn(this, this.cj)));
        }
        e.add(c.listen("keydown", runOn(this, this.bz)));
        e.add(c.listen("keyup", runOn(this, this.b1)));
        var source_ = this.bp.getNativeElement();
        if (!this.aa) {
            BaseDOMEventProxy.cd(source_);
        }
        if (BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) {
            var f = this.bp.getNativeElement();
            if ((window.MSGesture !== undefined)) {
                var g = (new MSGesture());
                g.target = f;
                this.cx = g;
                e.add(c.listen("MSGestureStart", runOn(this, this.c5)));
                e.add(c.listen("MSGestureChange", runOn(this, this.c3)));
                e.add(c.listen("MSGestureEnd", runOn(this, this.c4)));
            }
            if (BaseDOMEventProxy.bi) {
                e.add(c.listen("pointerdown", runOn(this, this.c8)));
                e.add(c.listen("pointerup", runOn(this, this.db)));
                e.add(c.listen("pointercancel", runOn(this, this.c7)));
                e.add(c.listen("pointermove", runOn(this, this.c9)));
                e.add(c.listen("pointerout", runOn(this, this.da)));
                e.add(c.listen("lostpointercapture", runOn(this, this.c6)));
            }
            else {
                e.add(c.listen("MSPointerDown", runOn(this, this.c8)));
                e.add(c.listen("MSPointerUp", runOn(this, this.db)));
                e.add(c.listen("MSPointerCancel", runOn(this, this.c7)));
                e.add(c.listen("MSPointerMove", runOn(this, this.c9)));
                e.add(c.listen("MSPointerOut", runOn(this, this.da)));
                e.add(c.listen("MSLostPointerCapture", runOn(this, this.c6)));
            }
        }
        e.add(c.listen("DOMMouseScroll", runOn(this, this.b5)));
        e.add(c.listen("mousewheel", runOn(this, this.b5)));
        e.add(c.listen("gesturestart", runOn(this, this.c5)));
        e.add(c.listen("gesturechange", runOn(this, this.c3)));
        e.add(c.listen("gestureend", runOn(this, this.c4)));
        e.add(c.listen("touchstart", runOn(this, this.de)));
        e.add(c.listen("touchmove", runOn(this, this.dd)));
        e.add(c.listen("touchend", runOn(this, this.dc)));
    };
    DOMEventProxy.prototype.db = function (e_) {
        var a = this.cr(e_);
        if (a) {
            this.bt = this.bt - 1;
            if (this.bt < 0) {
                this.bt = 0;
            }
        }
        if (this.bt < 2 && this.cq && a) {
            this.cq = false;
            var b = (e_.originalEvent.scale);
            this.au(this.cm, b);
        }
        else {
            if (a) {
                this.dc(e_);
            }
            else {
                this.b6(e_);
            }
        }
    };
    DOMEventProxy.prototype.c6 = function (e_) {
        var a = this.cr(e_);
        if (a) {
            this.bt--;
            if (this.bt < 0) {
                this.bt = 0;
            }
        }
        if (this.bt < 2 && this.cq && a) {
            this.cq = false;
            var b = (e_.originalEvent.scale);
            this.au(this.cm, b);
        }
    };
    DOMEventProxy.prototype.c7 = function (e_) {
        var a = this.cr(e_);
        if (a) {
            this.bt--;
            if (this.bt < 0) {
                this.bt = 0;
            }
        }
        if (this.bt < 2 && this.cq && a) {
            this.cq = false;
            var b = (e_.originalEvent.scale);
            this.au(this.cm, b);
        }
    };
    DOMEventProxy.prototype.c8 = function (e_) {
        var a = this.cr(e_);
        if (this.cx != null && a) {
            this.bt++;
            this.cx.addPointer((e_.originalEvent.pointerId));
        }
        var eventSource_ = this.bp.getNativeElement();
        if (BaseDOMEventProxy.bi) {
            eventSource_.setPointerCapture(e_.originalEvent.pointerId);
        }
        else {
            eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
        }
        if (this.bt > 1 && !this.cq && a) {
            this.cq = true;
            this.ci(e_);
            var b = (e_.originalEvent.scale);
            this.a2(this.cm, b);
        }
        else {
            if (a) {
                this.de(e_);
            }
            else {
                this.b2(e_);
            }
        }
    };
    DOMEventProxy.prototype.cr = function (e_) {
        var pointerEvent_ = e_.originalEvent;
        var a = false;
        if (BaseDOMEventProxy.bi) {
            a = (pointerEvent_.pointerType == 'touch');
        }
        else {
            a = (pointerEvent_.pointerType == pointerEvent_.MSPOINTER_TYPE_TOUCH);
        }
        return a;
    };
    DOMEventProxy.prototype.c9 = function (e_) {
        var a = this.cr(e_);
        if (this.cq) {
            return;
        }
        if (a) {
            this.dd(e_);
        }
        else {
            this.b4(e_);
        }
    };
    DOMEventProxy.prototype.da = function (e_) {
        var a = this.cr(e_);
        if (this.cq) {
            return;
        }
        if (a) {
        }
        else {
            this.b3(e_);
        }
    };
    DOMEventProxy.prototype.c5 = function (e_) {
        this.bg = true;
        this.cg(e_);
        this.ci(e_);
        this.dg();
        if (this.ah(this.cn)) {
            this.ce(e_);
            if ((BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) && this.bt < 2) {
                return;
            }
            var a = (e_.originalEvent.scale);
            this.a2(this.cm, a);
        }
    };
    DOMEventProxy.prototype.c3 = function (e_) {
        this.bg = true;
        this.cg(e_);
        this.ci(e_);
        if (this.ah(this.cn)) {
            this.ce(e_);
            if ((BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) && this.bt < 2) {
                return;
            }
            var a = (e_.originalEvent.scale);
            this.a1(this.cm, a);
        }
    };
    DOMEventProxy.prototype.c4 = function (e_) {
        this.ce(e_);
        var a = (e_.originalEvent.scale);
        this.bg = false;
        this.cg(e_);
        this.ci(e_);
        if ((!BaseDOMEventProxy.bh && !BaseDOMEventProxy.bi) || this.cq) {
            this.au(this.cm, a);
        }
    };
    DOMEventProxy.prototype.de = function (e_) {
        this.bg = true;
        this.cg(e_);
        this.ci(e_);
        this.dn = this.cm;
        if (this.ah(this.cn)) {
            if (!this.z) {
                this.ce(e_);
            }
            else {
                this.bj = true;
            }
            this.az(this.cn, false, true);
            this.aw(this.cn);
            this.ap(this.cm, true);
            this.dj();
        }
    };
    DOMEventProxy.prototype.dj = function () {
        if (this.cy == -1) {
            this.cv = this.cn.x;
            this.cw = this.cn.y;
            this.cy = this.bo.setTimeout(runOn(this, this.dh), 1500);
        }
    };
    DOMEventProxy.prototype.dg = function () {
        if (Math.abs(this.cv - this.cn.x) > this.cu || Math.abs(this.cw - this.cn.y) > this.cu) {
            this.dk();
        }
    };
    DOMEventProxy.prototype.dk = function () {
        if (this.cy != -1) {
            window.clearTimeout(this.cy);
            this.cy = -1;
        }
    };
    DOMEventProxy.prototype.dh = function () {
        this.cy = -1;
        if (this.bj) {
            this.bj = false;
            this.by();
        }
        this.av(this.cm);
    };
    DOMEventProxy.prototype.dd = function (a) {
        this.bg = true;
        this.cg(a);
        this.ci(a);
        if (this.bj) {
            if (this.ah(this.cn) && this.cs()) {
                this.bj = false;
                this.by();
            }
        }
        this.dg();
        this.dl();
        if (this.ah(this.cn) && this.bt == 1 && !this.bj) {
            this.ce(a);
            if (!this.cp) {
                this.cp = true;
                this.dm = this.cm;
                this.at(this.dm);
            }
            else {
                this.az(this.cn, true, true);
                this.ao(this.cm, true);
                this.as(this.cm);
            }
        }
    };
    DOMEventProxy.prototype.cs = function () {
        var a = { $type: Point_$type, x: this.dn.x - this.cm.x, y: this.dn.y - this.cm.y };
        if (Math.abs(a.x) < 2 && Math.abs(a.y) < 2) {
            return false;
        }
        if (Math.abs(a.x) > Math.abs(a.y)) {
            a.y = 0;
        }
        if (Math.abs(a.y) > Math.abs(a.x)) {
            a.x = 0;
        }
        return this.ai(a);
    };
    DOMEventProxy.prototype.dc = function (a) {
        this.bg = false;
        this.cg(a);
        this.ci(a);
        this.dk();
        if (this.bj) {
            this.bj = false;
            this.by();
        }
        this.ce(a);
        this.az(this.cn, false, true);
        this.a0(this.cn);
        if (this.bt == 0) {
            this.di(this.cn);
            this.cb();
        }
        if (this.cp && this.bt == 0) {
            this.cp = false;
            this.dm = null;
            this.ar(this.cm);
            this.cb();
        }
        this.an(this.cm, true);
    };
    DOMEventProxy.prototype.di = function (a) {
        if (Rect.l_op_Equality(this.dp, null)) {
            this.dp = new Rect(0, a.x - 50, a.y - 50, 100, 100);
            this.bo.setTimeout(runOn(this, this.dl), 500);
        }
        else {
            if (a.x >= this.dp.x && a.x <= this.dp.right && a.y >= this.dp.y && a.y <= this.dp.bottom) {
                this.dl();
                this.aq(a);
            }
        }
    };
    DOMEventProxy.prototype.dl = function () {
        this.dp = null;
    };
    DOMEventProxy.prototype.df = function (a) {
        if (this.ct.containsKey(a)) {
            var b = this.ct.item(a);
            this.ct.removeItem(a);
            for (var c = 0; c < b.count; c++) {
                b._inner[c]();
            }
            b.clear();
        }
    };
    DOMEventProxy.prototype.a6 = function (a, b) {
        var c = a;
        var d = this.c1 + b;
        this.df(d);
    };
    DOMEventProxy.prototype.al = function () {
        if (this.bp == null) {
            return;
        }
        this.df(this.c1);
        this.bp = null;
    };
    DOMEventProxy.cz = 0;
    DOMEventProxy.$t = markType(DOMEventProxy, 'DOMEventProxy', BaseDOMEventProxy.$);
    return DOMEventProxy;
}(BaseDOMEventProxy));
export { DOMEventProxy };
/*<BeginStatics Name="Infragistics.Controls.BaseDOMEventProxy" />*/
/*<EndStatics Name="Infragistics.Controls.BaseDOMEventProxy" />*/
/*<BeginStatics Name="Infragistics.Controls.DOMEventProxy" />*/
/*<EndStatics Name="Infragistics.Controls.DOMEventProxy" />*/
//# sourceMappingURL=BaseDOMEventProxy_combined.js.map