import { XYChart } from "./XYChart";
import { CategoryChartType } from "./CategoryChartType";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { BrushCollection } from "./BrushCollection";
import { List$1 } from "./List$1";
import { DataSeriesType } from "./DataSeriesType";
import { IDataSeriesAdapterRule } from "./IDataSeriesAdapterRule";
import { Series } from "./Series";
import { XamDataChart } from "./XamDataChart";
import { Type } from "./type";
import { Axis } from "./Axis";
import { DataSeries } from "./DataSeries";
export declare class CategoryChart extends XYChart {
    protected e1(): void;
    protected e3(a: Series, b: number): void;
    protected fj(a: string, b: any, c: any): void;
    private od;
    of: number;
    private nf;
    ng: (time: number) => number;
    protected ew(a: XamDataChart): void;
    protected e2(a: Series, b: number): void;
    private m6();
    private nb();
    protected em(): void;
    protected lf(a: Axis): void;
    private m0;
    m1: CategoryChartType;
    private m2;
    m3: CategorySeriesMarkerCollisionAvoidance;
    private ni;
    nm: boolean;
    private m4;
    m5: CategoryTransitionInMode;
    private nd;
    ne: TransitionInSpeedType;
    private nq;
    n4: number;
    private nr;
    n5: number;
    private np;
    n3: number;
    private ns;
    n6: number;
    private nt;
    n9: number;
    private nk;
    no: boolean;
    private oe;
    og: number;
    private nv;
    ob: number;
    private nu;
    oa: number;
    private nw;
    oc: number;
    readonly n2: number;
    readonly n1: number;
    readonly n8: number;
    readonly n7: number;
    private mw;
    my: BrushCollection;
    private mx;
    mz: BrushCollection;
    private nh;
    nl: boolean;
    private nj;
    nn: boolean;
    constructor();
    protected get_ba(): List$1<DataSeriesType>;
    protected readonly ba: List$1<DataSeriesType>;
    private o4(a, b);
    private o5(a, b);
    protected fy(): void;
    private _xAxis;
    private xAxis;
    private _yAxis;
    private yAxis;
    private m8(seriesType_);
    private na(a, b);
    private m9(a);
    nx(a: number): number;
    nz(a: number): number;
    ny(a: number): number;
    n0(a: number): number;
    protected r(a: DataSeries): DataSeriesType;
    protected ag(a: DataSeries, b: DataSeriesType): Series;
    protected fw(a: DataSeries): void;
    protected fz(): void;
    protected f1(a: Series): void;
    protected get_a9(): List$1<IDataSeriesAdapterRule>;
    protected readonly a9: List$1<IDataSeriesAdapterRule>;
    protected ek(a: Series, b: number): void;
    private o2(a);
    private o3(a);
    protected gj(): Axis;
    protected gk(): Axis;
    protected fi(a: string, b: any, c: any): void;
    static $t: Type;
}
