import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ConsolidatedItemsPosition } from "./ConsolidatedItemsPosition";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "./type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Rect } from "./Rect";
import { CategoryFrame } from "./CategoryFrame";
import { Pool$1 } from "./Pool$1";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "./List$1";
import { Rectangle } from "./Rectangle";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { RenderingContext } from "./RenderingContext";
export declare class ColumnSeries extends HorizontalAnchoredCategorySeries {
    protected be(): SeriesView;
    pw: ColumnSeriesView;
    h9(a: SeriesView): void;
    protected mv(): CategoryTransitionInMode;
    constructor();
    p0: number;
    p1: number;
    protected get_na(): boolean;
    protected readonly na: boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private p2;
    k9(a: Point): Rect;
    dd(a: Point, b: boolean): boolean;
    he(a: boolean, b: SeriesView): void;
    d7(): number;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    private px;
    py: ConsolidatedItemsPosition;
    private pz(a);
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class ColumnSeriesView extends AnchoredCategorySeriesView {
    ap(): void;
    protected c4: ColumnSeries;
    constructor(a: ColumnSeries);
    dc(): Rectangle;
    protected c6: List$1<Rectangle>;
    c7(a: Rectangle): void;
    c9(a: Rectangle): void;
    c8(a: Rectangle): void;
    da(a: Rectangle, b: number, c: number): void;
    protected z(a: number): any;
    private db;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    c5: Pool$1<Rectangle>;
    ai(a: any): void;
    static $t: Type;
}
