import { IFinancialPriceSeriesProxy } from "./IFinancialPriceSeriesProxy";
import { Series } from "./Series";
import { Type, Base } from "./type";
import { CategoryMode } from "./CategoryMode";
import { PriceDisplayType } from "./PriceDisplayType";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
export declare class FinancialPriceSeriesProxy extends Base implements IFinancialPriceSeriesProxy {
    getCloseMemberPath(a: Series): string;
    getHighMemberPath(a: Series): string;
    getLowMemberPath(a: Series): string;
    getOpenMemberPath(a: Series): string;
    getVolumeMemberPath(a: Series): string;
    matchesType(a: Series): boolean;
    setCategoryMode(a: Series, b: CategoryMode): void;
    setCloseMemberPath(a: Series, b: string): void;
    setDisplayType(a: Series, b: PriceDisplayType): void;
    setHighMemberPath(a: Series, b: string): void;
    setLowMemberPath(a: Series, b: string): void;
    setOpenMemberPath(a: Series, b: string): void;
    setVolumeMemberPath(a: Series, b: string): void;
    setXAxis(a: Series, b: CategoryAxisBase): void;
    setYAxis(a: Series, b: NumericYAxis): void;
    static $t: Type;
}
