import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "./type";
import { DependencyProperty } from "./DependencyProperty";
export declare class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor();
    protected get_pp(): IndicatorCalculationStrategy;
    protected readonly pp: IndicatorCalculationStrategy;
    protected get_p2(): Type;
    protected readonly p2: Type;
    qa: number;
    static readonly qf: DependencyProperty;
    protected pv(): number;
    p4(a: number): void;
    smoothingPeriod: number;
    static readonly qg: DependencyProperty;
    protected px(): number;
    qc: number;
    static readonly qh: DependencyProperty;
    protected pu(): number;
    protected o5(): number;
    static $t: Type;
}
