/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "./DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Type, Point_$type, runOn, typeCast, markType } from "./type";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "./PropertyMetadata";
var HorizontalRangeCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(HorizontalRangeCategorySeries, _super);
    function HorizontalRangeCategorySeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalRangeCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    HorizontalRangeCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    HorizontalRangeCategorySeries.prototype.hc = function () {
        _super.prototype.hc.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalRangeCategorySeries.prototype.ag = function (a) {
        var b = this.ai(this.ml(), this.mm.f, this.nm(this.bh), this.nn(this.bh), this.k3(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.ah = function (a) {
        var b = this.ai(this.ml(), this.mm.f, this.nm(this.bh), this.nn(this.bh), this.k3(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.get_c1 = function () {
        return true;
    };
    Object.defineProperty(HorizontalRangeCategorySeries.prototype, "c1", {
        get: function () {
            return this.get_c1();
        },
        enumerable: true,
        configurable: true
    });
    HorizontalRangeCategorySeries.prototype.bc = function () {
        if (this.bd == 0) {
            return 1;
        }
        else {
            return _super.prototype.bc.call(this);
        }
    };
    HorizontalRangeCategorySeries.prototype.getOffsetValue = function () {
        return this.RangeFramePreparer.r(this.xAxis, this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    };
    HorizontalRangeCategorySeries.prototype.getCategoryWidth = function () {
        return this.xAxis.getCategorySize(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    };
    HorizontalRangeCategorySeries.prototype.e1 = function (a, b) {
        return this.e2(a, b, this.xAxis, runOn(this, this.nk), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.e3 = function (a, b) {
        return this.e4(a, b, this.xAxis, runOn(this, this.nk), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.d0 = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.xAxis.ja;
        return this.d1(a, b, this.xAxis, d, e, f, runOn(this, this.nk));
    };
    HorizontalRangeCategorySeries.prototype.ed = function (a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bh);
        var e = new ScalerParams(0, this.br.mk, this.bh.bp, this.xAxis.bz, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.br.mk, this.bh.bp, d);
        return this.ef(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.nk), b, c);
    };
    HorizontalRangeCategorySeries.prototype.eb = function (a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bh);
        var e = new ScalerParams(0, this.br.mk, this.bh.bp, this.xAxis.bz, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.br.mk, this.bh.bp, d);
        return this.ef(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.nk), b, c);
    };
    HorizontalRangeCategorySeries.prototype.d9 = function (a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bh);
        var e = new ScalerParams(0, this.br.mk, this.bh.bp, this.xAxis.bz, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.br.mk, this.bh.bp, d);
        return this.ef(this.highColumn, a, this.xAxis, e, f, runOn(this, this.nk), b, c);
    };
    HorizontalRangeCategorySeries.prototype.kw = function (a, b, c) {
        var _this = this;
        return this.k2(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.yAxis, this.xAxis, runOn(this, this.d9), function (d, e) { return _this.e4(d, e, _this.xAxis, runOn(_this, _this.nk), _this.highColumn); }, function (d, e) { return _this.e2(d, e, _this.xAxis, runOn(_this, _this.nk), _this.highColumn); });
    };
    HorizontalRangeCategorySeries.prototype.ky = function (a, b, c) {
        var _this = this;
        return this.k2(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.yAxis, this.xAxis, runOn(this, this.eb), function (d, e) { return _this.e4(d, e, _this.xAxis, runOn(_this, _this.nk), _this.lowColumn); }, function (d, e) { return _this.e2(d, e, _this.xAxis, runOn(_this, _this.nk), _this.lowColumn); });
    };
    HorizontalRangeCategorySeries.prototype.k0 = function (a, b, c) {
        return this.k2(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.yAxis, this.xAxis, null, null, null);
    };
    HorizontalRangeCategorySeries.prototype.ng = function () {
        return this.yAxis != null && this.yAxis.cb();
    };
    HorizontalRangeCategorySeries.prototype.ie = function (a, b, c, d) {
        _super.prototype.ie.call(this, a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.hi(typeCast(Axis.$, c));
                this.ik(typeCast(Axis.$, d));
                this.mu.cl.g(this.ej);
                this.it(false);
                this.h1();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.hi(typeCast(Axis.$, c));
                this.ik(typeCast(Axis.$, d));
                this.mu.cl.g(this.ej);
                this.ng();
                this.it(false);
                this.h1();
                break;
        }
    };
    HorizontalRangeCategorySeries.prototype.ou = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HorizontalRangeCategorySeries.prototype.ot = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.bw) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalRangeCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
    return HorizontalRangeCategorySeries;
}(RangeCategorySeries));
export { HorizontalRangeCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::ox', [CategoryAxisBase.$, null], 'YAxis::oy', [NumericYAxis.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
//# sourceMappingURL=HorizontalRangeCategorySeries.js.map