import { IScaler } from "./IScaler";
import { CategoryMode } from "./CategoryMode";
import { Rect } from "./Rect";
import { Type } from "./type";
export interface ICategoryScaler extends IScaler {
    readonly categoryMode: CategoryMode;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    readonly isVertical: boolean;
    getOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
}
export declare let ICategoryScaler_$type: Type;
