import { FinancialOverlay } from "./FinancialOverlay";
import { List$1 } from "./List$1";
import { Type, Point } from "./type";
import { CategoryFrame } from "./CategoryFrame";
import { Rect } from "./Rect";
import { SeriesView } from "./SeriesView";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "./Polyline";
import { Polygon } from "./Polygon";
import { RenderingContext } from "./RenderingContext";
export declare class PriceChannelOverlay extends FinancialOverlay {
    constructor();
    o3: number;
    protected ie(a: any, b: string, c: any, d: any): void;
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    protected ow(): boolean;
    ob(a: CategoryFrame, b: FinancialSeriesView): void;
    he(a: boolean, b: SeriesView): void;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    o2: List$1<number>;
    o1: List$1<number>;
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    private o0;
    ed(a: Point, b: boolean, c: boolean): number;
    e1(a: Point, b: boolean): number;
    e3(a: Point, b: boolean): number;
    d8(): number;
    static $$p: string[];
    static $t: Type;
}
export declare class PriceChannelBucketCalculator extends FinancialBucketCalculator {
    constructor(a: FinancialSeriesView);
    protected f: PriceChannelOverlayView;
    getBucket(a: number): number[];
    static $t: Type;
}
export declare class PriceChannelOverlayView extends FinancialSeriesView {
    private b3;
    private b8;
    private b9;
    readonly b2: Polygon;
    readonly b6: Polyline;
    readonly b7: Polyline;
    by: PriceChannelOverlay;
    constructor(a: PriceChannelOverlay);
    ap(): void;
    protected bt(): FinancialBucketCalculator;
    bz(): void;
    b0(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: (arg1: number) => number, e: (arg1: number) => number): void;
    private b1;
    private b4;
    private b5;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
