/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { SplineType_$type } from "./SplineType";
import { DependencyProperty } from "./DependencyProperty";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { CollisionAvoider } from "./CollisionAvoider";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Type, typeCast, Point_$type, enumGetBox, markType } from "./type";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { Numeric } from "./Numeric";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_ } from "./number";
import { Color } from "./Color";
var SplineSeriesBase = /** @class */ (function (_super) {
    tslib_1.__extends(SplineSeriesBase, _super);
    function SplineSeriesBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.pw = null;
        return _this;
    }
    SplineSeriesBase.prototype.be = function () {
        return new SplineSeriesBaseView(this);
    };
    SplineSeriesBase.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        this.px = a;
    };
    SplineSeriesBase.prototype.get_ci = function () {
        return true;
    };
    Object.defineProperty(SplineSeriesBase.prototype, "ci", {
        get: function () {
            return this.get_ci();
        },
        enumerable: true,
        configurable: true
    });
    SplineSeriesBase.prototype.p3 = function (a, b, c, d, e, f) {
        var _this = this;
        var g = typeCast(ISortingAxis_$type, d);
        var h = this.getEffectiveViewport1(f);
        if (g == null) {
            return;
        }
        var i = new ScalerParams(0, b, c, d.bz, h);
        var j = new ScalerParams(0, b, c, e.bz, h);
        var k = this.li();
        var l = 0;
        var m = this.p1(d, b, c, h);
        var n = function (o) { return o; };
        var o = function (p) { return _this.valueColumn.item(g.i$b._inner[p]); };
        var p = this.mu.cl.f;
        var q = this.mu.cl.e;
        var r = truncate(Math.ceil(c.width / (p - q)));
        var s = new CollisionAvoider();
        var t = this.mu.cl.d;
        if (t <= 0 || (q <= 0 && p <= 0)) {
            this.mu.co.count = l;
            return;
        }
        var u = 0;
        var v = 0;
        for (var w = q; w < p + 1; ++w) {
            var x = null;
            var y = w * t;
            if (g != null && g.i$b != null && y >= 0 && y < g.i$b.count) {
                y = g.i$b._inner[y];
            }
            if (w >= (this.valueColumn.count - 1)) {
                if (k && this.pz(a, a.f._inner[a.f.count - 1], s, Math.min(y, this.by.count - 1), l, f, u - 1)) {
                    ++l;
                }
                break;
            }
            var z = n(w);
            var aa = o(w);
            var ab = n(w + 1);
            var ac = o(w + 1);
            var ad = ab - z;
            var ae = this.pw[w];
            var af = this.pw[w + 1];
            var ag = g.i$d(g.i$b._inner[w]);
            var ah = d.dj(ag, i) + m;
            var ai = e.dj(aa, j);
            a.f.add([ah, ai, ai]);
            u++;
            v = u;
            for (var aj = 1; aj < r; ++aj) {
                var ak = aj / r;
                var al = z + ad * ak;
                var am = (ab - al) / ad;
                var an = (al - z) / ad;
                var ao = am * aa + an * ac + ((am * am * am - am) * ae + (an * an * an - an) * af) * (ad * ad) / 6;
                var ap = g.i$d(g.i$b._inner[w]);
                var aq = g.i$d(g.i$b._inner[w + 1]);
                var ar = ap + (aq - ap) * ak;
                al = d.dj(ar, i) + m;
                ao = e.dj(ao, j);
                a.f.add([al, ao, ao]);
                u++;
            }
            if (k) {
                x = [ah, ai, ai];
            }
            if (k && this.pz(a, x, s, Math.min(y, this.by.count - 1), l, f, v - 1)) {
                ++l;
            }
        }
        f.co.count = l;
    };
    SplineSeriesBase.prototype.pz = function (a, b, c, d, e, f, g) {
        var h = b[0];
        var i = b[1];
        var j = new Rect(0, h - 5, i - 5, 11, 11);
        if (!isNaN_(h) && !isNaN_(i) && c.tryAdd(j)) {
            a.m.add({ $type: Point_$type, x: h, y: i });
            var k = f.co.item(e);
            k.content.item = this.by.item(d);
            k.al = g;
            return true;
        }
        return false;
    };
    SplineSeriesBase.prototype.ai = function (a, b, c, d, e, f) {
        if (a == null || a.b3 || this.nm(this.bh) > 1 || this.nm(this.bh) == 0) {
            return _super.prototype.ai.call(this, this.ml(), this.mm.f, this.nm(this.bh), this.nn(this.bh), e, f);
        }
        var g = this.px.cl.f;
        var h = this.bh.bp;
        var i = truncate(Math.ceil(h.width / (g - d)));
        var j = -1;
        var k = -1;
        var l = this.d2(e);
        var m = this.e3(e, f);
        var n = this.e1(e, f);
        var o = truncate(Math.floor(m / this.nm(this.bh)));
        var p = truncate(Math.floor(n / this.nm(this.bh)));
        j = o - this.nn(this.bh);
        k = p - this.nn(this.bh);
        var q = j * i;
        var r = k * i;
        var s = 0;
        if (m != n) {
            s = (l - m) / (n - m);
        }
        var t = truncate(Math.floor(q + s * (r - q)));
        j = t;
        k = t + 1;
        if (j < 0) {
            j = 0;
        }
        if (j > this.mm.f.count - 1) {
            j = this.mm.f.count - 1;
        }
        if (k < 0) {
            k = 0;
        }
        if (k > this.mm.f.count - 1) {
            k = this.mm.f.count - 1;
        }
        var u = this.mm.f._inner[j];
        var v = this.mm.f._inner[k];
        var w = new Array(2);
        w[0] = u;
        w[1] = v;
        return w;
    };
    SplineSeriesBase.prototype.nz = function (a, b) {
        var _this = this;
        _super.prototype.nz.call(this, a, b);
        if (a.f.count <= 1) {
            return;
        }
        if (b.cl.d == 0) {
            return;
        }
        var c = b.bq;
        var d = b.bp;
        var e = this.getEffectiveViewport1(b);
        var f = this.pd;
        var g = this.pj;
        var h = new ScalerParams(0, c, d, f.bz, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, g.bz, e);
            $ret.b = _this.d8();
            return $ret;
        })());
        a.f.clear();
        a.m.clear();
        var j = this.li();
        var k = 0;
        var l = typeCast(ISortingAxis_$type, this.pd);
        if (l != null && l.i$b.count != this.by.count) {
            return;
        }
        var m = this.p1(f, c, d, e);
        var n = function (o) { return o; };
        var o = function (p) { return _this.valueColumn.item(p); };
        var p = b.cl.d;
        if ((this.pw == null || this.pw.length != this.valueColumn.count) && p == 1) {
            var q = this.py == 0 ? NaN : 0;
            if (this.pd != null && typeCast(ISortingAxis_$type, this.pd) !== null && this.pd.i$b != null) {
                var r_1 = new SafeSortedReadOnlyDoubleCollection(1, this.valueColumn, this.pd.i$b, NaN);
                o = function (s) { return r_1.item(s); };
            }
            this.pw = Numeric.c(this.valueColumn.count, n, o, q, q);
        }
        var s = b.cl.f;
        var t = b.cl.e;
        var u = truncate(Math.ceil(d.width / (s - t)));
        var v = new CollisionAvoider();
        if (l != null) {
            this.p3(a, c, d, f, g, b);
            return;
        }
        var w = b;
        w.c0();
        var x = 0;
        var y = 0;
        for (var z = t; z <= s; ++z) {
            var aa = null;
            if (p == 1) {
                if (z >= (this.valueColumn.count - 1)) {
                    if (j && this.pz(a, a.f._inner[a.f.count - 1], v, Math.min(z * p, this.by.count - 1), k, b, x - 1)) {
                        ++k;
                    }
                    break;
                }
                var ab = n(z);
                var ac = o(z);
                var ad = n(z + 1);
                var ae = o(z + 1);
                var af = ad - ab;
                var ag = this.pw[z];
                var ah = this.pw[z + 1];
                var ai = f.dj(ab, h) + m;
                var aj = g.dj(ac, i);
                a.f.add([ai, aj, aj]);
                x++;
                y = x;
                for (var ak = 1; ak < u; ++ak) {
                    var al = ab + af * ak / u;
                    var am = (ad - al) / af;
                    var an = (al - ab) / af;
                    var ao = am * ac + an * ae + ((am * am * am - am) * ag + (an * an * an - an) * ah) * (af * af) / 6;
                    al = f.dj(al, h) + m;
                    ao = g.dj(ao, i);
                    a.f.add([al, ao, ao]);
                    x++;
                }
                if (j) {
                    aa = b.cl.getBucket(z);
                    aa[0] = (f.dj(aa[0], h) + m);
                    aa[1] = g.dj(aa[1], i);
                    aa[2] = g.dj(aa[2], i);
                }
            }
            else {
                aa = b.cl.getBucket(z);
                if (!isNaN_(aa[0])) {
                    aa[0] = (f.dj(aa[0], h) + m);
                    aa[1] = g.dj(aa[1], i);
                    aa[2] = g.dj(aa[2], i);
                    a.f.add(aa);
                    x++;
                }
            }
            if (j && this.pz(a, aa, v, Math.min(z * p, this.by.count - 1), k, b, y - 1)) {
                ++k;
            }
        }
        w.c2();
        b.co.count = k;
    };
    SplineSeriesBase.prototype.p0 = function (a, b, c, d, e, f, g) {
        var h = d - b;
        var i = b + h * a;
        var j = (d - i) / h;
        var k = (i - b) / h;
        var l = j * c + k * e + ((j * j * j - j) * f + (k * k * k - k) * g) * (h * h) / 6;
        return l;
    };
    SplineSeriesBase.prototype.d6 = function (a, b, c, d, e, f, g, h) {
        var i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        var j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        var k = e;
        var l = f;
        var m = i;
        var n = j;
        var o = NaN;
        var p = NaN;
        if (this.pw != null && e >= 0 && e < this.pw.length) {
            o = this.pw[e];
        }
        if (this.pw != null && f >= 0 && f < this.pw.length) {
            p = this.pw[f];
        }
        return this.p0(a, k, m, l, n, o, p);
    };
    SplineSeriesBase.prototype.p1 = function (a, b, c, d) {
        var e = this.preferredCategoryMode(a);
        if (e == 0 && a.categoryMode != 0) {
            e = 1;
        }
        var f = 0;
        switch (e) {
            case 0:
                f = 0;
                break;
            case 1:
                f = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                f = a.getGroupCenter(this.e6, b, c, d);
                break;
        }
        if (a.bz) {
            f = -f;
        }
        return f;
    };
    SplineSeriesBase.prototype.p4 = function () {
        this.pw = null;
    };
    SplineSeriesBase.prototype.ie = function (a, b, c, d) {
        switch (b) {
            case "ValueColumn":
            case "FastItemsSource":
                this.p4();
                break;
        }
        _super.prototype.ie.call(this, a, b, c, d);
        switch (b) {
            case SplineSeriesBase.$$p[0]:
                this.p4();
                this.it(false);
                this.h1();
                break;
        }
    };
    SplineSeriesBase.prototype.hh = function (a, b, c, d) {
        this.p4();
        _super.prototype.hh.call(this, a, b, c, d);
    };
    Object.defineProperty(SplineSeriesBase.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    SplineSeriesBase.$t = markType(SplineSeriesBase, 'SplineSeriesBase', HorizontalAnchoredCategorySeries.$);
    return SplineSeriesBase;
}(HorizontalAnchoredCategorySeries));
export { SplineSeriesBase };
Type.dep(DependencyProperty, PropertyMetadata, SplineSeriesBase, 'raisePropertyChanged', ['SplineType:py:p5', [SplineType_$type, enumGetBox(SplineType_$type, 0)]]);
var SplineSeriesBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(SplineSeriesBaseView, _super);
    function SplineSeriesBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.c4 = null;
        _this.c4 = a;
        return _this;
    }
    SplineSeriesBaseView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kp = a;
        this.e.ek = 3;
        this.e.el = 1;
        this.e.em = 4;
        this.e.dq = false;
    };
    SplineSeriesBaseView.$t = markType(SplineSeriesBaseView, 'SplineSeriesBaseView', AnchoredCategorySeriesView.$);
    return SplineSeriesBaseView;
}(AnchoredCategorySeriesView));
export { SplineSeriesBaseView };
/*<BeginStatics Name="Infragistics.Controls.Charts.SplineSeriesBase" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.SplineSeriesBase" />*/
//# sourceMappingURL=SplineSeriesBase_combined.js.map