/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { typeCast, Array_$type, runOn, markType } from "./type";
import { ISortingAxis_$type } from "./ISortingAxis";
import { List$1 } from "./List$1";
import { Path } from "./Path";
import { ScalerParams } from "./ScalerParams";
import { intDivide, isNaN_ } from "./number";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Color } from "./Color";
var StepLineSeries = /** @class */ (function (_super) {
    tslib_1.__extends(StepLineSeries, _super);
    function StepLineSeries() {
        var _this = _super.call(this) || this;
        _this.pw = null;
        _this.pw = new CategoryLineRasterizer();
        _this.ab = StepLineSeries.$;
        return _this;
    }
    StepLineSeries.prototype.be = function () {
        return new StepLineSeriesView(this);
    };
    StepLineSeries.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        this.px = a;
    };
    StepLineSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
    };
    StepLineSeries.prototype.preferredCategoryMode = function (a) {
        return typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
    };
    StepLineSeries.prototype.get_ci = function () {
        return true;
    };
    Object.defineProperty(StepLineSeries.prototype, "ci", {
        get: function () {
            return this.get_ci();
        },
        enumerable: true,
        configurable: true
    });
    StepLineSeries.prototype.he = function (a, b) {
        _super.prototype.he.call(this, a, b);
        var c = b;
        c.c5();
    };
    StepLineSeries.prototype.bc = function () {
        if (this.bd == 0) {
            return 2;
        }
        else {
            return _super.prototype.bc.call(this);
        }
    };
    StepLineSeries.prototype.d6 = function (a, b, c, d, e, f, g, h) {
        var i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        var j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        if (a > 0.5) {
            return j;
        }
        return i;
    };
    StepLineSeries.prototype.py = function (a, b, c, d, e, f) {
        var g;
        if (b) {
            if (f) {
                g = (a & 1) == 0;
                if (g || (intDivide(a, 2)) + 1 < 0) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                if (c.f.count == (intDivide(a, 2)) + 1) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                return c.f._inner[(intDivide(a, 2)) + 1][0];
            }
            g = (a & 1) == 0;
            return c.f._inner[(intDivide(a, 2))][0] + (g ? d : -d);
        }
        if (f) {
            g = (a & 1) == 0;
            if (g || ((intDivide(a, 2)) + 1) >= c.f.count) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            if (c.f.count == (intDivide(a, 2)) + 1) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            return c.f._inner[(intDivide(a, 2)) + 1][0];
        }
        g = (a & 1) == 0;
        return c.f._inner[(intDivide(a, 2))][0] + (g ? -d : d);
    };
    StepLineSeries.prototype.n2 = function (a, b) {
        _super.prototype.n2.call(this, a, b);
        var c = b.bq;
        var d = b.bp;
        var e = this.getEffectiveViewport1(b);
        var f = typeCast(ISortingAxis_$type, this.pd) != null;
        var g = this.pd.bz;
        var h = 0;
        if (this.pd != null) {
            h = 0.5 * this.pd.getCategorySize(c, d, e);
        }
        var i = a.f;
        var j = 2 * i.count;
        var k = new List$1(Array_$type, 2, j);
        if (!this.pd.bz) {
            for (var l = 0; l < j; l++) {
                var m = new Array(4);
                m[0] = this.py(l, false, a, h, g, f);
                m[1] = a.f._inner[(intDivide(l, 2))][1];
                m[2] = this.py(l, true, a, h, g, f);
                m[3] = a.f._inner[(intDivide(l, 2))][2];
                k.add(m);
            }
        }
        else {
            for (var n = 0; n < j; n++) {
                var o = new Array(4);
                o[0] = this.py(n, true, a, h, g, f);
                o[1] = a.f._inner[(intDivide(n, 2))][1];
                o[2] = this.py(n, true, a, h, g, f);
                o[3] = a.f._inner[(intDivide(n, 2))][2];
                k.add(o);
            }
        }
        var p = typeCast(StepLineSeriesView.$, b);
        var q = p.cl.d;
        this.mt.x(this, this.ne(), this.pd, runOn(this, this.mf), this.nm(b), this.nn(b));
        var r = false;
        var s = this.mt.c;
        if (s != null) {
            r = true;
        }
        if (r) {
            var t = new ScalerParams(0, b.bq, b.bp, this.pd.bz, e);
            this.ny(i, -1, this.valueColumn.count, this.pd, t, b.n);
        }
        var u = p.db;
        var v = p.dc;
        var w = p.da;
        this.mt.ae(u, true, false, true, false);
        this.mt.ae(v, true, false, true, false);
        this.mt.ae(w, false, true, false, false);
        w._opacity = 0.75 * this.mt.i;
        if (b.cp(a)) {
            p.c6(j, k, false, 1, this.oc(k, j - 1, b.bp, b.bq), q, this.ej);
            b.cs(a);
        }
    };
    Object.defineProperty(StepLineSeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(this.pd);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepLineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    StepLineSeries.$t = markType(StepLineSeries, 'StepLineSeries', HorizontalAnchoredCategorySeries.$, [IIsCategoryBased_$type]);
    return StepLineSeries;
}(HorizontalAnchoredCategorySeries));
export { StepLineSeries };
var StepLineSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(StepLineSeriesView, _super);
    function StepLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c4 = null;
        _this.de = new Path();
        _this.dd = new Path();
        _this.df = new Path();
        _this.c9 = new Path();
        _this.c8 = new Path();
        _this.c7 = new Path();
        _this.c4 = a;
        return _this;
    }
    Object.defineProperty(StepLineSeriesView.prototype, "db", {
        get: function () {
            return this.de;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepLineSeriesView.prototype, "dc", {
        get: function () {
            return this.df;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepLineSeriesView.prototype, "da", {
        get: function () {
            return this.dd;
        },
        enumerable: true,
        configurable: true
    });
    StepLineSeriesView.prototype.c5 = function () {
        this.dd.aj = null;
        this.de.aj = null;
        this.df.aj = null;
        this.an();
    };
    StepLineSeriesView.prototype.c6 = function (a, b, c, d, e, f, g) {
        this.c4.pw.a = typeCast(ISortingAxis_$type, this.cn.fetchXAxis()) !== null ? true : false;
        this.c4.pw.m(this.de, this.dd, this.df, a, b, c, d, e, f, g);
        this.an();
    };
    StepLineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.c8.aj = this.de.aj;
        this.c9.aj = this.df.aj;
        this.c7.aj = this.dd.aj;
        var a = this.bk();
        this.c8._stroke = a;
        this.c8.ac = this.e.en + 3;
        this.c9._stroke = a;
        this.c9.ac = this.e.en + 3;
        this.c7._fill = a;
        this.c7._opacity = 1;
    };
    StepLineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.c7);
                a.s(this.c8);
                a.s(this.c9);
            }
            else {
                a.s(this.dd);
                a.s(this.de);
                a.s(this.df);
            }
        }
    };
    StepLineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a1.exportPathData(a, this.de, "lowerShape", ["Lower", "Main"]);
        this.e.a1.exportPathData(a, this.df, "upperShape", ["Upper"]);
        this.e.a1.exportPathData(a, this.dd, "translucentShape", ["Translucent"]);
    };
    StepLineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kp = a;
        this.e.ek = 3;
        this.e.el = 1;
        this.e.em = 4;
        this.e.dq = false;
    };
    StepLineSeriesView.$t = markType(StepLineSeriesView, 'StepLineSeriesView', AnchoredCategorySeriesView.$);
    return StepLineSeriesView;
}(AnchoredCategorySeriesView));
export { StepLineSeriesView };
//# sourceMappingURL=StepLineSeries_combined.js.map