import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialIndicatorComponent } from './igx-financial-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { AccumulationDistributionIndicator } from "./AccumulationDistributionIndicator";
/**
 * Represents a IgxDataChartComponent Accumulation/Distribution indicator series.
 * Default required members: Close, Low, High, Volume
*/
export var IgxAccumulationDistributionIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }];
var IgxAccumulationDistributionIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxAccumulationDistributionIndicatorComponent, _super);
    function IgxAccumulationDistributionIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxAccumulationDistributionIndicatorComponent.prototype.createImplementation = function () {
        return new AccumulationDistributionIndicator();
    };
    Object.defineProperty(IgxAccumulationDistributionIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxAccumulationDistributionIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-accumulation-distribution-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxAccumulationDistributionIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxAccumulationDistributionIndicatorComponent.ctorParameters = function () { return []; };
    return IgxAccumulationDistributionIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxAccumulationDistributionIndicatorComponent };
//# sourceMappingURL=igx-accumulation-distribution-indicator-component.js.map