/**
 * EventArgs class for property updated events.
*/
var /**
 * EventArgs class for property updated events.
*/
PropertyUpdatedEventArgs = /** @class */ (function () {
    function PropertyUpdatedEventArgs() {
    }
    Object.defineProperty(PropertyUpdatedEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    PropertyUpdatedEventArgs.prototype.onImplementationCreated = function () {
    };
    PropertyUpdatedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(PropertyUpdatedEventArgs.prototype, "propertyName", {
        /**
         * Name of the property being updated.
        */
        get: /**
             * Name of the property being updated.
            */
        function () {
            return this.i.propertyName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PropertyUpdatedEventArgs.prototype, "oldValue", {
        /**
         * Old or previous value of the property being updated.
        */
        get: /**
             * Old or previous value of the property being updated.
            */
        function () {
            return this.i.oldValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PropertyUpdatedEventArgs.prototype, "newValue", {
        /**
         * New or current value of the property being updated.
        */
        get: /**
             * New or current value of the property being updated.
            */
        function () {
            return this.i.newValue;
        },
        enumerable: true,
        configurable: true
    });
    return PropertyUpdatedEventArgs;
}());
/**
 * EventArgs class for property updated events.
*/
export { PropertyUpdatedEventArgs };
//# sourceMappingURL=igx-property-updated-event-args.js.map